/* Application.c generated by valac 0.56.3, the Vala compiler
 * generated from Application.vala, do not modify */

/*
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: 2020-2022 Louis Brauer <louis@brauer.family>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <locale.h>
#include <glib/gi18n-lib.h>

#define TUNER_APPLICATION_APP_VERSION "1.5.0"
#define TUNER_APPLICATION_APP_ID "com.github.louis77.tuner"
#define TUNER_APPLICATION_STAR_CHAR "★ "
#define TUNER_APPLICATION_UNSTAR_CHAR "☆ "
#define GETTEXT_PACKAGE "com.github.louis77.tuner"
#define LOCALEDIR "/usr/share/locale"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TUNER_TYPE_APPLICATION (tuner_application_get_type ())
#define TUNER_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_APPLICATION, TunerApplication))
#define TUNER_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_APPLICATION, TunerApplicationClass))
#define TUNER_IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_APPLICATION))
#define TUNER_IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_APPLICATION))
#define TUNER_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_APPLICATION, TunerApplicationClass))

typedef struct _TunerApplication TunerApplication;
typedef struct _TunerApplicationClass TunerApplicationClass;
typedef struct _TunerApplicationPrivate TunerApplicationPrivate;

#define TUNER_TYPE_WINDOW (tuner_window_get_type ())
#define TUNER_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_WINDOW, TunerWindow))
#define TUNER_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_WINDOW, TunerWindowClass))
#define TUNER_IS_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_WINDOW))
#define TUNER_IS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_WINDOW))
#define TUNER_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_WINDOW, TunerWindowClass))

typedef struct _TunerWindow TunerWindow;
typedef struct _TunerWindowClass TunerWindowClass;

#define TUNER_TYPE_PLAYER_CONTROLLER (tuner_player_controller_get_type ())
#define TUNER_PLAYER_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_PLAYER_CONTROLLER, TunerPlayerController))
#define TUNER_PLAYER_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_PLAYER_CONTROLLER, TunerPlayerControllerClass))
#define TUNER_IS_PLAYER_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_PLAYER_CONTROLLER))
#define TUNER_IS_PLAYER_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_PLAYER_CONTROLLER))
#define TUNER_PLAYER_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_PLAYER_CONTROLLER, TunerPlayerControllerClass))

typedef struct _TunerPlayerController TunerPlayerController;
typedef struct _TunerPlayerControllerClass TunerPlayerControllerClass;
enum  {
	TUNER_APPLICATION_0_PROPERTY,
	TUNER_APPLICATION_SETTINGS_PROPERTY,
	TUNER_APPLICATION_PLAYER_PROPERTY,
	TUNER_APPLICATION_CACHE_DIR_PROPERTY,
	TUNER_APPLICATION_DATA_DIR_PROPERTY,
	TUNER_APPLICATION_NUM_PROPERTIES
};
static GParamSpec* tuner_application_properties[TUNER_APPLICATION_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _TunerApplication {
	GtkApplication parent_instance;
	TunerApplicationPrivate * priv;
	TunerWindow* window;
};

struct _TunerApplicationClass {
	GtkApplicationClass parent_class;
};

struct _TunerApplicationPrivate {
	GSettings* _settings;
	TunerPlayerController* _player;
	gchar* _cache_dir;
	gchar* _data_dir;
};

static gint TunerApplication_private_offset;
static gpointer tuner_application_parent_class = NULL;
VALA_EXTERN TunerApplication* tuner_application__instance;
TunerApplication* tuner_application__instance = NULL;

VALA_EXTERN GType tuner_application_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerApplication, g_object_unref)
VALA_EXTERN GType tuner_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerWindow, g_object_unref)
VALA_EXTERN GType tuner_player_controller_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerPlayerController, g_object_unref)
static void tuner_application_on_resume_window (TunerApplication* self);
static void _tuner_application_on_resume_window_gsimple_action_activate_callback (GSimpleAction* action,
                                                                           GVariant* parameter,
                                                                           gpointer self);
VALA_EXTERN TunerApplication* tuner_application_new (void);
VALA_EXTERN TunerApplication* tuner_application_construct (GType object_type);
static void tuner_application_real_activate (GApplication* base);
VALA_EXTERN TunerPlayerController* tuner_application_get_player (TunerApplication* self);
VALA_EXTERN TunerWindow* tuner_window_new (TunerApplication* app,
                               TunerPlayerController* player);
VALA_EXTERN TunerWindow* tuner_window_construct (GType object_type,
                                     TunerApplication* app,
                                     TunerPlayerController* player);
VALA_EXTERN void tuner_dbus_initialize (void);
static void tuner_application_ensure_dir (TunerApplication* self,
                                   const gchar* path);
VALA_EXTERN GSettings* tuner_application_get_settings (TunerApplication* self);
static void tuner_application_set_settings (TunerApplication* self,
                                     GSettings* value);
static void tuner_application_set_player (TunerApplication* self,
                                   TunerPlayerController* value);
VALA_EXTERN const gchar* tuner_application_get_cache_dir (TunerApplication* self);
static void tuner_application_set_cache_dir (TunerApplication* self,
                                      const gchar* value);
VALA_EXTERN const gchar* tuner_application_get_data_dir (TunerApplication* self);
static void tuner_application_set_data_dir (TunerApplication* self,
                                     const gchar* value);
VALA_EXTERN TunerApplication* tuner_application_get_instance (void);
static GObject * tuner_application_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties);
VALA_EXTERN TunerPlayerController* tuner_player_controller_new (void);
VALA_EXTERN TunerPlayerController* tuner_player_controller_construct (GType object_type);
static void tuner_application_finalize (GObject * obj);
static GType tuner_application_get_type_once (void);
static void _vala_tuner_application_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_tuner_application_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static const GActionEntry TUNER_APPLICATION_ACTION_ENTRIES[1] = {{"resume-window", _tuner_application_on_resume_window_gsimple_action_activate_callback}};

static inline gpointer
tuner_application_get_instance_private (TunerApplication* self)
{
	return G_STRUCT_MEMBER_P (self, TunerApplication_private_offset);
}

static void
_tuner_application_on_resume_window_gsimple_action_activate_callback (GSimpleAction* action,
                                                                      GVariant* parameter,
                                                                      gpointer self)
{
#line 20 "../src/Application.vala"
	tuner_application_on_resume_window ((TunerApplication*) self);
#line 167 "Application.c"
}

TunerApplication*
tuner_application_construct (GType object_type)
{
	TunerApplication * self = NULL;
#line 25 "../src/Application.vala"
	self = (TunerApplication*) g_object_new (object_type, "application-id", TUNER_APPLICATION_APP_ID, "flags", G_APPLICATION_FLAGS_NONE, NULL);
#line 24 "../src/Application.vala"
	return self;
#line 178 "Application.c"
}

TunerApplication*
tuner_application_new (void)
{
#line 24 "../src/Application.vala"
	return tuner_application_construct (TUNER_TYPE_APPLICATION);
#line 186 "Application.c"
}

static void
tuner_application_real_activate (GApplication* base)
{
	TunerApplication * self;
	TunerWindow* _tmp0_;
#line 60 "../src/Application.vala"
	self = (TunerApplication*) base;
#line 61 "../src/Application.vala"
	_tmp0_ = self->window;
#line 61 "../src/Application.vala"
	if (_tmp0_ == NULL) {
#line 200 "Application.c"
		TunerPlayerController* _tmp1_;
		TunerWindow* _tmp2_;
		TunerWindow* _tmp3_;
#line 62 "../src/Application.vala"
		_tmp1_ = self->priv->_player;
#line 62 "../src/Application.vala"
		_tmp2_ = tuner_window_new (self, _tmp1_);
#line 62 "../src/Application.vala"
		g_object_ref_sink (_tmp2_);
#line 62 "../src/Application.vala"
		_g_object_unref0 (self->window);
#line 62 "../src/Application.vala"
		self->window = _tmp2_;
#line 63 "../src/Application.vala"
		_tmp3_ = self->window;
#line 63 "../src/Application.vala"
		gtk_application_add_window ((GtkApplication*) self, (GtkWindow*) _tmp3_);
#line 64 "../src/Application.vala"
		tuner_dbus_initialize ();
#line 220 "Application.c"
	} else {
		TunerWindow* _tmp4_;
#line 66 "../src/Application.vala"
		_tmp4_ = self->window;
#line 66 "../src/Application.vala"
		gtk_window_present ((GtkWindow*) _tmp4_);
#line 227 "Application.c"
	}
}

static void
tuner_application_on_resume_window (TunerApplication* self)
{
	TunerWindow* _tmp0_;
#line 71 "../src/Application.vala"
	g_return_if_fail (self != NULL);
#line 72 "../src/Application.vala"
	_tmp0_ = self->window;
#line 72 "../src/Application.vala"
	gtk_window_present ((GtkWindow*) _tmp0_);
#line 241 "Application.c"
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1578 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1579 "glib-2.0.vapi"
	result = self;
#line 1579 "glib-2.0.vapi"
	return result;
#line 254 "Application.c"
}

static void
tuner_application_ensure_dir (TunerApplication* self,
                              const gchar* path)
{
	GFile* dir = NULL;
	GFile* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 75 "../src/Application.vala"
	g_return_if_fail (self != NULL);
#line 75 "../src/Application.vala"
	g_return_if_fail (path != NULL);
#line 76 "../src/Application.vala"
	_tmp0_ = g_file_new_for_path (path);
#line 76 "../src/Application.vala"
	dir = _tmp0_;
#line 272 "Application.c"
	{
		const gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 79 "../src/Application.vala"
		_tmp1_ = string_to_string (path);
#line 79 "../src/Application.vala"
		_tmp2_ = g_strconcat ("Ensuring dir exists: ", _tmp1_, NULL);
#line 79 "../src/Application.vala"
		_tmp3_ = _tmp2_;
#line 79 "../src/Application.vala"
		g_debug ("Application.vala:79: %s", _tmp3_);
#line 79 "../src/Application.vala"
		_g_free0 (_tmp3_);
#line 80 "../src/Application.vala"
		g_file_make_directory (dir, NULL, &_inner_error0_);
#line 80 "../src/Application.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 291 "Application.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
#line 78 "../src/Application.vala"
		e = _inner_error0_;
#line 78 "../src/Application.vala"
		_inner_error0_ = NULL;
#line 85 "../src/Application.vala"
		_tmp4_ = e;
#line 85 "../src/Application.vala"
		if (!g_error_matches (_tmp4_, G_IO_ERROR, G_IO_ERROR_EXISTS)) {
#line 308 "Application.c"
			GError* _tmp5_;
			const gchar* _tmp6_;
#line 86 "../src/Application.vala"
			_tmp5_ = e;
#line 86 "../src/Application.vala"
			_tmp6_ = _tmp5_->message;
#line 86 "../src/Application.vala"
			g_warning ("Application.vala:86: dir couldn't be created: %s", _tmp6_);
#line 317 "Application.c"
		}
#line 78 "../src/Application.vala"
		_g_error_free0 (e);
#line 321 "Application.c"
	}
	__finally0:
#line 78 "../src/Application.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 78 "../src/Application.vala"
		_g_object_unref0 (dir);
#line 78 "../src/Application.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 78 "../src/Application.vala"
		g_clear_error (&_inner_error0_);
#line 78 "../src/Application.vala"
		return;
#line 334 "Application.c"
	}
#line 75 "../src/Application.vala"
	_g_object_unref0 (dir);
#line 338 "Application.c"
}

GSettings*
tuner_application_get_settings (TunerApplication* self)
{
	GSettings* result;
	GSettings* _tmp0_;
#line 8 "../src/Application.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 8 "../src/Application.vala"
	_tmp0_ = self->priv->_settings;
#line 8 "../src/Application.vala"
	result = _tmp0_;
#line 8 "../src/Application.vala"
	return result;
#line 354 "Application.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 8 "../src/Application.vala"
	return self ? g_object_ref (self) : NULL;
#line 362 "Application.c"
}

static void
tuner_application_set_settings (TunerApplication* self,
                                GSettings* value)
{
	GSettings* old_value;
#line 8 "../src/Application.vala"
	g_return_if_fail (self != NULL);
#line 8 "../src/Application.vala"
	old_value = tuner_application_get_settings (self);
#line 8 "../src/Application.vala"
	if (old_value != value) {
#line 376 "Application.c"
		GSettings* _tmp0_;
#line 8 "../src/Application.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 8 "../src/Application.vala"
		_g_object_unref0 (self->priv->_settings);
#line 8 "../src/Application.vala"
		self->priv->_settings = _tmp0_;
#line 8 "../src/Application.vala"
		g_object_notify_by_pspec ((GObject *) self, tuner_application_properties[TUNER_APPLICATION_SETTINGS_PROPERTY]);
#line 386 "Application.c"
	}
}

TunerPlayerController*
tuner_application_get_player (TunerApplication* self)
{
	TunerPlayerController* result;
	TunerPlayerController* _tmp0_;
#line 9 "../src/Application.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 9 "../src/Application.vala"
	_tmp0_ = self->priv->_player;
#line 9 "../src/Application.vala"
	result = _tmp0_;
#line 9 "../src/Application.vala"
	return result;
#line 403 "Application.c"
}

static void
tuner_application_set_player (TunerApplication* self,
                              TunerPlayerController* value)
{
	TunerPlayerController* old_value;
#line 9 "../src/Application.vala"
	g_return_if_fail (self != NULL);
#line 9 "../src/Application.vala"
	old_value = tuner_application_get_player (self);
#line 9 "../src/Application.vala"
	if (old_value != value) {
#line 417 "Application.c"
		TunerPlayerController* _tmp0_;
#line 9 "../src/Application.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 9 "../src/Application.vala"
		_g_object_unref0 (self->priv->_player);
#line 9 "../src/Application.vala"
		self->priv->_player = _tmp0_;
#line 9 "../src/Application.vala"
		g_object_notify_by_pspec ((GObject *) self, tuner_application_properties[TUNER_APPLICATION_PLAYER_PROPERTY]);
#line 427 "Application.c"
	}
}

const gchar*
tuner_application_get_cache_dir (TunerApplication* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 10 "../src/Application.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 10 "../src/Application.vala"
	_tmp0_ = self->priv->_cache_dir;
#line 10 "../src/Application.vala"
	result = _tmp0_;
#line 10 "../src/Application.vala"
	return result;
#line 444 "Application.c"
}

static void
tuner_application_set_cache_dir (TunerApplication* self,
                                 const gchar* value)
{
	gchar* old_value;
#line 10 "../src/Application.vala"
	g_return_if_fail (self != NULL);
#line 10 "../src/Application.vala"
	old_value = tuner_application_get_cache_dir (self);
#line 10 "../src/Application.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 458 "Application.c"
		gchar* _tmp0_;
#line 10 "../src/Application.vala"
		_tmp0_ = g_strdup (value);
#line 10 "../src/Application.vala"
		_g_free0 (self->priv->_cache_dir);
#line 10 "../src/Application.vala"
		self->priv->_cache_dir = _tmp0_;
#line 10 "../src/Application.vala"
		g_object_notify_by_pspec ((GObject *) self, tuner_application_properties[TUNER_APPLICATION_CACHE_DIR_PROPERTY]);
#line 468 "Application.c"
	}
}

const gchar*
tuner_application_get_data_dir (TunerApplication* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 11 "../src/Application.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 11 "../src/Application.vala"
	_tmp0_ = self->priv->_data_dir;
#line 11 "../src/Application.vala"
	result = _tmp0_;
#line 11 "../src/Application.vala"
	return result;
#line 485 "Application.c"
}

static void
tuner_application_set_data_dir (TunerApplication* self,
                                const gchar* value)
{
	gchar* old_value;
#line 11 "../src/Application.vala"
	g_return_if_fail (self != NULL);
#line 11 "../src/Application.vala"
	old_value = tuner_application_get_data_dir (self);
#line 11 "../src/Application.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 499 "Application.c"
		gchar* _tmp0_;
#line 11 "../src/Application.vala"
		_tmp0_ = g_strdup (value);
#line 11 "../src/Application.vala"
		_g_free0 (self->priv->_data_dir);
#line 11 "../src/Application.vala"
		self->priv->_data_dir = _tmp0_;
#line 11 "../src/Application.vala"
		g_object_notify_by_pspec ((GObject *) self, tuner_application_properties[TUNER_APPLICATION_DATA_DIR_PROPERTY]);
#line 509 "Application.c"
	}
}

TunerApplication*
tuner_application_get_instance (void)
{
	TunerApplication* result;
	TunerApplication* _tmp0_;
	TunerApplication* _tmp2_;
#line 53 "../src/Application.vala"
	_tmp0_ = tuner_application__instance;
#line 53 "../src/Application.vala"
	if (_tmp0_ == NULL) {
#line 523 "Application.c"
		TunerApplication* _tmp1_;
#line 54 "../src/Application.vala"
		_tmp1_ = tuner_application_new ();
#line 54 "../src/Application.vala"
		_g_object_unref0 (tuner_application__instance);
#line 54 "../src/Application.vala"
		tuner_application__instance = _tmp1_;
#line 531 "Application.c"
	}
#line 56 "../src/Application.vala"
	_tmp2_ = tuner_application__instance;
#line 56 "../src/Application.vala"
	result = _tmp2_;
#line 56 "../src/Application.vala"
	return result;
#line 539 "Application.c"
}

static GObject *
tuner_application_constructor (GType type,
                               guint n_construct_properties,
                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	TunerApplication * self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	TunerPlayerController* _tmp4_;
	TunerPlayerController* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	const gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	const gchar* _tmp17_;
#line 31 "../src/Application.vala"
	parent_class = G_OBJECT_CLASS (tuner_application_parent_class);
#line 31 "../src/Application.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 31 "../src/Application.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUNER_TYPE_APPLICATION, TunerApplication);
#line 32 "../src/Application.vala"
	setlocale (LC_ALL, "");
#line 33 "../src/Application.vala"
	bindtextdomain (GETTEXT_PACKAGE, LOCALEDIR);
#line 34 "../src/Application.vala"
	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
#line 35 "../src/Application.vala"
	textdomain (GETTEXT_PACKAGE);
#line 37 "../src/Application.vala"
	_tmp0_ = g_application_get_application_id ((GApplication*) self);
#line 37 "../src/Application.vala"
	_tmp1_ = _tmp0_;
#line 37 "../src/Application.vala"
	_tmp2_ = g_settings_new (_tmp1_);
#line 37 "../src/Application.vala"
	_tmp3_ = _tmp2_;
#line 37 "../src/Application.vala"
	tuner_application_set_settings (self, _tmp3_);
#line 37 "../src/Application.vala"
	_g_object_unref0 (_tmp3_);
#line 38 "../src/Application.vala"
	_tmp4_ = tuner_player_controller_new ();
#line 38 "../src/Application.vala"
	_tmp5_ = _tmp4_;
#line 38 "../src/Application.vala"
	tuner_application_set_player (self, _tmp5_);
#line 38 "../src/Application.vala"
	_g_object_unref0 (_tmp5_);
#line 40 "../src/Application.vala"
	_tmp6_ = g_get_user_cache_dir ();
#line 40 "../src/Application.vala"
	_tmp7_ = g_application_get_application_id ((GApplication*) self);
#line 40 "../src/Application.vala"
	_tmp8_ = _tmp7_;
#line 40 "../src/Application.vala"
	_tmp9_ = g_build_filename (_tmp6_, _tmp8_, NULL);
#line 40 "../src/Application.vala"
	_tmp10_ = _tmp9_;
#line 40 "../src/Application.vala"
	tuner_application_set_cache_dir (self, _tmp10_);
#line 40 "../src/Application.vala"
	_g_free0 (_tmp10_);
#line 41 "../src/Application.vala"
	_tmp11_ = self->priv->_cache_dir;
#line 41 "../src/Application.vala"
	tuner_application_ensure_dir (self, _tmp11_);
#line 43 "../src/Application.vala"
	_tmp12_ = g_get_user_data_dir ();
#line 43 "../src/Application.vala"
	_tmp13_ = g_application_get_application_id ((GApplication*) self);
#line 43 "../src/Application.vala"
	_tmp14_ = _tmp13_;
#line 43 "../src/Application.vala"
	_tmp15_ = g_build_filename (_tmp12_, _tmp14_, NULL);
#line 43 "../src/Application.vala"
	_tmp16_ = _tmp15_;
#line 43 "../src/Application.vala"
	tuner_application_set_data_dir (self, _tmp16_);
#line 43 "../src/Application.vala"
	_g_free0 (_tmp16_);
#line 44 "../src/Application.vala"
	_tmp17_ = self->priv->_data_dir;
#line 44 "../src/Application.vala"
	tuner_application_ensure_dir (self, _tmp17_);
#line 46 "../src/Application.vala"
	g_action_map_add_action_entries ((GActionMap*) self, TUNER_APPLICATION_ACTION_ENTRIES, (gint) G_N_ELEMENTS (TUNER_APPLICATION_ACTION_ENTRIES), self);
#line 31 "../src/Application.vala"
	return obj;
#line 642 "Application.c"
}

static void
tuner_application_class_init (TunerApplicationClass * klass,
                              gpointer klass_data)
{
#line 6 "../src/Application.vala"
	tuner_application_parent_class = g_type_class_peek_parent (klass);
#line 6 "../src/Application.vala"
	g_type_class_adjust_private_offset (klass, &TunerApplication_private_offset);
#line 6 "../src/Application.vala"
	((GApplicationClass *) klass)->activate = (void (*) (GApplication*)) tuner_application_real_activate;
#line 6 "../src/Application.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_tuner_application_get_property;
#line 6 "../src/Application.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_tuner_application_set_property;
#line 6 "../src/Application.vala"
	G_OBJECT_CLASS (klass)->constructor = tuner_application_constructor;
#line 6 "../src/Application.vala"
	G_OBJECT_CLASS (klass)->finalize = tuner_application_finalize;
#line 6 "../src/Application.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_APPLICATION_SETTINGS_PROPERTY, tuner_application_properties[TUNER_APPLICATION_SETTINGS_PROPERTY] = g_param_spec_object ("settings", "settings", "settings", g_settings_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 6 "../src/Application.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_APPLICATION_PLAYER_PROPERTY, tuner_application_properties[TUNER_APPLICATION_PLAYER_PROPERTY] = g_param_spec_object ("player", "player", "player", TUNER_TYPE_PLAYER_CONTROLLER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 6 "../src/Application.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_APPLICATION_CACHE_DIR_PROPERTY, tuner_application_properties[TUNER_APPLICATION_CACHE_DIR_PROPERTY] = g_param_spec_string ("cache-dir", "cache-dir", "cache-dir", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 6 "../src/Application.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_APPLICATION_DATA_DIR_PROPERTY, tuner_application_properties[TUNER_APPLICATION_DATA_DIR_PROPERTY] = g_param_spec_string ("data-dir", "data-dir", "data-dir", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 671 "Application.c"
}

static void
tuner_application_instance_init (TunerApplication * self,
                                 gpointer klass)
{
#line 6 "../src/Application.vala"
	self->priv = tuner_application_get_instance_private (self);
#line 680 "Application.c"
}

static void
tuner_application_finalize (GObject * obj)
{
	TunerApplication * self;
#line 6 "../src/Application.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUNER_TYPE_APPLICATION, TunerApplication);
#line 8 "../src/Application.vala"
	_g_object_unref0 (self->priv->_settings);
#line 9 "../src/Application.vala"
	_g_object_unref0 (self->priv->_player);
#line 10 "../src/Application.vala"
	_g_free0 (self->priv->_cache_dir);
#line 11 "../src/Application.vala"
	_g_free0 (self->priv->_data_dir);
#line 13 "../src/Application.vala"
	_g_object_unref0 (self->window);
#line 6 "../src/Application.vala"
	G_OBJECT_CLASS (tuner_application_parent_class)->finalize (obj);
#line 701 "Application.c"
}

static GType
tuner_application_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TunerApplicationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tuner_application_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TunerApplication), 0, (GInstanceInitFunc) tuner_application_instance_init, NULL };
	GType tuner_application_type_id;
	tuner_application_type_id = g_type_register_static (gtk_application_get_type (), "TunerApplication", &g_define_type_info, 0);
	TunerApplication_private_offset = g_type_add_instance_private (tuner_application_type_id, sizeof (TunerApplicationPrivate));
	return tuner_application_type_id;
}

GType
tuner_application_get_type (void)
{
	static volatile gsize tuner_application_type_id__once = 0;
	if (g_once_init_enter (&tuner_application_type_id__once)) {
		GType tuner_application_type_id;
		tuner_application_type_id = tuner_application_get_type_once ();
		g_once_init_leave (&tuner_application_type_id__once, tuner_application_type_id);
	}
	return tuner_application_type_id__once;
}

static void
_vala_tuner_application_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	TunerApplication * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TUNER_TYPE_APPLICATION, TunerApplication);
#line 6 "../src/Application.vala"
	switch (property_id) {
#line 6 "../src/Application.vala"
		case TUNER_APPLICATION_SETTINGS_PROPERTY:
#line 6 "../src/Application.vala"
		g_value_set_object (value, tuner_application_get_settings (self));
#line 6 "../src/Application.vala"
		break;
#line 6 "../src/Application.vala"
		case TUNER_APPLICATION_PLAYER_PROPERTY:
#line 6 "../src/Application.vala"
		g_value_set_object (value, tuner_application_get_player (self));
#line 6 "../src/Application.vala"
		break;
#line 6 "../src/Application.vala"
		case TUNER_APPLICATION_CACHE_DIR_PROPERTY:
#line 6 "../src/Application.vala"
		g_value_set_string (value, tuner_application_get_cache_dir (self));
#line 6 "../src/Application.vala"
		break;
#line 6 "../src/Application.vala"
		case TUNER_APPLICATION_DATA_DIR_PROPERTY:
#line 6 "../src/Application.vala"
		g_value_set_string (value, tuner_application_get_data_dir (self));
#line 6 "../src/Application.vala"
		break;
#line 760 "Application.c"
		default:
#line 6 "../src/Application.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 6 "../src/Application.vala"
		break;
#line 766 "Application.c"
	}
}

static void
_vala_tuner_application_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	TunerApplication * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TUNER_TYPE_APPLICATION, TunerApplication);
#line 6 "../src/Application.vala"
	switch (property_id) {
#line 6 "../src/Application.vala"
		case TUNER_APPLICATION_SETTINGS_PROPERTY:
#line 6 "../src/Application.vala"
		tuner_application_set_settings (self, g_value_get_object (value));
#line 6 "../src/Application.vala"
		break;
#line 6 "../src/Application.vala"
		case TUNER_APPLICATION_PLAYER_PROPERTY:
#line 6 "../src/Application.vala"
		tuner_application_set_player (self, g_value_get_object (value));
#line 6 "../src/Application.vala"
		break;
#line 6 "../src/Application.vala"
		case TUNER_APPLICATION_CACHE_DIR_PROPERTY:
#line 6 "../src/Application.vala"
		tuner_application_set_cache_dir (self, g_value_get_string (value));
#line 6 "../src/Application.vala"
		break;
#line 6 "../src/Application.vala"
		case TUNER_APPLICATION_DATA_DIR_PROPERTY:
#line 6 "../src/Application.vala"
		tuner_application_set_data_dir (self, g_value_get_string (value));
#line 6 "../src/Application.vala"
		break;
#line 804 "Application.c"
		default:
#line 6 "../src/Application.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 6 "../src/Application.vala"
		break;
#line 810 "Application.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

