/* PlayerController.c generated by valac 0.56.3, the Vala compiler
 * generated from PlayerController.vala, do not modify */

/*
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: 2020-2022 Louis Brauer <louis@brauer.family>
 */

#include <glib-object.h>
#include <gst/player/player.h>
#include <glib.h>
#include <string.h>
#include <stdlib.h>
#include <gst/gst.h>
#include <float.h>
#include <math.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TUNER_TYPE_PLAYER_CONTROLLER (tuner_player_controller_get_type ())
#define TUNER_PLAYER_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_PLAYER_CONTROLLER, TunerPlayerController))
#define TUNER_PLAYER_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_PLAYER_CONTROLLER, TunerPlayerControllerClass))
#define TUNER_IS_PLAYER_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_PLAYER_CONTROLLER))
#define TUNER_IS_PLAYER_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_PLAYER_CONTROLLER))
#define TUNER_PLAYER_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_PLAYER_CONTROLLER, TunerPlayerControllerClass))

typedef struct _TunerPlayerController TunerPlayerController;
typedef struct _TunerPlayerControllerClass TunerPlayerControllerClass;
typedef struct _TunerPlayerControllerPrivate TunerPlayerControllerPrivate;

#define TUNER_MODEL_TYPE_STATION (tuner_model_station_get_type ())
#define TUNER_MODEL_STATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_MODEL_TYPE_STATION, TunerModelStation))
#define TUNER_MODEL_STATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_MODEL_TYPE_STATION, TunerModelStationClass))
#define TUNER_MODEL_IS_STATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_MODEL_TYPE_STATION))
#define TUNER_MODEL_IS_STATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_MODEL_TYPE_STATION))
#define TUNER_MODEL_STATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_MODEL_TYPE_STATION, TunerModelStationClass))

typedef struct _TunerModelStation TunerModelStation;
typedef struct _TunerModelStationClass TunerModelStationClass;
enum  {
	TUNER_PLAYER_CONTROLLER_0_PROPERTY,
	TUNER_PLAYER_CONTROLLER_STATION_PROPERTY,
	TUNER_PLAYER_CONTROLLER_VOLUME_PROPERTY,
	TUNER_PLAYER_CONTROLLER_NUM_PROPERTIES
};
static GParamSpec* tuner_player_controller_properties[TUNER_PLAYER_CONTROLLER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))
typedef struct _Block2Data Block2Data;
#define _gst_tag_list_unref0(var) ((var == NULL) ? NULL : (var = (gst_tag_list_unref (var), NULL)))
enum  {
	TUNER_PLAYER_CONTROLLER_STATION_CHANGED_SIGNAL,
	TUNER_PLAYER_CONTROLLER_STATE_CHANGED_SIGNAL,
	TUNER_PLAYER_CONTROLLER_TITLE_CHANGED_SIGNAL,
	TUNER_PLAYER_CONTROLLER_VOLUME_CHANGED_SIGNAL,
	TUNER_PLAYER_CONTROLLER_NUM_SIGNALS
};
static guint tuner_player_controller_signals[TUNER_PLAYER_CONTROLLER_NUM_SIGNALS] = {0};

struct _TunerPlayerController {
	GObject parent_instance;
	TunerPlayerControllerPrivate * priv;
	GstPlayer* player;
};

struct _TunerPlayerControllerClass {
	GObjectClass parent_class;
};

struct _TunerPlayerControllerPrivate {
	TunerModelStation* _station;
	GstPlayerState* _current_state;
};

struct _Block2Data {
	int _ref_count_;
	TunerPlayerController* self;
	gchar* title;
};

static gint TunerPlayerController_private_offset;
static gpointer tuner_player_controller_parent_class = NULL;

VALA_EXTERN GType tuner_player_controller_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerPlayerController, g_object_unref)
VALA_EXTERN GType tuner_model_station_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerModelStation, g_object_unref)
static GstPlayerState* _gst_player_state_dup (GstPlayerState* self);
VALA_EXTERN void tuner_player_controller_play_station (TunerPlayerController* self,
                                           TunerModelStation* station);
VALA_EXTERN const gchar* tuner_model_station_get_url (TunerModelStation* self);
VALA_EXTERN gboolean tuner_player_controller_can_play (TunerPlayerController* self);
VALA_EXTERN void tuner_player_controller_play_pause (TunerPlayerController* self);
static gchar* tuner_player_controller_extract_title_from_stream (TunerPlayerController* self,
                                                          GstPlayerMediaInfo* media_info);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void ____lambda4_ (Block2Data* _data2_,
                   GstTagList* list,
                   const gchar* tag);
static void _____lambda4__gst_tag_foreach_func (GstTagList* list,
                                         const gchar* tag,
                                         gpointer self);
VALA_EXTERN TunerPlayerController* tuner_player_controller_new (void);
VALA_EXTERN TunerPlayerController* tuner_player_controller_construct (GType object_type);
VALA_EXTERN GstPlayerState* tuner_player_controller_get_current_state (TunerPlayerController* self);
VALA_EXTERN void tuner_player_controller_set_current_state (TunerPlayerController* self,
                                                GstPlayerState* value);
VALA_EXTERN TunerModelStation* tuner_player_controller_get_station (TunerPlayerController* self);
VALA_EXTERN void tuner_player_controller_set_station (TunerPlayerController* self,
                                          TunerModelStation* value);
VALA_EXTERN gdouble tuner_player_controller_get_volume (TunerPlayerController* self);
VALA_EXTERN void tuner_player_controller_set_volume (TunerPlayerController* self,
                                         gdouble value);
static GObject * tuner_player_controller_constructor (GType type,
                                               guint n_construct_properties,
                                               GObjectConstructParam * construct_properties);
static void _tuner_player_controller___lambda5_ (TunerPlayerController* self,
                                          GstPlayerState state);
static gboolean _gst_player_state_equal (const GstPlayerState * s1,
                                  const GstPlayerState * s2);
static void __tuner_player_controller___lambda5__gst_player_state_changed (GstPlayer* _sender,
                                                                    GstPlayerState object,
                                                                    gpointer self);
static void _tuner_player_controller___lambda6_ (TunerPlayerController* self,
                                          GstPlayerMediaInfo* obj);
static void __tuner_player_controller___lambda6__gst_player_media_info_updated (GstPlayer* _sender,
                                                                         GstPlayerMediaInfo* object,
                                                                         gpointer self);
static void _tuner_player_controller___lambda7_ (TunerPlayerController* self,
                                          GstPlayer* obj);
static void __tuner_player_controller___lambda7__gst_player_volume_changed (GstPlayer* _sender,
                                                                     gpointer self);
static void tuner_player_controller_finalize (GObject * obj);
static GType tuner_player_controller_get_type_once (void);
static void _vala_tuner_player_controller_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec);
static void _vala_tuner_player_controller_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec);

static inline gpointer
tuner_player_controller_get_instance_private (TunerPlayerController* self)
{
	return G_STRUCT_MEMBER_P (self, TunerPlayerController_private_offset);
}

static GstPlayerState*
_gst_player_state_dup (GstPlayerState* self)
{
	GstPlayerState* dup;
#line 9 "../src/Controllers/PlayerController.vala"
	dup = g_new0 (GstPlayerState, 1);
#line 9 "../src/Controllers/PlayerController.vala"
	memcpy (dup, self, sizeof (GstPlayerState));
#line 9 "../src/Controllers/PlayerController.vala"
	return dup;
#line 170 "PlayerController.c"
}

static gpointer
__gst_player_state_dup0 (gpointer self)
{
#line 9 "../src/Controllers/PlayerController.vala"
	return self ? _gst_player_state_dup (self) : NULL;
#line 178 "PlayerController.c"
}

void
tuner_player_controller_play_station (TunerPlayerController* self,
                                      TunerModelStation* station)
{
	GstPlayer* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GstPlayer* _tmp3_;
#line 64 "../src/Controllers/PlayerController.vala"
	g_return_if_fail (self != NULL);
#line 64 "../src/Controllers/PlayerController.vala"
	g_return_if_fail (station != NULL);
#line 65 "../src/Controllers/PlayerController.vala"
	_tmp0_ = self->player;
#line 65 "../src/Controllers/PlayerController.vala"
	_tmp1_ = tuner_model_station_get_url (station);
#line 65 "../src/Controllers/PlayerController.vala"
	_tmp2_ = _tmp1_;
#line 65 "../src/Controllers/PlayerController.vala"
	gst_player_set_uri (_tmp0_, _tmp2_);
#line 66 "../src/Controllers/PlayerController.vala"
	_tmp3_ = self->player;
#line 66 "../src/Controllers/PlayerController.vala"
	gst_player_play (_tmp3_);
#line 67 "../src/Controllers/PlayerController.vala"
	g_signal_emit (self, tuner_player_controller_signals[TUNER_PLAYER_CONTROLLER_STATION_CHANGED_SIGNAL], 0, station);
#line 207 "PlayerController.c"
}

gboolean
tuner_player_controller_can_play (TunerPlayerController* self)
{
	TunerModelStation* _tmp0_;
	gboolean result;
#line 70 "../src/Controllers/PlayerController.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 71 "../src/Controllers/PlayerController.vala"
	_tmp0_ = self->priv->_station;
#line 71 "../src/Controllers/PlayerController.vala"
	result = _tmp0_ != NULL;
#line 71 "../src/Controllers/PlayerController.vala"
	return result;
#line 223 "PlayerController.c"
}

void
tuner_player_controller_play_pause (TunerPlayerController* self)
{
	GstPlayerState* _tmp0_;
#line 74 "../src/Controllers/PlayerController.vala"
	g_return_if_fail (self != NULL);
#line 75 "../src/Controllers/PlayerController.vala"
	_tmp0_ = self->priv->_current_state;
#line 75 "../src/Controllers/PlayerController.vala"
	switch (*_tmp0_) {
#line 75 "../src/Controllers/PlayerController.vala"
		case GST_PLAYER_STATE_PLAYING:
#line 75 "../src/Controllers/PlayerController.vala"
		case GST_PLAYER_STATE_BUFFERING:
#line 240 "PlayerController.c"
		{
			GstPlayer* _tmp1_;
#line 78 "../src/Controllers/PlayerController.vala"
			_tmp1_ = self->player;
#line 78 "../src/Controllers/PlayerController.vala"
			gst_player_stop (_tmp1_);
#line 79 "../src/Controllers/PlayerController.vala"
			break;
#line 249 "PlayerController.c"
		}
		default:
		{
			GstPlayer* _tmp2_;
#line 81 "../src/Controllers/PlayerController.vala"
			_tmp2_ = self->player;
#line 81 "../src/Controllers/PlayerController.vala"
			gst_player_play (_tmp2_);
#line 82 "../src/Controllers/PlayerController.vala"
			break;
#line 260 "PlayerController.c"
		}
	}
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 86 "../src/Controllers/PlayerController.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 86 "../src/Controllers/PlayerController.vala"
	return _data2_;
#line 272 "PlayerController.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 86 "../src/Controllers/PlayerController.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 282 "PlayerController.c"
		TunerPlayerController* self;
#line 86 "../src/Controllers/PlayerController.vala"
		self = _data2_->self;
#line 86 "../src/Controllers/PlayerController.vala"
		_g_free0 (_data2_->title);
#line 86 "../src/Controllers/PlayerController.vala"
		_g_object_unref0 (self);
#line 86 "../src/Controllers/PlayerController.vala"
		g_slice_free (Block2Data, _data2_);
#line 292 "PlayerController.c"
	}
}

static gpointer
_gst_tag_list_ref0 (gpointer self)
{
#line 90 "../src/Controllers/PlayerController.vala"
	return self ? gst_tag_list_ref (self) : NULL;
#line 301 "PlayerController.c"
}

static void
____lambda4_ (Block2Data* _data2_,
              GstTagList* list,
              const gchar* tag)
{
	TunerPlayerController* self;
#line 91 "../src/Controllers/PlayerController.vala"
	self = _data2_->self;
#line 91 "../src/Controllers/PlayerController.vala"
	g_return_if_fail (list != NULL);
#line 91 "../src/Controllers/PlayerController.vala"
	g_return_if_fail (tag != NULL);
#line 92 "../src/Controllers/PlayerController.vala"
	if (g_strcmp0 (tag, "title") == 0) {
#line 318 "PlayerController.c"
		gchar* _tmp0_ = NULL;
#line 93 "../src/Controllers/PlayerController.vala"
		gst_tag_list_get_string (list, tag, &_tmp0_);
#line 93 "../src/Controllers/PlayerController.vala"
		_g_free0 (_data2_->title);
#line 93 "../src/Controllers/PlayerController.vala"
		_data2_->title = _tmp0_;
#line 326 "PlayerController.c"
	}
}

static void
_____lambda4__gst_tag_foreach_func (GstTagList* list,
                                    const gchar* tag,
                                    gpointer self)
{
#line 91 "../src/Controllers/PlayerController.vala"
	____lambda4_ (self, list, tag);
#line 337 "PlayerController.c"
}

static gchar*
tuner_player_controller_extract_title_from_stream (TunerPlayerController* self,
                                                   GstPlayerMediaInfo* media_info)
{
	Block2Data* _data2_;
	GList* streamlist = NULL;
	GList* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* result;
#line 86 "../src/Controllers/PlayerController.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 86 "../src/Controllers/PlayerController.vala"
	g_return_val_if_fail (media_info != NULL, NULL);
#line 86 "../src/Controllers/PlayerController.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 86 "../src/Controllers/PlayerController.vala"
	_data2_->_ref_count_ = 1;
#line 86 "../src/Controllers/PlayerController.vala"
	_data2_->self = g_object_ref (self);
#line 87 "../src/Controllers/PlayerController.vala"
	_data2_->title = NULL;
#line 88 "../src/Controllers/PlayerController.vala"
	_tmp0_ = gst_player_media_info_get_stream_list (media_info);
#line 88 "../src/Controllers/PlayerController.vala"
	_tmp1_ = g_list_copy (_tmp0_);
#line 88 "../src/Controllers/PlayerController.vala"
	streamlist = _tmp1_;
#line 89 "../src/Controllers/PlayerController.vala"
	_tmp2_ = streamlist;
#line 372 "PlayerController.c"
	{
		GList* stream_collection = NULL;
		GList* stream_it = NULL;
#line 89 "../src/Controllers/PlayerController.vala"
		stream_collection = _tmp2_;
#line 89 "../src/Controllers/PlayerController.vala"
		for (stream_it = stream_collection; stream_it != NULL; stream_it = stream_it->next) {
#line 380 "PlayerController.c"
			GstPlayerStreamInfo* stream = NULL;
#line 89 "../src/Controllers/PlayerController.vala"
			stream = (GstPlayerStreamInfo*) stream_it->data;
#line 384 "PlayerController.c"
			{
				GstTagList* tags = NULL;
				GstPlayerStreamInfo* _tmp3_;
				GstTagList* _tmp4_;
				GstTagList* _tmp5_;
				GstTagList* _tmp6_;
#line 90 "../src/Controllers/PlayerController.vala"
				_tmp3_ = stream;
#line 90 "../src/Controllers/PlayerController.vala"
				_tmp4_ = gst_player_stream_info_get_tags (_tmp3_);
#line 90 "../src/Controllers/PlayerController.vala"
				_tmp5_ = _gst_tag_list_ref0 (_tmp4_);
#line 90 "../src/Controllers/PlayerController.vala"
				tags = _tmp5_;
#line 91 "../src/Controllers/PlayerController.vala"
				_tmp6_ = tags;
#line 91 "../src/Controllers/PlayerController.vala"
				gst_tag_list_foreach (_tmp6_, _____lambda4__gst_tag_foreach_func, _data2_);
#line 89 "../src/Controllers/PlayerController.vala"
				_gst_tag_list_unref0 (tags);
#line 405 "PlayerController.c"
			}
		}
	}
#line 97 "../src/Controllers/PlayerController.vala"
	_tmp7_ = _data2_->title;
#line 97 "../src/Controllers/PlayerController.vala"
	_tmp8_ = g_strdup (_tmp7_);
#line 97 "../src/Controllers/PlayerController.vala"
	result = _tmp8_;
#line 97 "../src/Controllers/PlayerController.vala"
	(streamlist == NULL) ? NULL : (streamlist = (g_list_free (streamlist), NULL));
#line 97 "../src/Controllers/PlayerController.vala"
	block2_data_unref (_data2_);
#line 97 "../src/Controllers/PlayerController.vala"
	_data2_ = NULL;
#line 97 "../src/Controllers/PlayerController.vala"
	return result;
#line 423 "PlayerController.c"
}

TunerPlayerController*
tuner_player_controller_construct (GType object_type)
{
	TunerPlayerController * self = NULL;
#line 7 "../src/Controllers/PlayerController.vala"
	self = (TunerPlayerController*) g_object_new (object_type, NULL);
#line 7 "../src/Controllers/PlayerController.vala"
	return self;
#line 434 "PlayerController.c"
}

TunerPlayerController*
tuner_player_controller_new (void)
{
#line 7 "../src/Controllers/PlayerController.vala"
	return tuner_player_controller_construct (TUNER_TYPE_PLAYER_CONTROLLER);
#line 442 "PlayerController.c"
}

GstPlayerState*
tuner_player_controller_get_current_state (TunerPlayerController* self)
{
	GstPlayerState* result;
	GstPlayerState* _tmp0_;
#line 39 "../src/Controllers/PlayerController.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 40 "../src/Controllers/PlayerController.vala"
	_tmp0_ = self->priv->_current_state;
#line 40 "../src/Controllers/PlayerController.vala"
	result = _tmp0_;
#line 40 "../src/Controllers/PlayerController.vala"
	return result;
#line 458 "PlayerController.c"
}

void
tuner_player_controller_set_current_state (TunerPlayerController* self,
                                           GstPlayerState* value)
{
	GstPlayerState* _tmp0_;
#line 43 "../src/Controllers/PlayerController.vala"
	g_return_if_fail (self != NULL);
#line 44 "../src/Controllers/PlayerController.vala"
	_tmp0_ = __gst_player_state_dup0 (value);
#line 44 "../src/Controllers/PlayerController.vala"
	_g_free0 (self->priv->_current_state);
#line 44 "../src/Controllers/PlayerController.vala"
	self->priv->_current_state = _tmp0_;
#line 474 "PlayerController.c"
}

TunerModelStation*
tuner_player_controller_get_station (TunerPlayerController* self)
{
	TunerModelStation* result;
	TunerModelStation* _tmp0_;
#line 49 "../src/Controllers/PlayerController.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 50 "../src/Controllers/PlayerController.vala"
	_tmp0_ = self->priv->_station;
#line 50 "../src/Controllers/PlayerController.vala"
	result = _tmp0_;
#line 50 "../src/Controllers/PlayerController.vala"
	return result;
#line 490 "PlayerController.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 54 "../src/Controllers/PlayerController.vala"
	return self ? g_object_ref (self) : NULL;
#line 498 "PlayerController.c"
}

void
tuner_player_controller_set_station (TunerPlayerController* self,
                                     TunerModelStation* value)
{
	TunerModelStation* _tmp0_;
	TunerModelStation* _tmp1_;
#line 53 "../src/Controllers/PlayerController.vala"
	g_return_if_fail (self != NULL);
#line 54 "../src/Controllers/PlayerController.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 54 "../src/Controllers/PlayerController.vala"
	_g_object_unref0 (self->priv->_station);
#line 54 "../src/Controllers/PlayerController.vala"
	self->priv->_station = _tmp0_;
#line 55 "../src/Controllers/PlayerController.vala"
	_tmp1_ = self->priv->_station;
#line 55 "../src/Controllers/PlayerController.vala"
	tuner_player_controller_play_station (self, _tmp1_);
#line 53 "../src/Controllers/PlayerController.vala"
	g_object_notify_by_pspec ((GObject *) self, tuner_player_controller_properties[TUNER_PLAYER_CONTROLLER_STATION_PROPERTY]);
#line 521 "PlayerController.c"
}

gdouble
tuner_player_controller_get_volume (TunerPlayerController* self)
{
	gdouble result;
	GstPlayer* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
#line 60 "../src/Controllers/PlayerController.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 60 "../src/Controllers/PlayerController.vala"
	_tmp0_ = self->player;
#line 60 "../src/Controllers/PlayerController.vala"
	_tmp1_ = gst_player_get_volume (_tmp0_);
#line 60 "../src/Controllers/PlayerController.vala"
	_tmp2_ = _tmp1_;
#line 60 "../src/Controllers/PlayerController.vala"
	result = _tmp2_;
#line 60 "../src/Controllers/PlayerController.vala"
	return result;
#line 543 "PlayerController.c"
}

void
tuner_player_controller_set_volume (TunerPlayerController* self,
                                    gdouble value)
{
	GstPlayer* _tmp0_;
#line 61 "../src/Controllers/PlayerController.vala"
	g_return_if_fail (self != NULL);
#line 61 "../src/Controllers/PlayerController.vala"
	_tmp0_ = self->player;
#line 61 "../src/Controllers/PlayerController.vala"
	gst_player_set_volume (_tmp0_, value);
#line 61 "../src/Controllers/PlayerController.vala"
	g_object_notify_by_pspec ((GObject *) self, tuner_player_controller_properties[TUNER_PLAYER_CONTROLLER_VOLUME_PROPERTY]);
#line 559 "PlayerController.c"
}

static gboolean
_gst_player_state_equal (const GstPlayerState * s1,
                         const GstPlayerState * s2)
{
#line 21 "../src/Controllers/PlayerController.vala"
	if (s1 == s2) {
#line 21 "../src/Controllers/PlayerController.vala"
		return TRUE;
#line 570 "PlayerController.c"
	}
#line 21 "../src/Controllers/PlayerController.vala"
	if (s1 == NULL) {
#line 21 "../src/Controllers/PlayerController.vala"
		return FALSE;
#line 576 "PlayerController.c"
	}
#line 21 "../src/Controllers/PlayerController.vala"
	if (s2 == NULL) {
#line 21 "../src/Controllers/PlayerController.vala"
		return FALSE;
#line 582 "PlayerController.c"
	}
#line 21 "../src/Controllers/PlayerController.vala"
	return (*s1) == (*s2);
#line 586 "PlayerController.c"
}

static void
_tuner_player_controller___lambda5_ (TunerPlayerController* self,
                                     GstPlayerState state)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GstPlayerState* _tmp2_;
	GstPlayerState* _tmp3_;
	GstPlayerState _tmp4_;
#line 21 "../src/Controllers/PlayerController.vala"
	_tmp2_ = tuner_player_controller_get_current_state (self);
#line 21 "../src/Controllers/PlayerController.vala"
	_tmp3_ = _tmp2_;
#line 21 "../src/Controllers/PlayerController.vala"
	_tmp4_ = GST_PLAYER_STATE_PLAYING;
#line 21 "../src/Controllers/PlayerController.vala"
	if (_gst_player_state_equal (_tmp3_, &_tmp4_) == TRUE) {
#line 21 "../src/Controllers/PlayerController.vala"
		_tmp1_ = state == GST_PLAYER_STATE_BUFFERING;
#line 608 "PlayerController.c"
	} else {
#line 21 "../src/Controllers/PlayerController.vala"
		_tmp1_ = FALSE;
#line 612 "PlayerController.c"
	}
#line 21 "../src/Controllers/PlayerController.vala"
	if (!_tmp1_) {
#line 616 "PlayerController.c"
		GstPlayerState* _tmp5_;
		GstPlayerState* _tmp6_;
#line 21 "../src/Controllers/PlayerController.vala"
		_tmp5_ = tuner_player_controller_get_current_state (self);
#line 21 "../src/Controllers/PlayerController.vala"
		_tmp6_ = _tmp5_;
#line 21 "../src/Controllers/PlayerController.vala"
		_tmp0_ = !(_gst_player_state_equal (&state, _tmp6_) == TRUE);
#line 625 "PlayerController.c"
	} else {
#line 21 "../src/Controllers/PlayerController.vala"
		_tmp0_ = FALSE;
#line 629 "PlayerController.c"
	}
#line 21 "../src/Controllers/PlayerController.vala"
	if (_tmp0_) {
#line 22 "../src/Controllers/PlayerController.vala"
		g_signal_emit (self, tuner_player_controller_signals[TUNER_PLAYER_CONTROLLER_STATE_CHANGED_SIGNAL], 0, state);
#line 23 "../src/Controllers/PlayerController.vala"
		tuner_player_controller_set_current_state (self, &state);
#line 637 "PlayerController.c"
	}
}

static void
__tuner_player_controller___lambda5__gst_player_state_changed (GstPlayer* _sender,
                                                               GstPlayerState object,
                                                               gpointer self)
{
#line 19 "../src/Controllers/PlayerController.vala"
	_tuner_player_controller___lambda5_ ((TunerPlayerController*) self, object);
#line 648 "PlayerController.c"
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1578 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1579 "glib-2.0.vapi"
	result = self;
#line 1579 "glib-2.0.vapi"
	return result;
#line 661 "PlayerController.c"
}

static void
_tuner_player_controller___lambda6_ (TunerPlayerController* self,
                                     GstPlayerMediaInfo* obj)
{
	gchar* title = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 26 "../src/Controllers/PlayerController.vala"
	g_return_if_fail (obj != NULL);
#line 27 "../src/Controllers/PlayerController.vala"
	_tmp0_ = tuner_player_controller_extract_title_from_stream (self, obj);
#line 27 "../src/Controllers/PlayerController.vala"
	title = _tmp0_;
#line 28 "../src/Controllers/PlayerController.vala"
	_tmp1_ = title;
#line 28 "../src/Controllers/PlayerController.vala"
	if (_tmp1_ != NULL) {
#line 681 "PlayerController.c"
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		const gchar* _tmp6_;
#line 29 "../src/Controllers/PlayerController.vala"
		_tmp2_ = title;
#line 29 "../src/Controllers/PlayerController.vala"
		_tmp3_ = string_to_string (_tmp2_);
#line 29 "../src/Controllers/PlayerController.vala"
		_tmp4_ = g_strconcat ("Got new title from station: ", _tmp3_, NULL);
#line 29 "../src/Controllers/PlayerController.vala"
		_tmp5_ = _tmp4_;
#line 29 "../src/Controllers/PlayerController.vala"
		g_debug ("PlayerController.vala:29: %s", _tmp5_);
#line 29 "../src/Controllers/PlayerController.vala"
		_g_free0 (_tmp5_);
#line 30 "../src/Controllers/PlayerController.vala"
		_tmp6_ = title;
#line 30 "../src/Controllers/PlayerController.vala"
		g_signal_emit (self, tuner_player_controller_signals[TUNER_PLAYER_CONTROLLER_TITLE_CHANGED_SIGNAL], 0, _tmp6_);
#line 703 "PlayerController.c"
	}
#line 26 "../src/Controllers/PlayerController.vala"
	_g_free0 (title);
#line 707 "PlayerController.c"
}

static void
__tuner_player_controller___lambda6__gst_player_media_info_updated (GstPlayer* _sender,
                                                                    GstPlayerMediaInfo* object,
                                                                    gpointer self)
{
#line 26 "../src/Controllers/PlayerController.vala"
	_tuner_player_controller___lambda6_ ((TunerPlayerController*) self, object);
#line 717 "PlayerController.c"
}

static void
_tuner_player_controller___lambda7_ (TunerPlayerController* self,
                                     GstPlayer* obj)
{
	gdouble _tmp0_;
	gdouble _tmp1_;
#line 33 "../src/Controllers/PlayerController.vala"
	g_return_if_fail (obj != NULL);
#line 34 "../src/Controllers/PlayerController.vala"
	_tmp0_ = gst_player_get_volume (obj);
#line 34 "../src/Controllers/PlayerController.vala"
	_tmp1_ = _tmp0_;
#line 34 "../src/Controllers/PlayerController.vala"
	g_signal_emit (self, tuner_player_controller_signals[TUNER_PLAYER_CONTROLLER_VOLUME_CHANGED_SIGNAL], 0, _tmp1_);
#line 734 "PlayerController.c"
}

static void
__tuner_player_controller___lambda7__gst_player_volume_changed (GstPlayer* _sender,
                                                                gpointer self)
{
#line 33 "../src/Controllers/PlayerController.vala"
	_tuner_player_controller___lambda7_ ((TunerPlayerController*) self, _sender);
#line 743 "PlayerController.c"
}

static GObject *
tuner_player_controller_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	TunerPlayerController * self;
	GstPlayer* _tmp0_;
	GstPlayer* _tmp1_;
	GstPlayer* _tmp2_;
	GstPlayer* _tmp3_;
#line 17 "../src/Controllers/PlayerController.vala"
	parent_class = G_OBJECT_CLASS (tuner_player_controller_parent_class);
#line 17 "../src/Controllers/PlayerController.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 17 "../src/Controllers/PlayerController.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUNER_TYPE_PLAYER_CONTROLLER, TunerPlayerController);
#line 18 "../src/Controllers/PlayerController.vala"
	_tmp0_ = gst_player_new (NULL, NULL);
#line 18 "../src/Controllers/PlayerController.vala"
	g_object_ref_sink (_tmp0_);
#line 18 "../src/Controllers/PlayerController.vala"
	_g_object_unref0 (self->player);
#line 18 "../src/Controllers/PlayerController.vala"
	self->player = _tmp0_;
#line 19 "../src/Controllers/PlayerController.vala"
	_tmp1_ = self->player;
#line 19 "../src/Controllers/PlayerController.vala"
	g_signal_connect_object (_tmp1_, "state-changed", (GCallback) __tuner_player_controller___lambda5__gst_player_state_changed, self, 0);
#line 26 "../src/Controllers/PlayerController.vala"
	_tmp2_ = self->player;
#line 26 "../src/Controllers/PlayerController.vala"
	g_signal_connect_object (_tmp2_, "media-info-updated", (GCallback) __tuner_player_controller___lambda6__gst_player_media_info_updated, self, 0);
#line 33 "../src/Controllers/PlayerController.vala"
	_tmp3_ = self->player;
#line 33 "../src/Controllers/PlayerController.vala"
	g_signal_connect_object (_tmp3_, "volume-changed", (GCallback) __tuner_player_controller___lambda7__gst_player_volume_changed, self, 0);
#line 17 "../src/Controllers/PlayerController.vala"
	return obj;
#line 786 "PlayerController.c"
}

static void
tuner_player_controller_class_init (TunerPlayerControllerClass * klass,
                                    gpointer klass_data)
{
#line 7 "../src/Controllers/PlayerController.vala"
	tuner_player_controller_parent_class = g_type_class_peek_parent (klass);
#line 7 "../src/Controllers/PlayerController.vala"
	g_type_class_adjust_private_offset (klass, &TunerPlayerController_private_offset);
#line 7 "../src/Controllers/PlayerController.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_tuner_player_controller_get_property;
#line 7 "../src/Controllers/PlayerController.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_tuner_player_controller_set_property;
#line 7 "../src/Controllers/PlayerController.vala"
	G_OBJECT_CLASS (klass)->constructor = tuner_player_controller_constructor;
#line 7 "../src/Controllers/PlayerController.vala"
	G_OBJECT_CLASS (klass)->finalize = tuner_player_controller_finalize;
#line 7 "../src/Controllers/PlayerController.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_PLAYER_CONTROLLER_STATION_PROPERTY, tuner_player_controller_properties[TUNER_PLAYER_CONTROLLER_STATION_PROPERTY] = g_param_spec_object ("station", "station", "station", TUNER_MODEL_TYPE_STATION, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 7 "../src/Controllers/PlayerController.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_PLAYER_CONTROLLER_VOLUME_PROPERTY, tuner_player_controller_properties[TUNER_PLAYER_CONTROLLER_VOLUME_PROPERTY] = g_param_spec_double ("volume", "volume", "volume", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 7 "../src/Controllers/PlayerController.vala"
	tuner_player_controller_signals[TUNER_PLAYER_CONTROLLER_STATION_CHANGED_SIGNAL] = g_signal_new ("station-changed", TUNER_TYPE_PLAYER_CONTROLLER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TUNER_MODEL_TYPE_STATION);
#line 7 "../src/Controllers/PlayerController.vala"
	tuner_player_controller_signals[TUNER_PLAYER_CONTROLLER_STATE_CHANGED_SIGNAL] = g_signal_new ("state-changed", TUNER_TYPE_PLAYER_CONTROLLER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__ENUM, G_TYPE_NONE, 1, gst_player_state_get_type ());
#line 7 "../src/Controllers/PlayerController.vala"
	tuner_player_controller_signals[TUNER_PLAYER_CONTROLLER_TITLE_CHANGED_SIGNAL] = g_signal_new ("title-changed", TUNER_TYPE_PLAYER_CONTROLLER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 7 "../src/Controllers/PlayerController.vala"
	tuner_player_controller_signals[TUNER_PLAYER_CONTROLLER_VOLUME_CHANGED_SIGNAL] = g_signal_new ("volume-changed", TUNER_TYPE_PLAYER_CONTROLLER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__DOUBLE, G_TYPE_NONE, 1, G_TYPE_DOUBLE);
#line 817 "PlayerController.c"
}

static void
tuner_player_controller_instance_init (TunerPlayerController * self,
                                       gpointer klass)
{
	GstPlayerState _tmp0_;
	GstPlayerState* _tmp1_;
#line 7 "../src/Controllers/PlayerController.vala"
	self->priv = tuner_player_controller_get_instance_private (self);
#line 9 "../src/Controllers/PlayerController.vala"
	_tmp0_ = GST_PLAYER_STATE_STOPPED;
#line 9 "../src/Controllers/PlayerController.vala"
	_tmp1_ = __gst_player_state_dup0 (&_tmp0_);
#line 9 "../src/Controllers/PlayerController.vala"
	self->priv->_current_state = _tmp1_;
#line 834 "PlayerController.c"
}

static void
tuner_player_controller_finalize (GObject * obj)
{
	TunerPlayerController * self;
#line 7 "../src/Controllers/PlayerController.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUNER_TYPE_PLAYER_CONTROLLER, TunerPlayerController);
#line 8 "../src/Controllers/PlayerController.vala"
	_g_object_unref0 (self->priv->_station);
#line 9 "../src/Controllers/PlayerController.vala"
	_g_free0 (self->priv->_current_state);
#line 10 "../src/Controllers/PlayerController.vala"
	_g_object_unref0 (self->player);
#line 7 "../src/Controllers/PlayerController.vala"
	G_OBJECT_CLASS (tuner_player_controller_parent_class)->finalize (obj);
#line 851 "PlayerController.c"
}

static GType
tuner_player_controller_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TunerPlayerControllerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tuner_player_controller_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TunerPlayerController), 0, (GInstanceInitFunc) tuner_player_controller_instance_init, NULL };
	GType tuner_player_controller_type_id;
	tuner_player_controller_type_id = g_type_register_static (G_TYPE_OBJECT, "TunerPlayerController", &g_define_type_info, 0);
	TunerPlayerController_private_offset = g_type_add_instance_private (tuner_player_controller_type_id, sizeof (TunerPlayerControllerPrivate));
	return tuner_player_controller_type_id;
}

GType
tuner_player_controller_get_type (void)
{
	static volatile gsize tuner_player_controller_type_id__once = 0;
	if (g_once_init_enter (&tuner_player_controller_type_id__once)) {
		GType tuner_player_controller_type_id;
		tuner_player_controller_type_id = tuner_player_controller_get_type_once ();
		g_once_init_leave (&tuner_player_controller_type_id__once, tuner_player_controller_type_id);
	}
	return tuner_player_controller_type_id__once;
}

static void
_vala_tuner_player_controller_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec)
{
	TunerPlayerController * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TUNER_TYPE_PLAYER_CONTROLLER, TunerPlayerController);
#line 7 "../src/Controllers/PlayerController.vala"
	switch (property_id) {
#line 7 "../src/Controllers/PlayerController.vala"
		case TUNER_PLAYER_CONTROLLER_STATION_PROPERTY:
#line 7 "../src/Controllers/PlayerController.vala"
		g_value_set_object (value, tuner_player_controller_get_station (self));
#line 7 "../src/Controllers/PlayerController.vala"
		break;
#line 7 "../src/Controllers/PlayerController.vala"
		case TUNER_PLAYER_CONTROLLER_VOLUME_PROPERTY:
#line 7 "../src/Controllers/PlayerController.vala"
		g_value_set_double (value, tuner_player_controller_get_volume (self));
#line 7 "../src/Controllers/PlayerController.vala"
		break;
#line 898 "PlayerController.c"
		default:
#line 7 "../src/Controllers/PlayerController.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 7 "../src/Controllers/PlayerController.vala"
		break;
#line 904 "PlayerController.c"
	}
}

static void
_vala_tuner_player_controller_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec)
{
	TunerPlayerController * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TUNER_TYPE_PLAYER_CONTROLLER, TunerPlayerController);
#line 7 "../src/Controllers/PlayerController.vala"
	switch (property_id) {
#line 7 "../src/Controllers/PlayerController.vala"
		case TUNER_PLAYER_CONTROLLER_STATION_PROPERTY:
#line 7 "../src/Controllers/PlayerController.vala"
		tuner_player_controller_set_station (self, g_value_get_object (value));
#line 7 "../src/Controllers/PlayerController.vala"
		break;
#line 7 "../src/Controllers/PlayerController.vala"
		case TUNER_PLAYER_CONTROLLER_VOLUME_PROPERTY:
#line 7 "../src/Controllers/PlayerController.vala"
		tuner_player_controller_set_volume (self, g_value_get_double (value));
#line 7 "../src/Controllers/PlayerController.vala"
		break;
#line 930 "PlayerController.c"
		default:
#line 7 "../src/Controllers/PlayerController.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 7 "../src/Controllers/PlayerController.vala"
		break;
#line 936 "PlayerController.c"
	}
}

