/* StationStore.c generated by valac 0.56.3, the Vala compiler
 * generated from StationStore.vala, do not modify */

/*
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: 2020-2022 Louis Brauer <louis@brauer.family>
 */
/* StationStore can store and retrieve a collection of stations*/
/* in a JSON file*/

#include <glib-object.h>
#include <gee.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <json-glib/json-glib.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TUNER_MODEL_TYPE_STATION_STORE (tuner_model_station_store_get_type ())
#define TUNER_MODEL_STATION_STORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_MODEL_TYPE_STATION_STORE, TunerModelStationStore))
#define TUNER_MODEL_STATION_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_MODEL_TYPE_STATION_STORE, TunerModelStationStoreClass))
#define TUNER_MODEL_IS_STATION_STORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_MODEL_TYPE_STATION_STORE))
#define TUNER_MODEL_IS_STATION_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_MODEL_TYPE_STATION_STORE))
#define TUNER_MODEL_STATION_STORE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_MODEL_TYPE_STATION_STORE, TunerModelStationStoreClass))

typedef struct _TunerModelStationStore TunerModelStationStore;
typedef struct _TunerModelStationStoreClass TunerModelStationStoreClass;
typedef struct _TunerModelStationStorePrivate TunerModelStationStorePrivate;

#define TUNER_MODEL_TYPE_STATION (tuner_model_station_get_type ())
#define TUNER_MODEL_STATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_MODEL_TYPE_STATION, TunerModelStation))
#define TUNER_MODEL_STATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_MODEL_TYPE_STATION, TunerModelStationClass))
#define TUNER_MODEL_IS_STATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_MODEL_TYPE_STATION))
#define TUNER_MODEL_IS_STATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_MODEL_TYPE_STATION))
#define TUNER_MODEL_STATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_MODEL_TYPE_STATION, TunerModelStationClass))

typedef struct _TunerModelStation TunerModelStation;
typedef struct _TunerModelStationClass TunerModelStationClass;
enum  {
	TUNER_MODEL_STATION_STORE_0_PROPERTY,
	TUNER_MODEL_STATION_STORE_NUM_PROPERTIES
};
static GParamSpec* tuner_model_station_store_properties[TUNER_MODEL_STATION_STORE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block3Data Block3Data;
#define _json_array_unref0(var) ((var == NULL) ? NULL : (var = (json_array_unref (var), NULL)))
#define __vala_JsonNode_free0(var) ((var == NULL) ? NULL : (var = (_vala_JsonNode_free (var), NULL)))

struct _TunerModelStationStore {
	GObject parent_instance;
	TunerModelStationStorePrivate * priv;
};

struct _TunerModelStationStoreClass {
	GObjectClass parent_class;
};

struct _TunerModelStationStorePrivate {
	GeeArrayList* _store;
	GFile* _data_file;
};

struct _Block3Data {
	int _ref_count_;
	TunerModelStationStore* self;
	TunerModelStation* station;
};

static gint TunerModelStationStore_private_offset;
static gpointer tuner_model_station_store_parent_class = NULL;

VALA_EXTERN GType tuner_model_station_store_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerModelStationStore, g_object_unref)
VALA_EXTERN GType tuner_model_station_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerModelStation, g_object_unref)
VALA_EXTERN TunerModelStationStore* tuner_model_station_store_new (const gchar* data_path);
VALA_EXTERN TunerModelStationStore* tuner_model_station_store_construct (GType object_type,
                                                             const gchar* data_path);
static void tuner_model_station_store_ensure (TunerModelStationStore* self);
static void tuner_model_station_store_load (TunerModelStationStore* self);
VALA_EXTERN void tuner_model_station_store_add (TunerModelStationStore* self,
                                    TunerModelStation* station);
static void _tuner_model_station_store_add (TunerModelStationStore* self,
                                     TunerModelStation* station);
static void tuner_model_station_store_persist (TunerModelStationStore* self);
VALA_EXTERN void tuner_model_station_store_remove (TunerModelStationStore* self,
                                       TunerModelStation* station);
static JsonNode* _vala_JsonNode_copy (JsonNode* self);
static void __lambda32_ (TunerModelStationStore* self,
                  JsonArray* a,
                  guint i,
                  JsonNode* elem);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static void __lambda33_ (Block3Data* _data3_,
                  GObject* sender,
                  GParamSpec* property);
VALA_EXTERN gboolean tuner_model_station_get_starred (TunerModelStation* self);
static void ___lambda33__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void ___lambda32__json_array_foreach (JsonArray* array,
                                      guint index_,
                                      JsonNode* element_node,
                                      gpointer self);
static void _vala_JsonNode_free (JsonNode* self);
VALA_EXTERN gchar* tuner_model_station_store_serialize (TunerModelStationStore* self);
VALA_EXTERN GeeArrayList* tuner_model_station_store_get_all (TunerModelStationStore* self);
VALA_EXTERN gboolean tuner_model_station_store_contains (TunerModelStationStore* self,
                                             TunerModelStation* station);
VALA_EXTERN const gchar* tuner_model_station_get_id (TunerModelStation* self);
static void tuner_model_station_store_finalize (GObject * obj);
static GType tuner_model_station_store_get_type_once (void);

static inline gpointer
tuner_model_station_store_get_instance_private (TunerModelStationStore* self)
{
	return G_STRUCT_MEMBER_P (self, TunerModelStationStore_private_offset);
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1578 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1579 "glib-2.0.vapi"
	result = self;
#line 1579 "glib-2.0.vapi"
	return result;
#line 144 "StationStore.c"
}

TunerModelStationStore*
tuner_model_station_store_construct (GType object_type,
                                     const gchar* data_path)
{
	TunerModelStationStore * self = NULL;
	GeeArrayList* _tmp0_;
	GFile* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 17 "../src/Models/StationStore.vala"
	g_return_val_if_fail (data_path != NULL, NULL);
#line 18 "../src/Models/StationStore.vala"
	self = (TunerModelStationStore*) g_object_new (object_type, NULL);
#line 20 "../src/Models/StationStore.vala"
	_tmp0_ = gee_array_list_new (TUNER_MODEL_TYPE_STATION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 20 "../src/Models/StationStore.vala"
	_g_object_unref0 (self->priv->_store);
#line 20 "../src/Models/StationStore.vala"
	self->priv->_store = _tmp0_;
#line 21 "../src/Models/StationStore.vala"
	_tmp1_ = g_file_new_for_path (data_path);
#line 21 "../src/Models/StationStore.vala"
	_g_object_unref0 (self->priv->_data_file);
#line 21 "../src/Models/StationStore.vala"
	self->priv->_data_file = _tmp1_;
#line 22 "../src/Models/StationStore.vala"
	tuner_model_station_store_ensure (self);
#line 23 "../src/Models/StationStore.vala"
	tuner_model_station_store_load (self);
#line 24 "../src/Models/StationStore.vala"
	_tmp2_ = string_to_string (data_path);
#line 24 "../src/Models/StationStore.vala"
	_tmp3_ = g_strconcat ("store initialized in path ", _tmp2_, NULL);
#line 24 "../src/Models/StationStore.vala"
	_tmp4_ = _tmp3_;
#line 24 "../src/Models/StationStore.vala"
	g_debug ("StationStore.vala:24: %s", _tmp4_);
#line 24 "../src/Models/StationStore.vala"
	_g_free0 (_tmp4_);
#line 17 "../src/Models/StationStore.vala"
	return self;
#line 189 "StationStore.c"
}

TunerModelStationStore*
tuner_model_station_store_new (const gchar* data_path)
{
#line 17 "../src/Models/StationStore.vala"
	return tuner_model_station_store_construct (TUNER_MODEL_TYPE_STATION_STORE, data_path);
#line 197 "StationStore.c"
}

void
tuner_model_station_store_add (TunerModelStationStore* self,
                               TunerModelStation* station)
{
#line 27 "../src/Models/StationStore.vala"
	g_return_if_fail (self != NULL);
#line 27 "../src/Models/StationStore.vala"
	g_return_if_fail (station != NULL);
#line 28 "../src/Models/StationStore.vala"
	_tuner_model_station_store_add (self, station);
#line 29 "../src/Models/StationStore.vala"
	tuner_model_station_store_persist (self);
#line 212 "StationStore.c"
}

static void
_tuner_model_station_store_add (TunerModelStationStore* self,
                                TunerModelStation* station)
{
	GeeArrayList* _tmp0_;
#line 32 "../src/Models/StationStore.vala"
	g_return_if_fail (self != NULL);
#line 32 "../src/Models/StationStore.vala"
	g_return_if_fail (station != NULL);
#line 33 "../src/Models/StationStore.vala"
	_tmp0_ = self->priv->_store;
#line 33 "../src/Models/StationStore.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, station);
#line 228 "StationStore.c"
}

void
tuner_model_station_store_remove (TunerModelStationStore* self,
                                  TunerModelStation* station)
{
	GeeArrayList* _tmp0_;
#line 37 "../src/Models/StationStore.vala"
	g_return_if_fail (self != NULL);
#line 37 "../src/Models/StationStore.vala"
	g_return_if_fail (station != NULL);
#line 38 "../src/Models/StationStore.vala"
	_tmp0_ = self->priv->_store;
#line 38 "../src/Models/StationStore.vala"
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp0_, station);
#line 39 "../src/Models/StationStore.vala"
	tuner_model_station_store_persist (self);
#line 246 "StationStore.c"
}

static void
tuner_model_station_store_ensure (TunerModelStationStore* self)
{
	GError* _inner_error0_ = NULL;
#line 42 "../src/Models/StationStore.vala"
	g_return_if_fail (self != NULL);
#line 255 "StationStore.c"
	{
		GFileOutputStream* df = NULL;
		GFile* _tmp0_;
		GFileOutputStream* _tmp1_;
		GFileOutputStream* _tmp2_;
#line 46 "../src/Models/StationStore.vala"
		_tmp0_ = self->priv->_data_file;
#line 46 "../src/Models/StationStore.vala"
		_tmp1_ = g_file_create (_tmp0_, G_FILE_CREATE_PRIVATE, NULL, &_inner_error0_);
#line 46 "../src/Models/StationStore.vala"
		df = _tmp1_;
#line 46 "../src/Models/StationStore.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 269 "StationStore.c"
			goto __catch0_g_error;
		}
#line 47 "../src/Models/StationStore.vala"
		_tmp2_ = df;
#line 47 "../src/Models/StationStore.vala"
		g_output_stream_close ((GOutputStream*) _tmp2_, NULL, &_inner_error0_);
#line 47 "../src/Models/StationStore.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 47 "../src/Models/StationStore.vala"
			_g_object_unref0 (df);
#line 280 "StationStore.c"
			goto __catch0_g_error;
		}
#line 48 "../src/Models/StationStore.vala"
		g_debug ("StationStore.vala:48: %s", "store created");
#line 45 "../src/Models/StationStore.vala"
		_g_object_unref0 (df);
#line 287 "StationStore.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 45 "../src/Models/StationStore.vala"
		g_clear_error (&_inner_error0_);
#line 294 "StationStore.c"
	}
	__finally0:
#line 45 "../src/Models/StationStore.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 45 "../src/Models/StationStore.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 45 "../src/Models/StationStore.vala"
		g_clear_error (&_inner_error0_);
#line 45 "../src/Models/StationStore.vala"
		return;
#line 305 "StationStore.c"
	}
}

static JsonNode*
_vala_JsonNode_copy (JsonNode* self)
{
#line 66 "../src/Models/StationStore.vala"
	return g_boxed_copy (json_node_get_type (), self);
#line 314 "StationStore.c"
}

static gpointer
__vala_JsonNode_copy0 (gpointer self)
{
#line 66 "../src/Models/StationStore.vala"
	return self ? _vala_JsonNode_copy (self) : NULL;
#line 322 "StationStore.c"
}

static gpointer
_json_array_ref0 (gpointer self)
{
#line 67 "../src/Models/StationStore.vala"
	return self ? json_array_ref (self) : NULL;
#line 330 "StationStore.c"
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
#line 68 "../src/Models/StationStore.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 68 "../src/Models/StationStore.vala"
	return _data3_;
#line 340 "StationStore.c"
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 68 "../src/Models/StationStore.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 350 "StationStore.c"
		TunerModelStationStore* self;
#line 68 "../src/Models/StationStore.vala"
		self = _data3_->self;
#line 68 "../src/Models/StationStore.vala"
		_g_object_unref0 (_data3_->station);
#line 68 "../src/Models/StationStore.vala"
		_g_object_unref0 (self);
#line 68 "../src/Models/StationStore.vala"
		g_slice_free (Block3Data, _data3_);
#line 360 "StationStore.c"
	}
}

static void
__lambda33_ (Block3Data* _data3_,
             GObject* sender,
             GParamSpec* property)
{
	TunerModelStationStore* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 72 "../src/Models/StationStore.vala"
	self = _data3_->self;
#line 72 "../src/Models/StationStore.vala"
	g_return_if_fail (sender != NULL);
#line 72 "../src/Models/StationStore.vala"
	g_return_if_fail (property != NULL);
#line 73 "../src/Models/StationStore.vala"
	_tmp0_ = tuner_model_station_get_starred (_data3_->station);
#line 73 "../src/Models/StationStore.vala"
	_tmp1_ = _tmp0_;
#line 73 "../src/Models/StationStore.vala"
	if (_tmp1_) {
#line 74 "../src/Models/StationStore.vala"
		tuner_model_station_store_add (self, _data3_->station);
#line 386 "StationStore.c"
	} else {
#line 76 "../src/Models/StationStore.vala"
		tuner_model_station_store_remove (self, _data3_->station);
#line 390 "StationStore.c"
	}
}

static void
___lambda33__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 72 "../src/Models/StationStore.vala"
	__lambda33_ (self, _sender, pspec);
#line 401 "StationStore.c"
}

static void
__lambda32_ (TunerModelStationStore* self,
             JsonArray* a,
             guint i,
             JsonNode* elem)
{
	Block3Data* _data3_;
	GObject* _tmp0_;
	TunerModelStation* _tmp1_;
#line 68 "../src/Models/StationStore.vala"
	g_return_if_fail (a != NULL);
#line 68 "../src/Models/StationStore.vala"
	g_return_if_fail (elem != NULL);
#line 68 "../src/Models/StationStore.vala"
	_data3_ = g_slice_new0 (Block3Data);
#line 68 "../src/Models/StationStore.vala"
	_data3_->_ref_count_ = 1;
#line 68 "../src/Models/StationStore.vala"
	_data3_->self = g_object_ref (self);
#line 69 "../src/Models/StationStore.vala"
	_tmp0_ = json_gobject_deserialize (TUNER_MODEL_TYPE_STATION, elem);
#line 69 "../src/Models/StationStore.vala"
	_tmp1_ = TUNER_MODEL_IS_STATION (_tmp0_) ? ((TunerModelStation*) _tmp0_) : NULL;
#line 69 "../src/Models/StationStore.vala"
	if (_tmp1_ == NULL) {
#line 69 "../src/Models/StationStore.vala"
		_g_object_unref0 (_tmp0_);
#line 431 "StationStore.c"
	}
#line 69 "../src/Models/StationStore.vala"
	_data3_->station = _tmp1_;
#line 72 "../src/Models/StationStore.vala"
	g_signal_connect_data ((GObject*) _data3_->station, "notify::starred", (GCallback) ___lambda33__g_object_notify, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
#line 80 "../src/Models/StationStore.vala"
	_tuner_model_station_store_add (self, _data3_->station);
#line 68 "../src/Models/StationStore.vala"
	block3_data_unref (_data3_);
#line 68 "../src/Models/StationStore.vala"
	_data3_ = NULL;
#line 443 "StationStore.c"
}

static void
___lambda32__json_array_foreach (JsonArray* array,
                                 guint index_,
                                 JsonNode* element_node,
                                 gpointer self)
{
#line 68 "../src/Models/StationStore.vala"
	__lambda32_ ((TunerModelStationStore*) self, array, index_, element_node);
#line 454 "StationStore.c"
}

static void
_vala_JsonNode_free (JsonNode* self)
{
#line 54 "../src/Models/StationStore.vala"
	g_boxed_free (json_node_get_type (), self);
#line 462 "StationStore.c"
}

static void
tuner_model_station_store_load (TunerModelStationStore* self)
{
	JsonParser* parser = NULL;
	JsonParser* _tmp0_;
	JsonNode* node = NULL;
	JsonParser* _tmp11_;
	JsonNode* _tmp12_;
	JsonNode* _tmp13_;
	JsonArray* array = NULL;
	JsonArray* _tmp14_;
	JsonArray* _tmp15_;
	GeeArrayList* _tmp16_;
	gint _tmp17_;
	gint _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	GError* _inner_error0_ = NULL;
#line 54 "../src/Models/StationStore.vala"
	g_return_if_fail (self != NULL);
#line 55 "../src/Models/StationStore.vala"
	g_debug ("StationStore.vala:55: loading store");
#line 56 "../src/Models/StationStore.vala"
	_tmp0_ = json_parser_new ();
#line 56 "../src/Models/StationStore.vala"
	parser = _tmp0_;
#line 493 "StationStore.c"
	{
		GFileInputStream* stream = NULL;
		GFile* _tmp1_;
		GFileInputStream* _tmp2_;
		JsonParser* _tmp3_;
		GFileInputStream* _tmp4_;
		GFileInputStream* _tmp5_;
#line 59 "../src/Models/StationStore.vala"
		_tmp1_ = self->priv->_data_file;
#line 59 "../src/Models/StationStore.vala"
		_tmp2_ = g_file_read (_tmp1_, NULL, &_inner_error0_);
#line 59 "../src/Models/StationStore.vala"
		stream = _tmp2_;
#line 59 "../src/Models/StationStore.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 509 "StationStore.c"
			goto __catch0_g_error;
		}
#line 60 "../src/Models/StationStore.vala"
		_tmp3_ = parser;
#line 60 "../src/Models/StationStore.vala"
		_tmp4_ = stream;
#line 60 "../src/Models/StationStore.vala"
		json_parser_load_from_stream (_tmp3_, (GInputStream*) _tmp4_, NULL, &_inner_error0_);
#line 60 "../src/Models/StationStore.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 60 "../src/Models/StationStore.vala"
			_g_object_unref0 (stream);
#line 522 "StationStore.c"
			goto __catch0_g_error;
		}
#line 61 "../src/Models/StationStore.vala"
		_tmp5_ = stream;
#line 61 "../src/Models/StationStore.vala"
		g_input_stream_close ((GInputStream*) _tmp5_, NULL, &_inner_error0_);
#line 61 "../src/Models/StationStore.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 61 "../src/Models/StationStore.vala"
			_g_object_unref0 (stream);
#line 533 "StationStore.c"
			goto __catch0_g_error;
		}
#line 58 "../src/Models/StationStore.vala"
		_g_object_unref0 (stream);
#line 538 "StationStore.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 58 "../src/Models/StationStore.vala"
		e = _inner_error0_;
#line 58 "../src/Models/StationStore.vala"
		_inner_error0_ = NULL;
#line 63 "../src/Models/StationStore.vala"
		_tmp6_ = e;
#line 63 "../src/Models/StationStore.vala"
		_tmp7_ = _tmp6_->message;
#line 63 "../src/Models/StationStore.vala"
		_tmp8_ = string_to_string (_tmp7_);
#line 63 "../src/Models/StationStore.vala"
		_tmp9_ = g_strconcat ("store: unable to load data, does it exist? ", _tmp8_, NULL);
#line 63 "../src/Models/StationStore.vala"
		_tmp10_ = _tmp9_;
#line 63 "../src/Models/StationStore.vala"
		g_warning ("StationStore.vala:63: %s", _tmp10_);
#line 63 "../src/Models/StationStore.vala"
		_g_free0 (_tmp10_);
#line 58 "../src/Models/StationStore.vala"
		_g_error_free0 (e);
#line 569 "StationStore.c"
	}
	__finally0:
#line 58 "../src/Models/StationStore.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 58 "../src/Models/StationStore.vala"
		_g_object_unref0 (parser);
#line 58 "../src/Models/StationStore.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 58 "../src/Models/StationStore.vala"
		g_clear_error (&_inner_error0_);
#line 58 "../src/Models/StationStore.vala"
		return;
#line 582 "StationStore.c"
	}
#line 66 "../src/Models/StationStore.vala"
	_tmp11_ = parser;
#line 66 "../src/Models/StationStore.vala"
	_tmp12_ = json_parser_get_root (_tmp11_);
#line 66 "../src/Models/StationStore.vala"
	_tmp13_ = __vala_JsonNode_copy0 (_tmp12_);
#line 66 "../src/Models/StationStore.vala"
	node = _tmp13_;
#line 67 "../src/Models/StationStore.vala"
	_tmp14_ = json_node_get_array (node);
#line 67 "../src/Models/StationStore.vala"
	_tmp15_ = _json_array_ref0 (_tmp14_);
#line 67 "../src/Models/StationStore.vala"
	array = _tmp15_;
#line 68 "../src/Models/StationStore.vala"
	json_array_foreach_element (array, ___lambda32__json_array_foreach, self);
#line 83 "../src/Models/StationStore.vala"
	_tmp16_ = self->priv->_store;
#line 83 "../src/Models/StationStore.vala"
	_tmp17_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp16_);
#line 83 "../src/Models/StationStore.vala"
	_tmp18_ = _tmp17_;
#line 83 "../src/Models/StationStore.vala"
	_tmp19_ = g_strdup_printf ("%i", _tmp18_);
#line 83 "../src/Models/StationStore.vala"
	_tmp20_ = _tmp19_;
#line 83 "../src/Models/StationStore.vala"
	_tmp21_ = g_strconcat ("loaded store size: ", _tmp20_, NULL);
#line 83 "../src/Models/StationStore.vala"
	_tmp22_ = _tmp21_;
#line 83 "../src/Models/StationStore.vala"
	g_debug ("StationStore.vala:83: %s", _tmp22_);
#line 83 "../src/Models/StationStore.vala"
	_g_free0 (_tmp22_);
#line 83 "../src/Models/StationStore.vala"
	_g_free0 (_tmp20_);
#line 54 "../src/Models/StationStore.vala"
	_json_array_unref0 (array);
#line 54 "../src/Models/StationStore.vala"
	__vala_JsonNode_free0 (node);
#line 54 "../src/Models/StationStore.vala"
	_g_object_unref0 (parser);
#line 626 "StationStore.c"
}

static void
tuner_model_station_store_persist (TunerModelStationStore* self)
{
	gchar* data = NULL;
	gchar* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 86 "../src/Models/StationStore.vala"
	g_return_if_fail (self != NULL);
#line 87 "../src/Models/StationStore.vala"
	g_debug ("StationStore.vala:87: persisting store");
#line 88 "../src/Models/StationStore.vala"
	_tmp0_ = tuner_model_station_store_serialize (self);
#line 88 "../src/Models/StationStore.vala"
	data = _tmp0_;
#line 643 "StationStore.c"
	{
		GFile* _tmp1_;
		GFileOutputStream* stream = NULL;
		GFile* _tmp2_;
		GFileOutputStream* _tmp3_;
		GDataOutputStream* s = NULL;
		GFileOutputStream* _tmp4_;
		GDataOutputStream* _tmp5_;
		GDataOutputStream* _tmp6_;
		const gchar* _tmp7_;
		GDataOutputStream* _tmp8_;
		GDataOutputStream* _tmp9_;
#line 91 "../src/Models/StationStore.vala"
		_tmp1_ = self->priv->_data_file;
#line 91 "../src/Models/StationStore.vala"
		g_file_delete (_tmp1_, NULL, &_inner_error0_);
#line 91 "../src/Models/StationStore.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 662 "StationStore.c"
			goto __catch0_g_error;
		}
#line 92 "../src/Models/StationStore.vala"
		_tmp2_ = self->priv->_data_file;
#line 92 "../src/Models/StationStore.vala"
		_tmp3_ = g_file_create (_tmp2_, G_FILE_CREATE_REPLACE_DESTINATION | G_FILE_CREATE_PRIVATE, NULL, &_inner_error0_);
#line 92 "../src/Models/StationStore.vala"
		stream = _tmp3_;
#line 92 "../src/Models/StationStore.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 673 "StationStore.c"
			goto __catch0_g_error;
		}
#line 95 "../src/Models/StationStore.vala"
		_tmp4_ = stream;
#line 95 "../src/Models/StationStore.vala"
		_tmp5_ = g_data_output_stream_new ((GOutputStream*) _tmp4_);
#line 95 "../src/Models/StationStore.vala"
		s = _tmp5_;
#line 96 "../src/Models/StationStore.vala"
		_tmp6_ = s;
#line 96 "../src/Models/StationStore.vala"
		_tmp7_ = data;
#line 96 "../src/Models/StationStore.vala"
		g_data_output_stream_put_string (_tmp6_, _tmp7_, NULL, &_inner_error0_);
#line 96 "../src/Models/StationStore.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 96 "../src/Models/StationStore.vala"
			_g_object_unref0 (s);
#line 96 "../src/Models/StationStore.vala"
			_g_object_unref0 (stream);
#line 694 "StationStore.c"
			goto __catch0_g_error;
		}
#line 97 "../src/Models/StationStore.vala"
		_tmp8_ = s;
#line 97 "../src/Models/StationStore.vala"
		g_output_stream_flush ((GOutputStream*) _tmp8_, NULL, &_inner_error0_);
#line 97 "../src/Models/StationStore.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 97 "../src/Models/StationStore.vala"
			_g_object_unref0 (s);
#line 97 "../src/Models/StationStore.vala"
			_g_object_unref0 (stream);
#line 707 "StationStore.c"
			goto __catch0_g_error;
		}
#line 98 "../src/Models/StationStore.vala"
		_tmp9_ = s;
#line 98 "../src/Models/StationStore.vala"
		g_output_stream_close ((GOutputStream*) _tmp9_, NULL, &_inner_error0_);
#line 98 "../src/Models/StationStore.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 98 "../src/Models/StationStore.vala"
			_g_object_unref0 (s);
#line 98 "../src/Models/StationStore.vala"
			_g_object_unref0 (stream);
#line 720 "StationStore.c"
			goto __catch0_g_error;
		}
#line 90 "../src/Models/StationStore.vala"
		_g_object_unref0 (s);
#line 90 "../src/Models/StationStore.vala"
		_g_object_unref0 (stream);
#line 727 "StationStore.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp10_;
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
#line 90 "../src/Models/StationStore.vala"
		e = _inner_error0_;
#line 90 "../src/Models/StationStore.vala"
		_inner_error0_ = NULL;
#line 100 "../src/Models/StationStore.vala"
		_tmp10_ = e;
#line 100 "../src/Models/StationStore.vala"
		_tmp11_ = _tmp10_->message;
#line 100 "../src/Models/StationStore.vala"
		_tmp12_ = string_to_string (_tmp11_);
#line 100 "../src/Models/StationStore.vala"
		_tmp13_ = g_strconcat ("store: unable to persist store: ", _tmp12_, NULL);
#line 100 "../src/Models/StationStore.vala"
		_tmp14_ = _tmp13_;
#line 100 "../src/Models/StationStore.vala"
		g_warning ("StationStore.vala:100: %s", _tmp14_);
#line 100 "../src/Models/StationStore.vala"
		_g_free0 (_tmp14_);
#line 90 "../src/Models/StationStore.vala"
		_g_error_free0 (e);
#line 758 "StationStore.c"
	}
	__finally0:
#line 90 "../src/Models/StationStore.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 90 "../src/Models/StationStore.vala"
		_g_free0 (data);
#line 90 "../src/Models/StationStore.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 90 "../src/Models/StationStore.vala"
		g_clear_error (&_inner_error0_);
#line 90 "../src/Models/StationStore.vala"
		return;
#line 771 "StationStore.c"
	}
#line 86 "../src/Models/StationStore.vala"
	_g_free0 (data);
#line 775 "StationStore.c"
}

gchar*
tuner_model_station_store_serialize (TunerModelStationStore* self)
{
	JsonBuilder* builder = NULL;
	JsonBuilder* _tmp0_;
	JsonBuilder* _tmp1_;
	JsonBuilder* _tmp15_;
	JsonGenerator* generator = NULL;
	JsonGenerator* _tmp16_;
	JsonBuilder* _tmp17_;
	JsonNode* _tmp18_;
	JsonNode* _tmp19_;
	gchar* data = NULL;
	gchar* _tmp20_;
	gchar* result;
#line 104 "../src/Models/StationStore.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 105 "../src/Models/StationStore.vala"
	_tmp0_ = json_builder_new ();
#line 105 "../src/Models/StationStore.vala"
	builder = _tmp0_;
#line 106 "../src/Models/StationStore.vala"
	_tmp1_ = builder;
#line 106 "../src/Models/StationStore.vala"
	json_builder_begin_array (_tmp1_);
#line 803 "StationStore.c"
	{
		GeeArrayList* _station_list = NULL;
		GeeArrayList* _tmp2_;
		gint _station_size = 0;
		GeeArrayList* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gint _station_index = 0;
#line 107 "../src/Models/StationStore.vala"
		_tmp2_ = self->priv->_store;
#line 107 "../src/Models/StationStore.vala"
		_station_list = _tmp2_;
#line 107 "../src/Models/StationStore.vala"
		_tmp3_ = _station_list;
#line 107 "../src/Models/StationStore.vala"
		_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 107 "../src/Models/StationStore.vala"
		_tmp5_ = _tmp4_;
#line 107 "../src/Models/StationStore.vala"
		_station_size = _tmp5_;
#line 107 "../src/Models/StationStore.vala"
		_station_index = -1;
#line 107 "../src/Models/StationStore.vala"
		while (TRUE) {
#line 828 "StationStore.c"
			gint _tmp6_;
			gint _tmp7_;
			TunerModelStation* station = NULL;
			GeeArrayList* _tmp8_;
			gpointer _tmp9_;
			JsonNode* node = NULL;
			TunerModelStation* _tmp10_;
			JsonNode* _tmp11_;
			JsonBuilder* _tmp12_;
			JsonNode* _tmp13_;
			JsonNode* _tmp14_;
#line 107 "../src/Models/StationStore.vala"
			_station_index = _station_index + 1;
#line 107 "../src/Models/StationStore.vala"
			_tmp6_ = _station_index;
#line 107 "../src/Models/StationStore.vala"
			_tmp7_ = _station_size;
#line 107 "../src/Models/StationStore.vala"
			if (!(_tmp6_ < _tmp7_)) {
#line 107 "../src/Models/StationStore.vala"
				break;
#line 850 "StationStore.c"
			}
#line 107 "../src/Models/StationStore.vala"
			_tmp8_ = _station_list;
#line 107 "../src/Models/StationStore.vala"
			_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _station_index);
#line 107 "../src/Models/StationStore.vala"
			station = (TunerModelStation*) _tmp9_;
#line 108 "../src/Models/StationStore.vala"
			_tmp10_ = station;
#line 108 "../src/Models/StationStore.vala"
			_tmp11_ = json_gobject_serialize ((GObject*) _tmp10_);
#line 108 "../src/Models/StationStore.vala"
			node = _tmp11_;
#line 109 "../src/Models/StationStore.vala"
			_tmp12_ = builder;
#line 109 "../src/Models/StationStore.vala"
			_tmp13_ = node;
#line 109 "../src/Models/StationStore.vala"
			_tmp14_ = __vala_JsonNode_copy0 (_tmp13_);
#line 109 "../src/Models/StationStore.vala"
			json_builder_add_value (_tmp12_, _tmp14_);
#line 107 "../src/Models/StationStore.vala"
			__vala_JsonNode_free0 (node);
#line 107 "../src/Models/StationStore.vala"
			_g_object_unref0 (station);
#line 876 "StationStore.c"
		}
	}
#line 111 "../src/Models/StationStore.vala"
	_tmp15_ = builder;
#line 111 "../src/Models/StationStore.vala"
	json_builder_end_array (_tmp15_);
#line 113 "../src/Models/StationStore.vala"
	_tmp16_ = json_generator_new ();
#line 113 "../src/Models/StationStore.vala"
	generator = _tmp16_;
#line 114 "../src/Models/StationStore.vala"
	_tmp17_ = builder;
#line 114 "../src/Models/StationStore.vala"
	_tmp18_ = json_builder_get_root (_tmp17_);
#line 114 "../src/Models/StationStore.vala"
	_tmp19_ = _tmp18_;
#line 114 "../src/Models/StationStore.vala"
	json_generator_set_root (generator, _tmp19_);
#line 114 "../src/Models/StationStore.vala"
	__vala_JsonNode_free0 (_tmp19_);
#line 115 "../src/Models/StationStore.vala"
	_tmp20_ = json_generator_to_data (generator, NULL);
#line 115 "../src/Models/StationStore.vala"
	data = _tmp20_;
#line 116 "../src/Models/StationStore.vala"
	result = data;
#line 116 "../src/Models/StationStore.vala"
	_g_object_unref0 (generator);
#line 116 "../src/Models/StationStore.vala"
	_g_object_unref0 (builder);
#line 116 "../src/Models/StationStore.vala"
	return result;
#line 909 "StationStore.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 120 "../src/Models/StationStore.vala"
	return self ? g_object_ref (self) : NULL;
#line 917 "StationStore.c"
}

GeeArrayList*
tuner_model_station_store_get_all (TunerModelStationStore* self)
{
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeArrayList* result;
#line 119 "../src/Models/StationStore.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 120 "../src/Models/StationStore.vala"
	_tmp0_ = self->priv->_store;
#line 120 "../src/Models/StationStore.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 120 "../src/Models/StationStore.vala"
	result = _tmp1_;
#line 120 "../src/Models/StationStore.vala"
	return result;
#line 936 "StationStore.c"
}

gboolean
tuner_model_station_store_contains (TunerModelStationStore* self,
                                    TunerModelStation* station)
{
	gboolean result;
#line 123 "../src/Models/StationStore.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 123 "../src/Models/StationStore.vala"
	g_return_val_if_fail (station != NULL, FALSE);
#line 948 "StationStore.c"
	{
		GeeArrayList* _s_list = NULL;
		GeeArrayList* _tmp0_;
		gint _s_size = 0;
		GeeArrayList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _s_index = 0;
#line 124 "../src/Models/StationStore.vala"
		_tmp0_ = self->priv->_store;
#line 124 "../src/Models/StationStore.vala"
		_s_list = _tmp0_;
#line 124 "../src/Models/StationStore.vala"
		_tmp1_ = _s_list;
#line 124 "../src/Models/StationStore.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 124 "../src/Models/StationStore.vala"
		_tmp3_ = _tmp2_;
#line 124 "../src/Models/StationStore.vala"
		_s_size = _tmp3_;
#line 124 "../src/Models/StationStore.vala"
		_s_index = -1;
#line 124 "../src/Models/StationStore.vala"
		while (TRUE) {
#line 973 "StationStore.c"
			gint _tmp4_;
			gint _tmp5_;
			TunerModelStation* s = NULL;
			GeeArrayList* _tmp6_;
			gpointer _tmp7_;
			TunerModelStation* _tmp8_;
			const gchar* _tmp9_;
			const gchar* _tmp10_;
			const gchar* _tmp11_;
			const gchar* _tmp12_;
#line 124 "../src/Models/StationStore.vala"
			_s_index = _s_index + 1;
#line 124 "../src/Models/StationStore.vala"
			_tmp4_ = _s_index;
#line 124 "../src/Models/StationStore.vala"
			_tmp5_ = _s_size;
#line 124 "../src/Models/StationStore.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 124 "../src/Models/StationStore.vala"
				break;
#line 994 "StationStore.c"
			}
#line 124 "../src/Models/StationStore.vala"
			_tmp6_ = _s_list;
#line 124 "../src/Models/StationStore.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _s_index);
#line 124 "../src/Models/StationStore.vala"
			s = (TunerModelStation*) _tmp7_;
#line 125 "../src/Models/StationStore.vala"
			_tmp8_ = s;
#line 125 "../src/Models/StationStore.vala"
			_tmp9_ = tuner_model_station_get_id (_tmp8_);
#line 125 "../src/Models/StationStore.vala"
			_tmp10_ = _tmp9_;
#line 125 "../src/Models/StationStore.vala"
			_tmp11_ = tuner_model_station_get_id (station);
#line 125 "../src/Models/StationStore.vala"
			_tmp12_ = _tmp11_;
#line 125 "../src/Models/StationStore.vala"
			if (g_strcmp0 (_tmp10_, _tmp12_) == 0) {
#line 126 "../src/Models/StationStore.vala"
				result = TRUE;
#line 126 "../src/Models/StationStore.vala"
				_g_object_unref0 (s);
#line 126 "../src/Models/StationStore.vala"
				return result;
#line 1020 "StationStore.c"
			}
#line 124 "../src/Models/StationStore.vala"
			_g_object_unref0 (s);
#line 1024 "StationStore.c"
		}
	}
#line 129 "../src/Models/StationStore.vala"
	result = FALSE;
#line 129 "../src/Models/StationStore.vala"
	return result;
#line 1031 "StationStore.c"
}

static void
tuner_model_station_store_class_init (TunerModelStationStoreClass * klass,
                                      gpointer klass_data)
{
#line 13 "../src/Models/StationStore.vala"
	tuner_model_station_store_parent_class = g_type_class_peek_parent (klass);
#line 13 "../src/Models/StationStore.vala"
	g_type_class_adjust_private_offset (klass, &TunerModelStationStore_private_offset);
#line 13 "../src/Models/StationStore.vala"
	G_OBJECT_CLASS (klass)->finalize = tuner_model_station_store_finalize;
#line 1044 "StationStore.c"
}

static void
tuner_model_station_store_instance_init (TunerModelStationStore * self,
                                         gpointer klass)
{
#line 13 "../src/Models/StationStore.vala"
	self->priv = tuner_model_station_store_get_instance_private (self);
#line 1053 "StationStore.c"
}

static void
tuner_model_station_store_finalize (GObject * obj)
{
	TunerModelStationStore * self;
#line 13 "../src/Models/StationStore.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUNER_MODEL_TYPE_STATION_STORE, TunerModelStationStore);
#line 14 "../src/Models/StationStore.vala"
	_g_object_unref0 (self->priv->_store);
#line 15 "../src/Models/StationStore.vala"
	_g_object_unref0 (self->priv->_data_file);
#line 13 "../src/Models/StationStore.vala"
	G_OBJECT_CLASS (tuner_model_station_store_parent_class)->finalize (obj);
#line 1068 "StationStore.c"
}

static GType
tuner_model_station_store_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TunerModelStationStoreClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tuner_model_station_store_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TunerModelStationStore), 0, (GInstanceInitFunc) tuner_model_station_store_instance_init, NULL };
	GType tuner_model_station_store_type_id;
	tuner_model_station_store_type_id = g_type_register_static (G_TYPE_OBJECT, "TunerModelStationStore", &g_define_type_info, 0);
	TunerModelStationStore_private_offset = g_type_add_instance_private (tuner_model_station_store_type_id, sizeof (TunerModelStationStorePrivate));
	return tuner_model_station_store_type_id;
}

GType
tuner_model_station_store_get_type (void)
{
	static volatile gsize tuner_model_station_store_type_id__once = 0;
	if (g_once_init_enter (&tuner_model_station_store_type_id__once)) {
		GType tuner_model_station_store_type_id;
		tuner_model_station_store_type_id = tuner_model_station_store_get_type_once ();
		g_once_init_leave (&tuner_model_station_store_type_id__once, tuner_model_station_store_type_id);
	}
	return tuner_model_station_store_type_id__once;
}

