/* Window.c generated by valac 0.56.3, the Vala compiler
 * generated from Window.vala, do not modify */

/*
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: 2020-2022 Louis Brauer <louis@brauer.family>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <granite.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gst/player/player.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>
#include <gee.h>
#include <pango/pango.h>

#define TUNER_WINDOW_WindowName "Tuner"
#define TUNER_WINDOW_ACTION_PREFIX "win."
#define TUNER_WINDOW_ACTION_PAUSE "action_pause"
#define TUNER_WINDOW_ACTION_QUIT "action_quit"
#define TUNER_WINDOW_ACTION_HIDE "action_hide"
#define TUNER_WINDOW_ACTION_ABOUT "action_about"
#define TUNER_WINDOW_ACTION_DISABLE_TRACKING "action_disable_tracking"
#define TUNER_WINDOW_ACTION_ENABLE_AUTOPLAY "action_enable_autoplay"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TUNER_TYPE_WINDOW (tuner_window_get_type ())
#define TUNER_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_WINDOW, TunerWindow))
#define TUNER_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_WINDOW, TunerWindowClass))
#define TUNER_IS_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_WINDOW))
#define TUNER_IS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_WINDOW))
#define TUNER_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_WINDOW, TunerWindowClass))

typedef struct _TunerWindow TunerWindow;
typedef struct _TunerWindowClass TunerWindowClass;
typedef struct _TunerWindowPrivate TunerWindowPrivate;

#define TUNER_TYPE_PLAYER_CONTROLLER (tuner_player_controller_get_type ())
#define TUNER_PLAYER_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_PLAYER_CONTROLLER, TunerPlayerController))
#define TUNER_PLAYER_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_PLAYER_CONTROLLER, TunerPlayerControllerClass))
#define TUNER_IS_PLAYER_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_PLAYER_CONTROLLER))
#define TUNER_IS_PLAYER_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_PLAYER_CONTROLLER))
#define TUNER_PLAYER_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_PLAYER_CONTROLLER, TunerPlayerControllerClass))

typedef struct _TunerPlayerController TunerPlayerController;
typedef struct _TunerPlayerControllerClass TunerPlayerControllerClass;

#define TUNER_TYPE_DIRECTORY_CONTROLLER (tuner_directory_controller_get_type ())
#define TUNER_DIRECTORY_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_DIRECTORY_CONTROLLER, TunerDirectoryController))
#define TUNER_DIRECTORY_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_DIRECTORY_CONTROLLER, TunerDirectoryControllerClass))
#define TUNER_IS_DIRECTORY_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_DIRECTORY_CONTROLLER))
#define TUNER_IS_DIRECTORY_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_DIRECTORY_CONTROLLER))
#define TUNER_DIRECTORY_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_DIRECTORY_CONTROLLER, TunerDirectoryControllerClass))

typedef struct _TunerDirectoryController TunerDirectoryController;
typedef struct _TunerDirectoryControllerClass TunerDirectoryControllerClass;

#define TUNER_TYPE_HEADER_BAR (tuner_header_bar_get_type ())
#define TUNER_HEADER_BAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_HEADER_BAR, TunerHeaderBar))
#define TUNER_HEADER_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_HEADER_BAR, TunerHeaderBarClass))
#define TUNER_IS_HEADER_BAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_HEADER_BAR))
#define TUNER_IS_HEADER_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_HEADER_BAR))
#define TUNER_HEADER_BAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_HEADER_BAR, TunerHeaderBarClass))

typedef struct _TunerHeaderBar TunerHeaderBar;
typedef struct _TunerHeaderBarClass TunerHeaderBarClass;
enum  {
	TUNER_WINDOW_0_PROPERTY,
	TUNER_WINDOW_SETTINGS_PROPERTY,
	TUNER_WINDOW_STACK_PROPERTY,
	TUNER_WINDOW_PLAYER_PROPERTY,
	TUNER_WINDOW_NUM_PROPERTIES
};
static GParamSpec* tuner_window_properties[TUNER_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TUNER_TYPE_APPLICATION (tuner_application_get_type ())
#define TUNER_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_APPLICATION, TunerApplication))
#define TUNER_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_APPLICATION, TunerApplicationClass))
#define TUNER_IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_APPLICATION))
#define TUNER_IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_APPLICATION))
#define TUNER_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_APPLICATION, TunerApplicationClass))

typedef struct _TunerApplication TunerApplication;
typedef struct _TunerApplicationClass TunerApplicationClass;

#define TUNER_TYPE_CONTENT_BOX (tuner_content_box_get_type ())
#define TUNER_CONTENT_BOX(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_CONTENT_BOX, TunerContentBox))
#define TUNER_CONTENT_BOX_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_CONTENT_BOX, TunerContentBoxClass))
#define TUNER_IS_CONTENT_BOX(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_CONTENT_BOX))
#define TUNER_IS_CONTENT_BOX_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_CONTENT_BOX))
#define TUNER_CONTENT_BOX_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_CONTENT_BOX, TunerContentBoxClass))

typedef struct _TunerContentBox TunerContentBox;
typedef struct _TunerContentBoxClass TunerContentBoxClass;
typedef struct _Block10Data Block10Data;

#define TUNER_TYPE_ABSTRACT_CONTENT_LIST (tuner_abstract_content_list_get_type ())
#define TUNER_ABSTRACT_CONTENT_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_ABSTRACT_CONTENT_LIST, TunerAbstractContentList))
#define TUNER_ABSTRACT_CONTENT_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_ABSTRACT_CONTENT_LIST, TunerAbstractContentListClass))
#define TUNER_IS_ABSTRACT_CONTENT_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_ABSTRACT_CONTENT_LIST))
#define TUNER_IS_ABSTRACT_CONTENT_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_ABSTRACT_CONTENT_LIST))
#define TUNER_ABSTRACT_CONTENT_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_ABSTRACT_CONTENT_LIST, TunerAbstractContentListClass))

typedef struct _TunerAbstractContentList TunerAbstractContentList;
typedef struct _TunerAbstractContentListClass TunerAbstractContentListClass;
#define _g_free0(var) (var = (g_free (var), NULL))

#define TUNER_TYPE_ABOUT_DIALOG (tuner_about_dialog_get_type ())
#define TUNER_ABOUT_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_ABOUT_DIALOG, TunerAboutDialog))
#define TUNER_ABOUT_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_ABOUT_DIALOG, TunerAboutDialogClass))
#define TUNER_IS_ABOUT_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_ABOUT_DIALOG))
#define TUNER_IS_ABOUT_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_ABOUT_DIALOG))
#define TUNER_ABOUT_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_ABOUT_DIALOG, TunerAboutDialogClass))

typedef struct _TunerAboutDialog TunerAboutDialog;
typedef struct _TunerAboutDialogClass TunerAboutDialogClass;

#define TUNER_MODEL_TYPE_STATION (tuner_model_station_get_type ())
#define TUNER_MODEL_STATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_MODEL_TYPE_STATION, TunerModelStation))
#define TUNER_MODEL_STATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_MODEL_TYPE_STATION, TunerModelStationClass))
#define TUNER_MODEL_IS_STATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_MODEL_TYPE_STATION))
#define TUNER_MODEL_IS_STATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_MODEL_TYPE_STATION))
#define TUNER_MODEL_STATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_MODEL_TYPE_STATION, TunerModelStationClass))

typedef struct _TunerModelStation TunerModelStation;
typedef struct _TunerModelStationClass TunerModelStationClass;
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
typedef enum  {
	TUNER_HEADER_BAR_PLAY_STATE_PAUSE_ACTIVE,
	TUNER_HEADER_BAR_PLAY_STATE_PAUSE_INACTIVE,
	TUNER_HEADER_BAR_PLAY_STATE_PLAY_ACTIVE,
	TUNER_HEADER_BAR_PLAY_STATE_PLAY_INACTIVE
} TunerHeaderBarPlayState;

#define TUNER_HEADER_BAR_TYPE_PLAY_STATE (tuner_header_bar_play_state_get_type ())

#define TUNER_TYPE_STATION_SOURCE (tuner_station_source_get_type ())
#define TUNER_STATION_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_STATION_SOURCE, TunerStationSource))
#define TUNER_STATION_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_STATION_SOURCE, TunerStationSourceClass))
#define TUNER_IS_STATION_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_STATION_SOURCE))
#define TUNER_IS_STATION_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_STATION_SOURCE))
#define TUNER_STATION_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_STATION_SOURCE, TunerStationSourceClass))

typedef struct _TunerStationSource TunerStationSource;
typedef struct _TunerStationSourceClass TunerStationSourceClass;

#define TUNER_TYPE_STATION_LIST (tuner_station_list_get_type ())
#define TUNER_STATION_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_STATION_LIST, TunerStationList))
#define TUNER_STATION_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_STATION_LIST, TunerStationListClass))
#define TUNER_IS_STATION_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_STATION_LIST))
#define TUNER_IS_STATION_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_STATION_LIST))
#define TUNER_STATION_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_STATION_LIST, TunerStationListClass))

typedef struct _TunerStationList TunerStationList;
typedef struct _TunerStationListClass TunerStationListClass;
typedef struct _Block11Data Block11Data;
typedef struct _TunerHeaderBarPrivate TunerHeaderBarPrivate;

#define TUNER_MODEL_TYPE_STATION_STORE (tuner_model_station_store_get_type ())
#define TUNER_MODEL_STATION_STORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_MODEL_TYPE_STATION_STORE, TunerModelStationStore))
#define TUNER_MODEL_STATION_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_MODEL_TYPE_STATION_STORE, TunerModelStationStoreClass))
#define TUNER_MODEL_IS_STATION_STORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_MODEL_TYPE_STATION_STORE))
#define TUNER_MODEL_IS_STATION_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_MODEL_TYPE_STATION_STORE))
#define TUNER_MODEL_STATION_STORE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_MODEL_TYPE_STATION_STORE, TunerModelStationStoreClass))

typedef struct _TunerModelStationStore TunerModelStationStore;
typedef struct _TunerModelStationStoreClass TunerModelStationStoreClass;

#define TYPE_SOURCE_ERROR (source_error_get_type ())
typedef struct _Block12Data Block12Data;
typedef struct _TunerContentBoxPrivate TunerContentBoxPrivate;

#define TUNER_TYPE_HEADER_LABEL (tuner_header_label_get_type ())
#define TUNER_HEADER_LABEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_HEADER_LABEL, TunerHeaderLabel))
#define TUNER_HEADER_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_HEADER_LABEL, TunerHeaderLabelClass))
#define TUNER_IS_HEADER_LABEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_HEADER_LABEL))
#define TUNER_IS_HEADER_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_HEADER_LABEL))
#define TUNER_HEADER_LABEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_HEADER_LABEL, TunerHeaderLabelClass))

typedef struct _TunerHeaderLabel TunerHeaderLabel;
typedef struct _TunerHeaderLabelClass TunerHeaderLabelClass;

#define TUNER_MODEL_TYPE_GENRE (tuner_model_genre_get_type ())
#define TUNER_MODEL_GENRE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_MODEL_TYPE_GENRE, TunerModelGenre))
#define TUNER_MODEL_GENRE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_MODEL_TYPE_GENRE, TunerModelGenreClass))
#define TUNER_MODEL_IS_GENRE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_MODEL_TYPE_GENRE))
#define TUNER_MODEL_IS_GENRE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_MODEL_TYPE_GENRE))
#define TUNER_MODEL_GENRE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_MODEL_TYPE_GENRE, TunerModelGenreClass))

typedef struct _TunerModelGenre TunerModelGenre;
typedef struct _TunerModelGenreClass TunerModelGenreClass;
typedef struct _Block13Data Block13Data;
typedef struct _TunerModelGenrePrivate TunerModelGenrePrivate;
#define _tuner_model_genre_unref0(var) ((var == NULL) ? NULL : (var = (tuner_model_genre_unref (var), NULL)))
enum  {
	TUNER_WINDOW_REFRESH_FAVOURITES_SIGNAL,
	TUNER_WINDOW_NUM_SIGNALS
};
static guint tuner_window_signals[TUNER_WINDOW_NUM_SIGNALS] = {0};

struct _TunerWindow {
	GtkApplicationWindow parent_instance;
	TunerWindowPrivate * priv;
};

struct _TunerWindowClass {
	GtkApplicationWindowClass parent_class;
};

struct _TunerWindowPrivate {
	GSettings* _settings;
	GtkStack* _stack;
	TunerPlayerController* _player;
	TunerDirectoryController* _directory;
	TunerHeaderBar* headerbar;
	GraniteWidgetsSourceList* source_list;
};

struct _Block10Data {
	int _ref_count_;
	TunerWindow* self;
	TunerContentBox* c;
	GraniteWidgetsSourceListItem* item;
	GraniteWidgetsSourceList* source_list;
};

struct _Block11Data {
	int _ref_count_;
	TunerWindow* self;
	GtkStack* stack;
	GraniteWidgetsSourceListExpandableItem* selections_category;
	TunerContentBox* c1;
	TunerStationSource* s1;
	TunerContentBox* c2;
	TunerStationSource* s2;
	TunerContentBox* c3;
	TunerStationSource* s3;
	GraniteWidgetsSourceListItem* item4;
	TunerContentBox* c_country;
	TunerStationList* c_slist;
	TunerContentBox* c4;
	TunerContentBox* c5;
};

struct _TunerHeaderBar {
	GtkHeaderBar parent_instance;
	TunerHeaderBarPrivate * priv;
	GtkVolumeButton* volume_button;
};

struct _TunerHeaderBarClass {
	GtkHeaderBarClass parent_class;
};

typedef enum  {
	SOURCE_ERROR_UNAVAILABLE
} SourceError;
#define SOURCE_ERROR source_error_quark ()

struct _Block12Data {
	int _ref_count_;
	Block11Data * _data11_;
	TunerStationSource* s_country;
};

struct _TunerContentBox {
	GtkBox parent_instance;
	TunerContentBoxPrivate * priv;
	TunerHeaderLabel* header_label;
};

struct _TunerContentBoxClass {
	GtkBoxClass parent_class;
};

struct _Block13Data {
	int _ref_count_;
	Block11Data * _data11_;
	TunerContentBox* cb;
	TunerStationSource* ds;
};

struct _TunerModelGenre {
	GTypeInstance parent_instance;
	volatile int ref_count;
	TunerModelGenrePrivate * priv;
	gchar* name;
	gchar** tags;
	gint tags_length1;
};

struct _TunerModelGenreClass {
	GTypeClass parent_class;
	void (*finalize) (TunerModelGenre *self);
};

static gint TunerWindow_private_offset;
static gpointer tuner_window_parent_class = NULL;

VALA_EXTERN GType tuner_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerWindow, g_object_unref)
VALA_EXTERN GType tuner_player_controller_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerPlayerController, g_object_unref)
VALA_EXTERN GType tuner_directory_controller_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerDirectoryController, g_object_unref)
VALA_EXTERN GType tuner_header_bar_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerHeaderBar, g_object_unref)
VALA_EXTERN void tuner_window_on_toggle_playback (TunerWindow* self);
static void _tuner_window_on_toggle_playback_gsimple_action_activate_callback (GSimpleAction* action,
                                                                        GVariant* parameter,
                                                                        gpointer self);
static void tuner_window_on_action_quit (TunerWindow* self);
static void _tuner_window_on_action_quit_gsimple_action_activate_callback (GSimpleAction* action,
                                                                    GVariant* parameter,
                                                                    gpointer self);
static void tuner_window_on_action_about (TunerWindow* self);
static void _tuner_window_on_action_about_gsimple_action_activate_callback (GSimpleAction* action,
                                                                     GVariant* parameter,
                                                                     gpointer self);
VALA_EXTERN void tuner_window_on_action_disable_tracking (TunerWindow* self,
                                              GSimpleAction* action,
                                              GVariant* parameter);
static void _tuner_window_on_action_disable_tracking_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                GVariant* parameter,
                                                                                gpointer self);
VALA_EXTERN void tuner_window_on_action_enable_autoplay (TunerWindow* self,
                                             GSimpleAction* action,
                                             GVariant* parameter);
static void _tuner_window_on_action_enable_autoplay_gsimple_action_activate_callback (GSimpleAction* action,
                                                                               GVariant* parameter,
                                                                               gpointer self);
VALA_EXTERN GType tuner_application_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerApplication, g_object_unref)
VALA_EXTERN TunerWindow* tuner_window_new (TunerApplication* app,
                               TunerPlayerController* player);
VALA_EXTERN TunerWindow* tuner_window_construct (GType object_type,
                                     TunerApplication* app,
                                     TunerPlayerController* player);
VALA_EXTERN TunerApplication* tuner_application_get_instance (void);
VALA_EXTERN GSettings* tuner_application_get_settings (TunerApplication* self);
VALA_EXTERN GType tuner_content_box_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerContentBox, g_object_unref)
static TunerContentBox* tuner_window_create_content_box (TunerWindow* self,
                                                  const gchar* name,
                                                  GraniteWidgetsSourceListItem* item,
                                                  const gchar* full_title,
                                                  const gchar* action_icon_name,
                                                  const gchar* action_tooltip_text,
                                                  GtkStack* stack,
                                                  GraniteWidgetsSourceList* source_list,
                                                  gboolean enable_count);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
VALA_EXTERN TunerContentBox* tuner_content_box_new (GtkImage* icon,
                                        const gchar* title,
                                        const gchar* subtitle,
                                        const gchar* action_icon_name,
                                        const gchar* action_tooltip_text);
VALA_EXTERN TunerContentBox* tuner_content_box_construct (GType object_type,
                                              GtkImage* icon,
                                              const gchar* title,
                                              const gchar* subtitle,
                                              const gchar* action_icon_name,
                                              const gchar* action_tooltip_text);
static void __lambda20_ (Block10Data* _data10_);
static void ___lambda20__gtk_widget_map (GtkWidget* _sender,
                                  gpointer self);
static void ___lambda21_ (Block10Data* _data10_);
VALA_EXTERN GType tuner_abstract_content_list_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerAbstractContentList, g_object_unref)
VALA_EXTERN TunerAbstractContentList* tuner_content_box_get_content (TunerContentBox* self);
VALA_EXTERN guint tuner_abstract_content_list_get_item_count (TunerAbstractContentList* self);
static void ____lambda21__tuner_content_box_content_changed (TunerContentBox* _sender,
                                                      gpointer self);
static void tuner_window_adjust_theme (void);
VALA_EXTERN GType tuner_about_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerAboutDialog, g_object_unref)
VALA_EXTERN TunerAboutDialog* tuner_about_dialog_new (GtkWindow* window);
VALA_EXTERN TunerAboutDialog* tuner_about_dialog_construct (GType object_type,
                                                GtkWindow* window);
VALA_EXTERN GType tuner_model_station_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerModelStation, g_object_unref)
VALA_EXTERN void tuner_window_handle_station_click (TunerWindow* self,
                                        TunerModelStation* station);
VALA_EXTERN const gchar* tuner_model_station_get_title (TunerModelStation* self);
VALA_EXTERN void tuner_directory_controller_count_station_click (TunerDirectoryController* self,
                                                     TunerModelStation* station);
VALA_EXTERN TunerPlayerController* tuner_window_get_player (TunerWindow* self);
VALA_EXTERN void tuner_player_controller_set_station (TunerPlayerController* self,
                                          TunerModelStation* value);
VALA_EXTERN const gchar* tuner_model_station_get_id (TunerModelStation* self);
VALA_EXTERN GSettings* tuner_window_get_settings (TunerWindow* self);
VALA_EXTERN void tuner_window_handle_favourites_changed (TunerWindow* self);
VALA_EXTERN void tuner_player_controller_play_pause (TunerPlayerController* self);
static GVariant* _variant_new6 (gboolean value);
static GVariant* _variant_new7 (gboolean value);
VALA_EXTERN void tuner_window_handleplayer_state_changed (TunerWindow* self,
                                              GstPlayerState state);
static gboolean ___lambda22_ (TunerWindow* self);
VALA_EXTERN GType tuner_header_bar_play_state_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void tuner_header_bar_set_playstate (TunerHeaderBar* self,
                                     TunerHeaderBarPlayState state);
static gboolean ____lambda22__gsource_func (gpointer self);
static gboolean ___lambda23_ (TunerWindow* self);
VALA_EXTERN gboolean tuner_player_controller_can_play (TunerPlayerController* self);
static gboolean ____lambda23__gsource_func (gpointer self);
static gboolean ___lambda24_ (TunerWindow* self);
static gboolean ____lambda24__gsource_func (gpointer self);
static gboolean ___lambda25_ (TunerWindow* self);
static gboolean ____lambda25__gsource_func (gpointer self);
VALA_EXTERN gboolean tuner_window_before_destroy (TunerWindow* self);
VALA_EXTERN GstPlayerState* tuner_player_controller_get_current_state (TunerPlayerController* self);
static gboolean _gst_player_state_equal (const GstPlayerState * s1,
                                  const GstPlayerState * s2);
static void tuner_window_set_settings (TunerWindow* self,
                                GSettings* value);
VALA_EXTERN GtkStack* tuner_window_get_stack (TunerWindow* self);
VALA_EXTERN void tuner_window_set_stack (TunerWindow* self,
                             GtkStack* value);
static void tuner_window_set_player (TunerWindow* self,
                              TunerPlayerController* value);
static GObject * tuner_window_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties);
VALA_EXTERN GType tuner_station_source_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerStationSource, g_object_unref)
VALA_EXTERN GType tuner_station_list_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerStationList, g_object_unref)
static Block11Data* block11_data_ref (Block11Data* _data11_);
static void block11_data_unref (void * _userdata_);
VALA_EXTERN TunerHeaderBar* tuner_header_bar_new (void);
VALA_EXTERN TunerHeaderBar* tuner_header_bar_construct (GType object_type);
static void _tuner_window_handleplayer_state_changed_tuner_player_controller_state_changed (TunerPlayerController* _sender,
                                                                                     GstPlayerState state,
                                                                                     gpointer self);
VALA_EXTERN void tuner_header_bar_update_from_station (TunerHeaderBar* self,
                                           TunerModelStation* station);
static void _tuner_header_bar_update_from_station_tuner_player_controller_station_changed (TunerPlayerController* _sender,
                                                                                    TunerModelStation* station,
                                                                                    gpointer self);
static void _tuner_window___lambda26_ (TunerWindow* self,
                                const gchar* title);
VALA_EXTERN void tuner_header_bar_set_subtitle (TunerHeaderBar* self,
                                    const gchar* value);
static void __tuner_window___lambda26__tuner_player_controller_title_changed (TunerPlayerController* _sender,
                                                                       const gchar* title,
                                                                       gpointer self);
static void _tuner_window___lambda27_ (TunerWindow* self,
                                gdouble volume);
static void __tuner_window___lambda27__tuner_player_controller_volume_changed (TunerPlayerController* _sender,
                                                                        gdouble volume,
                                                                        gpointer self);
static void _tuner_window___lambda28_ (TunerWindow* self,
                                gdouble value);
VALA_EXTERN void tuner_player_controller_set_volume (TunerPlayerController* self,
                                         gdouble value);
static void __tuner_window___lambda28__gtk_scale_button_value_changed (GtkScaleButton* _sender,
                                                                gdouble value,
                                                                gpointer self);
static void _tuner_window___lambda29_ (TunerWindow* self,
                                const gchar* key);
static void __tuner_window___lambda29__g_settings_changed (GSettings* _sender,
                                                    const gchar* key,
                                                    gpointer self);
static void _tuner_window___lambda30_ (TunerWindow* self,
                                GParamSpec* key);
static void __tuner_window___lambda30__g_object_notify (GObject* _sender,
                                                 GParamSpec* pspec,
                                                 gpointer self);
static GVariant* _variant_new8 (gboolean value);
static GVariant* _variant_new9 (gboolean value);
static gboolean _tuner_window___lambda31_ (TunerWindow* self,
                                    GdkEventAny* e);
static gboolean __tuner_window___lambda31__gtk_widget_delete_event (GtkWidget* _sender,
                                                             GdkEventAny* event,
                                                             gpointer self);
VALA_EXTERN const gchar* tuner_application_get_data_dir (TunerApplication* self);
VALA_EXTERN GType tuner_model_station_store_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerModelStationStore, g_object_unref)
VALA_EXTERN TunerModelStationStore* tuner_model_station_store_new (const gchar* data_path);
VALA_EXTERN TunerModelStationStore* tuner_model_station_store_construct (GType object_type,
                                                             const gchar* data_path);
VALA_EXTERN TunerDirectoryController* tuner_directory_controller_new (TunerModelStationStore* store);
VALA_EXTERN TunerDirectoryController* tuner_directory_controller_construct (GType object_type,
                                                                TunerModelStationStore* store);
VALA_EXTERN TunerStationSource* tuner_directory_controller_load_random_stations (TunerDirectoryController* self,
                                                                     guint limit);
static void _tuner_window___lambda36_ (Block11Data* _data11_);
VALA_EXTERN GQuark source_error_quark (void);
GType source_error_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GeeArrayList* tuner_station_source_next (TunerStationSource* self,
                                         GError** error);
VALA_EXTERN TunerStationList* tuner_station_list_new_with_stations (GeeArrayList* stations);
VALA_EXTERN TunerStationList* tuner_station_list_construct_with_stations (GType object_type,
                                                              GeeArrayList* stations);
static void _tuner_window_handle_station_click_tuner_station_list_selection_changed (TunerStationList* _sender,
                                                                              TunerModelStation* station,
                                                                              gpointer self);
static void _tuner_window_handle_favourites_changed_tuner_station_list_favourites_changed (TunerStationList* _sender,
                                                                                    gpointer self);
VALA_EXTERN void tuner_content_box_set_content (TunerContentBox* self,
                                    TunerAbstractContentList* value);
VALA_EXTERN void tuner_content_box_show_alert (TunerContentBox* self);
static void __tuner_window___lambda36__gtk_widget_realize (GtkWidget* _sender,
                                                    gpointer self);
static void _tuner_window___lambda43_ (Block11Data* _data11_);
static void __tuner_window___lambda43__tuner_content_box_action_activated (TunerContentBox* _sender,
                                                                    gpointer self);
VALA_EXTERN TunerStationSource* tuner_directory_controller_load_trending_stations (TunerDirectoryController* self,
                                                                       guint limit);
static void _tuner_window___lambda44_ (Block11Data* _data11_);
static void __tuner_window___lambda44__gtk_widget_realize (GtkWidget* _sender,
                                                    gpointer self);
VALA_EXTERN TunerStationSource* tuner_directory_controller_load_popular_stations (TunerDirectoryController* self,
                                                                      guint limit);
static void _tuner_window___lambda45_ (Block11Data* _data11_);
static void __tuner_window___lambda45__gtk_widget_realize (GtkWidget* _sender,
                                                    gpointer self);
VALA_EXTERN TunerStationList* tuner_station_list_new (void);
VALA_EXTERN TunerStationList* tuner_station_list_construct (GType object_type);
VALA_EXTERN void tuner_location_discovery_country_code (GAsyncReadyCallback _callback_,
                                            gpointer _user_data_);
VALA_EXTERN gchar* tuner_location_discovery_country_code_finish (GAsyncResult* _res_,
                                                     GError** error);
static void _tuner_window___lambda46_ (Block11Data* _data11_,
                                GObject* obj,
                                GAsyncResult* res);
static Block12Data* block12_data_ref (Block12Data* _data12_);
static void block12_data_unref (void * _userdata_);
VALA_EXTERN gchar* tuner_model_countries_get_by_code (const gchar* code,
                                          const gchar* fallback);
VALA_EXTERN GType tuner_header_label_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerHeaderLabel, g_object_unref)
VALA_EXTERN TunerStationSource* tuner_directory_controller_load_by_country (TunerDirectoryController* self,
                                                                guint limit,
                                                                const gchar* countrycode);
static void __lambda47_ (Block12Data* _data12_);
VALA_EXTERN void tuner_station_list_set_stations (TunerStationList* self,
                                      GeeArrayList* value);
static void ___lambda47__gtk_widget_realize (GtkWidget* _sender,
                                      gpointer self);
static void __tuner_window___lambda46__gasync_ready_callback (GObject* source_object,
                                                       GAsyncResult* res,
                                                       gpointer self);
VALA_EXTERN GeeArrayList* tuner_directory_controller_get_stored (TunerDirectoryController* self);
VALA_EXTERN gpointer tuner_model_genre_ref (gpointer instance);
VALA_EXTERN void tuner_model_genre_unref (gpointer instance);
VALA_EXTERN GParamSpec* tuner_model_param_spec_genre (const gchar* name,
                                          const gchar* nick,
                                          const gchar* blurb,
                                          GType object_type,
                                          GParamFlags flags);
VALA_EXTERN void tuner_model_value_set_genre (GValue* value,
                                  gpointer v_object);
VALA_EXTERN void tuner_model_value_take_genre (GValue* value,
                                   gpointer v_object);
VALA_EXTERN gpointer tuner_model_value_get_genre (const GValue* value);
VALA_EXTERN GType tuner_model_genre_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerModelGenre, tuner_model_genre_unref)
VALA_EXTERN TunerModelGenre** tuner_model_genres (gint* result_length1);
static Block13Data* block13_data_ref (Block13Data* _data13_);
static void block13_data_unref (void * _userdata_);
static gchar** _vala_array_dup8 (gchar** self,
                          gssize length);
VALA_EXTERN TunerStationSource* tuner_directory_controller_load_by_tags (TunerDirectoryController* self,
                                                             GeeArrayList* utags);
static void _tuner_window_____lambda48_ (Block13Data* _data13_);
static void __tuner_window_____lambda48__gtk_widget_realize (GtkWidget* _sender,
                                                      gpointer self);
static void _tuner_window___lambda49_ (TunerWindow* self,
                                gboolean starred);
VALA_EXTERN TunerModelStation* tuner_player_controller_get_station (TunerPlayerController* self);
VALA_EXTERN void tuner_model_station_toggle_starred (TunerModelStation* self);
static void __tuner_window___lambda49__tuner_header_bar_star_clicked (TunerHeaderBar* _sender,
                                                               gboolean starred,
                                                               gpointer self);
static void _tuner_window___lambda50_ (Block11Data* _data11_);
static void __tuner_window___lambda50__tuner_window_refresh_favourites (TunerWindow* _sender,
                                                                 gpointer self);
static void _tuner_window___lambda51_ (Block11Data* _data11_,
                                GraniteWidgetsSourceListItem* item);
static void __tuner_window___lambda51__granite_widgets_source_list_item_selected (GraniteWidgetsSourceList* _sender,
                                                                           GraniteWidgetsSourceListItem* item,
                                                                           gpointer self);
static void _tuner_window___lambda52_ (Block11Data* _data11_,
                                const gchar* text);
VALA_EXTERN TunerStationSource* tuner_directory_controller_load_search_stations (TunerDirectoryController* self,
                                                                     gchar* utext,
                                                                     guint limit);
VALA_EXTERN void tuner_content_box_show_nothing_found (TunerContentBox* self);
static void __tuner_window___lambda52__tuner_header_bar_searched_for (TunerHeaderBar* _sender,
                                                               const gchar* text,
                                                               gpointer self);
static void _tuner_window___lambda53_ (Block11Data* _data11_);
static void __tuner_window___lambda53__tuner_header_bar_search_focused (TunerHeaderBar* _sender,
                                                                 gpointer self);
VALA_EXTERN TunerStationSource* tuner_directory_controller_load_station_uuid (TunerDirectoryController* self,
                                                                  const gchar* uuid);
static void tuner_window_finalize (GObject * obj);
static GType tuner_window_get_type_once (void);
static void _vala_tuner_window_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_tuner_window_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static const GActionEntry TUNER_WINDOW_ACTION_ENTRIES[5] = {{TUNER_WINDOW_ACTION_PAUSE, _tuner_window_on_toggle_playback_gsimple_action_activate_callback}, {TUNER_WINDOW_ACTION_QUIT, _tuner_window_on_action_quit_gsimple_action_activate_callback}, {TUNER_WINDOW_ACTION_ABOUT, _tuner_window_on_action_about_gsimple_action_activate_callback}, {TUNER_WINDOW_ACTION_DISABLE_TRACKING, _tuner_window_on_action_disable_tracking_gsimple_action_activate_callback, NULL, "false"}, {TUNER_WINDOW_ACTION_ENABLE_AUTOPLAY, _tuner_window_on_action_enable_autoplay_gsimple_action_activate_callback, NULL, "false"}};

static inline gpointer
tuner_window_get_instance_private (TunerWindow* self)
{
	return G_STRUCT_MEMBER_P (self, TunerWindow_private_offset);
}

static void
_tuner_window_on_toggle_playback_gsimple_action_activate_callback (GSimpleAction* action,
                                                                   GVariant* parameter,
                                                                   gpointer self)
{
#line 29 "../src/Widgets/Window.vala"
	tuner_window_on_toggle_playback ((TunerWindow*) self);
#line 650 "Window.c"
}

static void
_tuner_window_on_action_quit_gsimple_action_activate_callback (GSimpleAction* action,
                                                               GVariant* parameter,
                                                               gpointer self)
{
#line 29 "../src/Widgets/Window.vala"
	tuner_window_on_action_quit ((TunerWindow*) self);
#line 660 "Window.c"
}

static void
_tuner_window_on_action_about_gsimple_action_activate_callback (GSimpleAction* action,
                                                                GVariant* parameter,
                                                                gpointer self)
{
#line 29 "../src/Widgets/Window.vala"
	tuner_window_on_action_about ((TunerWindow*) self);
#line 670 "Window.c"
}

static void
_tuner_window_on_action_disable_tracking_gsimple_action_activate_callback (GSimpleAction* action,
                                                                           GVariant* parameter,
                                                                           gpointer self)
{
#line 29 "../src/Widgets/Window.vala"
	tuner_window_on_action_disable_tracking ((TunerWindow*) self, action, parameter);
#line 680 "Window.c"
}

static void
_tuner_window_on_action_enable_autoplay_gsimple_action_activate_callback (GSimpleAction* action,
                                                                          GVariant* parameter,
                                                                          gpointer self)
{
#line 29 "../src/Widgets/Window.vala"
	tuner_window_on_action_enable_autoplay ((TunerWindow*) self, action, parameter);
#line 690 "Window.c"
}

TunerWindow*
tuner_window_construct (GType object_type,
                        TunerApplication* app,
                        TunerPlayerController* player)
{
	TunerWindow * self = NULL;
	TunerApplication* _tmp0_;
	TunerApplication* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	GtkApplication* _tmp4_;
	GtkApplication* _tmp5_;
	gchar* _tmp6_;
	gchar** _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	GtkApplication* _tmp9_;
	GtkApplication* _tmp10_;
	gchar* _tmp11_;
	gchar** _tmp12_;
	gchar** _tmp13_;
	gint _tmp13__length1;
	GtkApplication* _tmp14_;
	GtkApplication* _tmp15_;
	gchar* _tmp16_;
	gchar** _tmp17_;
	gchar** _tmp18_;
	gint _tmp18__length1;
#line 47 "../src/Widgets/Window.vala"
	g_return_val_if_fail (app != NULL, NULL);
#line 47 "../src/Widgets/Window.vala"
	g_return_val_if_fail (player != NULL, NULL);
#line 48 "../src/Widgets/Window.vala"
	_tmp0_ = tuner_application_get_instance ();
#line 48 "../src/Widgets/Window.vala"
	_tmp1_ = _tmp0_;
#line 48 "../src/Widgets/Window.vala"
	_tmp2_ = tuner_application_get_settings (_tmp1_);
#line 48 "../src/Widgets/Window.vala"
	_tmp3_ = _tmp2_;
#line 48 "../src/Widgets/Window.vala"
	self = (TunerWindow*) g_object_new (object_type, "application", app, "player", player, "settings", _tmp3_, NULL);
#line 54 "../src/Widgets/Window.vala"
	_tmp4_ = gtk_window_get_application ((GtkWindow*) self);
#line 54 "../src/Widgets/Window.vala"
	_tmp5_ = _tmp4_;
#line 54 "../src/Widgets/Window.vala"
	_tmp6_ = g_strdup ("<Control>5");
#line 54 "../src/Widgets/Window.vala"
	_tmp7_ = g_new0 (gchar*, 1 + 1);
#line 54 "../src/Widgets/Window.vala"
	_tmp7_[0] = _tmp6_;
#line 54 "../src/Widgets/Window.vala"
	_tmp8_ = _tmp7_;
#line 54 "../src/Widgets/Window.vala"
	_tmp8__length1 = 1;
#line 54 "../src/Widgets/Window.vala"
	gtk_application_set_accels_for_action (_tmp5_, TUNER_WINDOW_ACTION_PREFIX TUNER_WINDOW_ACTION_PAUSE, _tmp8_);
#line 54 "../src/Widgets/Window.vala"
	_tmp8_ = (_vala_array_free (_tmp8_, _tmp8__length1, (GDestroyNotify) g_free), NULL);
#line 55 "../src/Widgets/Window.vala"
	_tmp9_ = gtk_window_get_application ((GtkWindow*) self);
#line 55 "../src/Widgets/Window.vala"
	_tmp10_ = _tmp9_;
#line 55 "../src/Widgets/Window.vala"
	_tmp11_ = g_strdup ("<Control>q");
#line 55 "../src/Widgets/Window.vala"
	_tmp12_ = g_new0 (gchar*, 1 + 1);
#line 55 "../src/Widgets/Window.vala"
	_tmp12_[0] = _tmp11_;
#line 55 "../src/Widgets/Window.vala"
	_tmp13_ = _tmp12_;
#line 55 "../src/Widgets/Window.vala"
	_tmp13__length1 = 1;
#line 55 "../src/Widgets/Window.vala"
	gtk_application_set_accels_for_action (_tmp10_, TUNER_WINDOW_ACTION_PREFIX TUNER_WINDOW_ACTION_QUIT, _tmp13_);
#line 55 "../src/Widgets/Window.vala"
	_tmp13_ = (_vala_array_free (_tmp13_, _tmp13__length1, (GDestroyNotify) g_free), NULL);
#line 56 "../src/Widgets/Window.vala"
	_tmp14_ = gtk_window_get_application ((GtkWindow*) self);
#line 56 "../src/Widgets/Window.vala"
	_tmp15_ = _tmp14_;
#line 56 "../src/Widgets/Window.vala"
	_tmp16_ = g_strdup ("<Control>w");
#line 56 "../src/Widgets/Window.vala"
	_tmp17_ = g_new0 (gchar*, 1 + 1);
#line 56 "../src/Widgets/Window.vala"
	_tmp17_[0] = _tmp16_;
#line 56 "../src/Widgets/Window.vala"
	_tmp18_ = _tmp17_;
#line 56 "../src/Widgets/Window.vala"
	_tmp18__length1 = 1;
#line 56 "../src/Widgets/Window.vala"
	gtk_application_set_accels_for_action (_tmp15_, TUNER_WINDOW_ACTION_PREFIX TUNER_WINDOW_ACTION_QUIT, _tmp18_);
#line 56 "../src/Widgets/Window.vala"
	_tmp18_ = (_vala_array_free (_tmp18_, _tmp18__length1, (GDestroyNotify) g_free), NULL);
#line 47 "../src/Widgets/Window.vala"
	return self;
#line 791 "Window.c"
}

TunerWindow*
tuner_window_new (TunerApplication* app,
                  TunerPlayerController* player)
{
#line 47 "../src/Widgets/Window.vala"
	return tuner_window_construct (TUNER_TYPE_WINDOW, app, player);
#line 800 "Window.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 364 "../src/Widgets/Window.vala"
	return self ? g_object_ref (self) : NULL;
#line 808 "Window.c"
}

static Block10Data*
block10_data_ref (Block10Data* _data10_)
{
#line 364 "../src/Widgets/Window.vala"
	g_atomic_int_inc (&_data10_->_ref_count_);
#line 364 "../src/Widgets/Window.vala"
	return _data10_;
#line 818 "Window.c"
}

static void
block10_data_unref (void * _userdata_)
{
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
#line 364 "../src/Widgets/Window.vala"
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
#line 828 "Window.c"
		TunerWindow* self;
#line 364 "../src/Widgets/Window.vala"
		self = _data10_->self;
#line 364 "../src/Widgets/Window.vala"
		_g_object_unref0 (_data10_->c);
#line 364 "../src/Widgets/Window.vala"
		_g_object_unref0 (_data10_->item);
#line 364 "../src/Widgets/Window.vala"
		_g_object_unref0 (_data10_->source_list);
#line 364 "../src/Widgets/Window.vala"
		_g_object_unref0 (self);
#line 364 "../src/Widgets/Window.vala"
		g_slice_free (Block10Data, _data10_);
#line 842 "Window.c"
	}
}

static void
__lambda20_ (Block10Data* _data10_)
{
	TunerWindow* self;
#line 381 "../src/Widgets/Window.vala"
	self = _data10_->self;
#line 382 "../src/Widgets/Window.vala"
	granite_widgets_source_list_set_selected (_data10_->source_list, _data10_->item);
#line 854 "Window.c"
}

static void
___lambda20__gtk_widget_map (GtkWidget* _sender,
                             gpointer self)
{
#line 381 "../src/Widgets/Window.vala"
	__lambda20_ (self);
#line 863 "Window.c"
}

static void
___lambda21_ (Block10Data* _data10_)
{
	TunerWindow* self;
	TunerContentBox* _tmp0_;
	TunerAbstractContentList* _tmp1_;
	TunerAbstractContentList* _tmp2_;
	guint count = 0U;
	TunerContentBox* _tmp3_;
	TunerAbstractContentList* _tmp4_;
	TunerAbstractContentList* _tmp5_;
	guint _tmp6_;
	guint _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
#line 385 "../src/Widgets/Window.vala"
	self = _data10_->self;
#line 386 "../src/Widgets/Window.vala"
	_tmp0_ = _data10_->c;
#line 386 "../src/Widgets/Window.vala"
	_tmp1_ = tuner_content_box_get_content (_tmp0_);
#line 386 "../src/Widgets/Window.vala"
	_tmp2_ = _tmp1_;
#line 386 "../src/Widgets/Window.vala"
	if (_tmp2_ == NULL) {
#line 386 "../src/Widgets/Window.vala"
		return;
#line 893 "Window.c"
	}
#line 387 "../src/Widgets/Window.vala"
	_tmp3_ = _data10_->c;
#line 387 "../src/Widgets/Window.vala"
	_tmp4_ = tuner_content_box_get_content (_tmp3_);
#line 387 "../src/Widgets/Window.vala"
	_tmp5_ = _tmp4_;
#line 387 "../src/Widgets/Window.vala"
	_tmp6_ = tuner_abstract_content_list_get_item_count (_tmp5_);
#line 387 "../src/Widgets/Window.vala"
	_tmp7_ = _tmp6_;
#line 387 "../src/Widgets/Window.vala"
	count = _tmp7_;
#line 388 "../src/Widgets/Window.vala"
	_tmp8_ = g_strdup_printf ("%u", count);
#line 388 "../src/Widgets/Window.vala"
	_tmp9_ = _tmp8_;
#line 388 "../src/Widgets/Window.vala"
	granite_widgets_source_list_item_set_badge (_data10_->item, _tmp9_);
#line 388 "../src/Widgets/Window.vala"
	_g_free0 (_tmp9_);
#line 915 "Window.c"
}

static void
____lambda21__tuner_content_box_content_changed (TunerContentBox* _sender,
                                                 gpointer self)
{
#line 385 "../src/Widgets/Window.vala"
	___lambda21_ (self);
#line 924 "Window.c"
}

static TunerContentBox*
tuner_window_create_content_box (TunerWindow* self,
                                 const gchar* name,
                                 GraniteWidgetsSourceListItem* item,
                                 const gchar* full_title,
                                 const gchar* action_icon_name,
                                 const gchar* action_tooltip_text,
                                 GtkStack* stack,
                                 GraniteWidgetsSourceList* source_list,
                                 gboolean enable_count)
{
	Block10Data* _data10_;
	GraniteWidgetsSourceListItem* _tmp0_;
	GraniteWidgetsSourceList* _tmp1_;
	gchar* _tmp2_;
	TunerContentBox* _tmp3_;
	TunerContentBox* _tmp4_;
	TunerContentBox* _tmp6_;
	TunerContentBox* _tmp7_;
	TunerContentBox* _tmp8_;
	TunerContentBox* result;
#line 364 "../src/Widgets/Window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 364 "../src/Widgets/Window.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 364 "../src/Widgets/Window.vala"
	g_return_val_if_fail (item != NULL, NULL);
#line 364 "../src/Widgets/Window.vala"
	g_return_val_if_fail (full_title != NULL, NULL);
#line 364 "../src/Widgets/Window.vala"
	g_return_val_if_fail (stack != NULL, NULL);
#line 364 "../src/Widgets/Window.vala"
	g_return_val_if_fail (source_list != NULL, NULL);
#line 364 "../src/Widgets/Window.vala"
	_data10_ = g_slice_new0 (Block10Data);
#line 364 "../src/Widgets/Window.vala"
	_data10_->_ref_count_ = 1;
#line 364 "../src/Widgets/Window.vala"
	_data10_->self = g_object_ref (self);
#line 364 "../src/Widgets/Window.vala"
	_tmp0_ = _g_object_ref0 (item);
#line 364 "../src/Widgets/Window.vala"
	_g_object_unref0 (_data10_->item);
#line 364 "../src/Widgets/Window.vala"
	_data10_->item = _tmp0_;
#line 364 "../src/Widgets/Window.vala"
	_tmp1_ = _g_object_ref0 (source_list);
#line 364 "../src/Widgets/Window.vala"
	_g_object_unref0 (_data10_->source_list);
#line 364 "../src/Widgets/Window.vala"
	_data10_->source_list = _tmp1_;
#line 373 "../src/Widgets/Window.vala"
	_tmp2_ = g_strdup (name);
#line 373 "../src/Widgets/Window.vala"
	g_object_set_data_full ((GObject*) _data10_->item, "stack_child", _tmp2_, g_free);
#line 374 "../src/Widgets/Window.vala"
	_tmp3_ = tuner_content_box_new (NULL, full_title, NULL, action_icon_name, action_tooltip_text);
#line 374 "../src/Widgets/Window.vala"
	g_object_ref_sink (_tmp3_);
#line 374 "../src/Widgets/Window.vala"
	_data10_->c = _tmp3_;
#line 381 "../src/Widgets/Window.vala"
	_tmp4_ = _data10_->c;
#line 381 "../src/Widgets/Window.vala"
	g_signal_connect_data ((GtkWidget*) _tmp4_, "map", (GCallback) ___lambda20__gtk_widget_map, block10_data_ref (_data10_), (GClosureNotify) block10_data_unref, 0);
#line 384 "../src/Widgets/Window.vala"
	if (enable_count) {
#line 994 "Window.c"
		TunerContentBox* _tmp5_;
#line 385 "../src/Widgets/Window.vala"
		_tmp5_ = _data10_->c;
#line 385 "../src/Widgets/Window.vala"
		g_signal_connect_data (_tmp5_, "content-changed", (GCallback) ____lambda21__tuner_content_box_content_changed, block10_data_ref (_data10_), (GClosureNotify) block10_data_unref, 0);
#line 1000 "Window.c"
	}
#line 391 "../src/Widgets/Window.vala"
	_tmp6_ = _data10_->c;
#line 391 "../src/Widgets/Window.vala"
	gtk_stack_add_named (stack, (GtkWidget*) _tmp6_, name);
#line 393 "../src/Widgets/Window.vala"
	_tmp7_ = _data10_->c;
#line 393 "../src/Widgets/Window.vala"
	_tmp8_ = _g_object_ref0 (_tmp7_);
#line 393 "../src/Widgets/Window.vala"
	result = _tmp8_;
#line 393 "../src/Widgets/Window.vala"
	block10_data_unref (_data10_);
#line 393 "../src/Widgets/Window.vala"
	_data10_ = NULL;
#line 393 "../src/Widgets/Window.vala"
	return result;
#line 1018 "Window.c"
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1578 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1579 "glib-2.0.vapi"
	result = self;
#line 1579 "glib-2.0.vapi"
	return result;
#line 1031 "Window.c"
}

static void
tuner_window_adjust_theme (void)
{
	gchar* theme = NULL;
	TunerApplication* _tmp0_;
	TunerApplication* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GtkSettings* gtk_settings = NULL;
	GtkSettings* _tmp9_;
	GtkSettings* _tmp10_;
	GraniteSettings* granite_settings = NULL;
	GraniteSettings* _tmp11_;
	GraniteSettings* _tmp12_;
	const gchar* _tmp13_;
#line 397 "../src/Widgets/Window.vala"
	_tmp0_ = tuner_application_get_instance ();
#line 397 "../src/Widgets/Window.vala"
	_tmp1_ = _tmp0_;
#line 397 "../src/Widgets/Window.vala"
	_tmp2_ = tuner_application_get_settings (_tmp1_);
#line 397 "../src/Widgets/Window.vala"
	_tmp3_ = _tmp2_;
#line 397 "../src/Widgets/Window.vala"
	_tmp4_ = g_settings_get_string (_tmp3_, "theme-mode");
#line 397 "../src/Widgets/Window.vala"
	theme = _tmp4_;
#line 398 "../src/Widgets/Window.vala"
	_tmp5_ = theme;
#line 398 "../src/Widgets/Window.vala"
	_tmp6_ = string_to_string (_tmp5_);
#line 398 "../src/Widgets/Window.vala"
	_tmp7_ = g_strconcat ("current theme: ", _tmp6_, NULL);
#line 398 "../src/Widgets/Window.vala"
	_tmp8_ = _tmp7_;
#line 398 "../src/Widgets/Window.vala"
	g_warning ("Window.vala:398: %s", _tmp8_);
#line 398 "../src/Widgets/Window.vala"
	_g_free0 (_tmp8_);
#line 400 "../src/Widgets/Window.vala"
	_tmp9_ = gtk_settings_get_default ();
#line 400 "../src/Widgets/Window.vala"
	_tmp10_ = _g_object_ref0 (_tmp9_);
#line 400 "../src/Widgets/Window.vala"
	gtk_settings = _tmp10_;
#line 401 "../src/Widgets/Window.vala"
	_tmp11_ = granite_settings_get_default ();
#line 401 "../src/Widgets/Window.vala"
	_tmp12_ = _g_object_ref0 (_tmp11_);
#line 401 "../src/Widgets/Window.vala"
	granite_settings = _tmp12_;
#line 402 "../src/Widgets/Window.vala"
	_tmp13_ = theme;
#line 402 "../src/Widgets/Window.vala"
	if (g_strcmp0 (_tmp13_, "system") != 0) {
#line 1094 "Window.c"
		GtkSettings* _tmp14_;
		const gchar* _tmp15_;
#line 403 "../src/Widgets/Window.vala"
		_tmp14_ = gtk_settings;
#line 403 "../src/Widgets/Window.vala"
		_tmp15_ = theme;
#line 403 "../src/Widgets/Window.vala"
		g_object_set (_tmp14_, "gtk-application-prefer-dark-theme", g_strcmp0 (_tmp15_, "dark") == 0, NULL);
#line 1103 "Window.c"
	} else {
		GtkSettings* _tmp16_;
		GraniteSettings* _tmp17_;
		GraniteSettingsColorScheme _tmp18_;
		GraniteSettingsColorScheme _tmp19_;
#line 405 "../src/Widgets/Window.vala"
		_tmp16_ = gtk_settings;
#line 405 "../src/Widgets/Window.vala"
		_tmp17_ = granite_settings;
#line 405 "../src/Widgets/Window.vala"
		_tmp18_ = granite_settings_get_prefers_color_scheme (_tmp17_);
#line 405 "../src/Widgets/Window.vala"
		_tmp19_ = _tmp18_;
#line 405 "../src/Widgets/Window.vala"
		g_object_set (_tmp16_, "gtk-application-prefer-dark-theme", _tmp19_ == GRANITE_SETTINGS_COLOR_SCHEME_DARK, NULL);
#line 1119 "Window.c"
	}
#line 396 "../src/Widgets/Window.vala"
	_g_object_unref0 (granite_settings);
#line 396 "../src/Widgets/Window.vala"
	_g_object_unref0 (gtk_settings);
#line 396 "../src/Widgets/Window.vala"
	_g_free0 (theme);
#line 1127 "Window.c"
}

static void
tuner_window_on_action_quit (TunerWindow* self)
{
#line 409 "../src/Widgets/Window.vala"
	g_return_if_fail (self != NULL);
#line 410 "../src/Widgets/Window.vala"
	gtk_window_close ((GtkWindow*) self);
#line 1137 "Window.c"
}

static void
tuner_window_on_action_about (TunerWindow* self)
{
	TunerAboutDialog* dialog = NULL;
	TunerAboutDialog* _tmp0_;
#line 413 "../src/Widgets/Window.vala"
	g_return_if_fail (self != NULL);
#line 414 "../src/Widgets/Window.vala"
	_tmp0_ = tuner_about_dialog_new ((GtkWindow*) self);
#line 414 "../src/Widgets/Window.vala"
	g_object_ref_sink (_tmp0_);
#line 414 "../src/Widgets/Window.vala"
	dialog = _tmp0_;
#line 415 "../src/Widgets/Window.vala"
	gtk_window_present ((GtkWindow*) dialog);
#line 413 "../src/Widgets/Window.vala"
	_g_object_unref0 (dialog);
#line 1157 "Window.c"
}

void
tuner_window_handle_station_click (TunerWindow* self,
                                   TunerModelStation* station)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	TunerDirectoryController* _tmp5_;
	TunerPlayerController* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	GSettings* _tmp12_;
	const gchar* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
#line 418 "../src/Widgets/Window.vala"
	g_return_if_fail (self != NULL);
#line 418 "../src/Widgets/Window.vala"
	g_return_if_fail (station != NULL);
#line 419 "../src/Widgets/Window.vala"
	_tmp0_ = tuner_model_station_get_title (station);
#line 419 "../src/Widgets/Window.vala"
	_tmp1_ = _tmp0_;
#line 419 "../src/Widgets/Window.vala"
	_tmp2_ = string_to_string (_tmp1_);
#line 419 "../src/Widgets/Window.vala"
	_tmp3_ = g_strconcat ("handle station click for ", _tmp2_, NULL);
#line 419 "../src/Widgets/Window.vala"
	_tmp4_ = _tmp3_;
#line 419 "../src/Widgets/Window.vala"
	g_info ("Window.vala:419: %s", _tmp4_);
#line 419 "../src/Widgets/Window.vala"
	_g_free0 (_tmp4_);
#line 420 "../src/Widgets/Window.vala"
	_tmp5_ = self->priv->_directory;
#line 420 "../src/Widgets/Window.vala"
	tuner_directory_controller_count_station_click (_tmp5_, station);
#line 421 "../src/Widgets/Window.vala"
	_tmp6_ = self->priv->_player;
#line 421 "../src/Widgets/Window.vala"
	tuner_player_controller_set_station (_tmp6_, station);
#line 423 "../src/Widgets/Window.vala"
	_tmp7_ = tuner_model_station_get_id (station);
#line 423 "../src/Widgets/Window.vala"
	_tmp8_ = _tmp7_;
#line 423 "../src/Widgets/Window.vala"
	_tmp9_ = string_to_string (_tmp8_);
#line 423 "../src/Widgets/Window.vala"
	_tmp10_ = g_strconcat ("storing last played station: ", _tmp9_, NULL);
#line 423 "../src/Widgets/Window.vala"
	_tmp11_ = _tmp10_;
#line 423 "../src/Widgets/Window.vala"
	g_warning ("Window.vala:423: %s", _tmp11_);
#line 423 "../src/Widgets/Window.vala"
	_g_free0 (_tmp11_);
#line 424 "../src/Widgets/Window.vala"
	_tmp12_ = self->priv->_settings;
#line 424 "../src/Widgets/Window.vala"
	_tmp13_ = tuner_model_station_get_id (station);
#line 424 "../src/Widgets/Window.vala"
	_tmp14_ = _tmp13_;
#line 424 "../src/Widgets/Window.vala"
	g_settings_set_string (_tmp12_, "last-played-station", _tmp14_);
#line 426 "../src/Widgets/Window.vala"
	_tmp15_ = tuner_model_station_get_title (station);
#line 426 "../src/Widgets/Window.vala"
	_tmp16_ = _tmp15_;
#line 426 "../src/Widgets/Window.vala"
	_tmp17_ = g_strconcat (TUNER_WINDOW_WindowName ": ", _tmp16_, NULL);
#line 426 "../src/Widgets/Window.vala"
	_tmp18_ = _tmp17_;
#line 426 "../src/Widgets/Window.vala"
	gtk_window_set_title ((GtkWindow*) self, _tmp18_);
#line 426 "../src/Widgets/Window.vala"
	_g_free0 (_tmp18_);
#line 1243 "Window.c"
}

void
tuner_window_handle_favourites_changed (TunerWindow* self)
{
#line 429 "../src/Widgets/Window.vala"
	g_return_if_fail (self != NULL);
#line 430 "../src/Widgets/Window.vala"
	g_signal_emit (self, tuner_window_signals[TUNER_WINDOW_REFRESH_FAVOURITES_SIGNAL], 0);
#line 1253 "Window.c"
}

void
tuner_window_on_toggle_playback (TunerWindow* self)
{
	TunerPlayerController* _tmp0_;
#line 433 "../src/Widgets/Window.vala"
	g_return_if_fail (self != NULL);
#line 434 "../src/Widgets/Window.vala"
	g_info ("Window.vala:434: Stop Playback requested");
#line 435 "../src/Widgets/Window.vala"
	_tmp0_ = self->priv->_player;
#line 435 "../src/Widgets/Window.vala"
	tuner_player_controller_play_pause (_tmp0_);
#line 1268 "Window.c"
}

static GVariant*
_variant_new6 (gboolean value)
{
#line 440 "../src/Widgets/Window.vala"
	return g_variant_ref_sink (g_variant_new_boolean (value));
#line 1276 "Window.c"
}

static gchar*
bool_to_string (gboolean self)
{
	gchar* result;
#line 37 "glib-2.0.vapi"
	if (self) {
#line 1285 "Window.c"
		gchar* _tmp0_;
#line 38 "glib-2.0.vapi"
		_tmp0_ = g_strdup ("true");
#line 38 "glib-2.0.vapi"
		result = _tmp0_;
#line 38 "glib-2.0.vapi"
		return result;
#line 1293 "Window.c"
	} else {
		gchar* _tmp1_;
#line 40 "glib-2.0.vapi"
		_tmp1_ = g_strdup ("false");
#line 40 "glib-2.0.vapi"
		result = _tmp1_;
#line 40 "glib-2.0.vapi"
		return result;
#line 1302 "Window.c"
	}
}

void
tuner_window_on_action_disable_tracking (TunerWindow* self,
                                         GSimpleAction* action,
                                         GVariant* parameter)
{
	gboolean new_state = FALSE;
	GSettings* _tmp0_;
	GVariant* _tmp1_;
	GSettings* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
#line 438 "../src/Widgets/Window.vala"
	g_return_if_fail (self != NULL);
#line 438 "../src/Widgets/Window.vala"
	g_return_if_fail (action != NULL);
#line 439 "../src/Widgets/Window.vala"
	_tmp0_ = self->priv->_settings;
#line 439 "../src/Widgets/Window.vala"
	new_state = !g_settings_get_boolean (_tmp0_, "do-not-track");
#line 440 "../src/Widgets/Window.vala"
	_tmp1_ = _variant_new6 (new_state);
#line 440 "../src/Widgets/Window.vala"
	g_simple_action_set_state (action, _tmp1_);
#line 440 "../src/Widgets/Window.vala"
	_g_variant_unref0 (_tmp1_);
#line 441 "../src/Widgets/Window.vala"
	_tmp2_ = self->priv->_settings;
#line 441 "../src/Widgets/Window.vala"
	g_settings_set_boolean (_tmp2_, "do-not-track", new_state);
#line 442 "../src/Widgets/Window.vala"
	_tmp3_ = bool_to_string (new_state);
#line 442 "../src/Widgets/Window.vala"
	_tmp4_ = _tmp3_;
#line 442 "../src/Widgets/Window.vala"
	_tmp5_ = g_strconcat ("on_action_disable_tracking: ", _tmp4_, NULL);
#line 442 "../src/Widgets/Window.vala"
	_tmp6_ = _tmp5_;
#line 442 "../src/Widgets/Window.vala"
	g_debug ("Window.vala:442: %s", _tmp6_);
#line 442 "../src/Widgets/Window.vala"
	_g_free0 (_tmp6_);
#line 442 "../src/Widgets/Window.vala"
	_g_free0 (_tmp4_);
#line 1351 "Window.c"
}

static GVariant*
_variant_new7 (gboolean value)
{
#line 447 "../src/Widgets/Window.vala"
	return g_variant_ref_sink (g_variant_new_boolean (value));
#line 1359 "Window.c"
}

void
tuner_window_on_action_enable_autoplay (TunerWindow* self,
                                        GSimpleAction* action,
                                        GVariant* parameter)
{
	gboolean new_state = FALSE;
	GSettings* _tmp0_;
	GVariant* _tmp1_;
	GSettings* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
#line 445 "../src/Widgets/Window.vala"
	g_return_if_fail (self != NULL);
#line 445 "../src/Widgets/Window.vala"
	g_return_if_fail (action != NULL);
#line 446 "../src/Widgets/Window.vala"
	_tmp0_ = self->priv->_settings;
#line 446 "../src/Widgets/Window.vala"
	new_state = !g_settings_get_boolean (_tmp0_, "auto-play");
#line 447 "../src/Widgets/Window.vala"
	_tmp1_ = _variant_new7 (new_state);
#line 447 "../src/Widgets/Window.vala"
	g_simple_action_set_state (action, _tmp1_);
#line 447 "../src/Widgets/Window.vala"
	_g_variant_unref0 (_tmp1_);
#line 448 "../src/Widgets/Window.vala"
	_tmp2_ = self->priv->_settings;
#line 448 "../src/Widgets/Window.vala"
	g_settings_set_boolean (_tmp2_, "auto-play", new_state);
#line 449 "../src/Widgets/Window.vala"
	_tmp3_ = bool_to_string (new_state);
#line 449 "../src/Widgets/Window.vala"
	_tmp4_ = _tmp3_;
#line 449 "../src/Widgets/Window.vala"
	_tmp5_ = g_strconcat ("on_action_enable_autoplay: ", _tmp4_, NULL);
#line 449 "../src/Widgets/Window.vala"
	_tmp6_ = _tmp5_;
#line 449 "../src/Widgets/Window.vala"
	g_debug ("Window.vala:449: %s", _tmp6_);
#line 449 "../src/Widgets/Window.vala"
	_g_free0 (_tmp6_);
#line 449 "../src/Widgets/Window.vala"
	_g_free0 (_tmp4_);
#line 1407 "Window.c"
}

static gboolean
___lambda22_ (TunerWindow* self)
{
	TunerHeaderBar* _tmp0_;
	gboolean result;
#line 457 "../src/Widgets/Window.vala"
	_tmp0_ = self->priv->headerbar;
#line 457 "../src/Widgets/Window.vala"
	tuner_header_bar_set_playstate (_tmp0_, TUNER_HEADER_BAR_PLAY_STATE_PAUSE_ACTIVE);
#line 458 "../src/Widgets/Window.vala"
	result = FALSE;
#line 458 "../src/Widgets/Window.vala"
	return result;
#line 1423 "Window.c"
}

static gboolean
____lambda22__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda22_ ((TunerWindow*) self);
#line 456 "../src/Widgets/Window.vala"
	return result;
#line 1433 "Window.c"
}

static gboolean
___lambda23_ (TunerWindow* self)
{
	TunerPlayerController* _tmp0_;
	gboolean result;
#line 464 "../src/Widgets/Window.vala"
	_tmp0_ = self->priv->_player;
#line 464 "../src/Widgets/Window.vala"
	if (tuner_player_controller_can_play (_tmp0_)) {
#line 1445 "Window.c"
		TunerHeaderBar* _tmp1_;
#line 465 "../src/Widgets/Window.vala"
		_tmp1_ = self->priv->headerbar;
#line 465 "../src/Widgets/Window.vala"
		tuner_header_bar_set_playstate (_tmp1_, TUNER_HEADER_BAR_PLAY_STATE_PLAY_ACTIVE);
#line 1451 "Window.c"
	} else {
		TunerHeaderBar* _tmp2_;
#line 467 "../src/Widgets/Window.vala"
		_tmp2_ = self->priv->headerbar;
#line 467 "../src/Widgets/Window.vala"
		tuner_header_bar_set_playstate (_tmp2_, TUNER_HEADER_BAR_PLAY_STATE_PLAY_INACTIVE);
#line 1458 "Window.c"
	}
#line 469 "../src/Widgets/Window.vala"
	result = FALSE;
#line 469 "../src/Widgets/Window.vala"
	return result;
#line 1464 "Window.c"
}

static gboolean
____lambda23__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda23_ ((TunerWindow*) self);
#line 463 "../src/Widgets/Window.vala"
	return result;
#line 1474 "Window.c"
}

static gboolean
___lambda24_ (TunerWindow* self)
{
	TunerHeaderBar* _tmp0_;
	gboolean result;
#line 475 "../src/Widgets/Window.vala"
	_tmp0_ = self->priv->headerbar;
#line 475 "../src/Widgets/Window.vala"
	tuner_header_bar_set_playstate (_tmp0_, TUNER_HEADER_BAR_PLAY_STATE_PAUSE_ACTIVE);
#line 476 "../src/Widgets/Window.vala"
	result = FALSE;
#line 476 "../src/Widgets/Window.vala"
	return result;
#line 1490 "Window.c"
}

static gboolean
____lambda24__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda24_ ((TunerWindow*) self);
#line 474 "../src/Widgets/Window.vala"
	return result;
#line 1500 "Window.c"
}

static gboolean
___lambda25_ (TunerWindow* self)
{
	TunerPlayerController* _tmp0_;
	gboolean result;
#line 482 "../src/Widgets/Window.vala"
	_tmp0_ = self->priv->_player;
#line 482 "../src/Widgets/Window.vala"
	if (tuner_player_controller_can_play (_tmp0_)) {
#line 1512 "Window.c"
		TunerHeaderBar* _tmp1_;
#line 483 "../src/Widgets/Window.vala"
		_tmp1_ = self->priv->headerbar;
#line 483 "../src/Widgets/Window.vala"
		tuner_header_bar_set_playstate (_tmp1_, TUNER_HEADER_BAR_PLAY_STATE_PLAY_ACTIVE);
#line 1518 "Window.c"
	} else {
		TunerHeaderBar* _tmp2_;
#line 485 "../src/Widgets/Window.vala"
		_tmp2_ = self->priv->headerbar;
#line 485 "../src/Widgets/Window.vala"
		tuner_header_bar_set_playstate (_tmp2_, TUNER_HEADER_BAR_PLAY_STATE_PLAY_INACTIVE);
#line 1525 "Window.c"
	}
#line 487 "../src/Widgets/Window.vala"
	result = FALSE;
#line 487 "../src/Widgets/Window.vala"
	return result;
#line 1531 "Window.c"
}

static gboolean
____lambda25__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda25_ ((TunerWindow*) self);
#line 481 "../src/Widgets/Window.vala"
	return result;
#line 1541 "Window.c"
}

void
tuner_window_handleplayer_state_changed (TunerWindow* self,
                                         GstPlayerState state)
{
#line 452 "../src/Widgets/Window.vala"
	g_return_if_fail (self != NULL);
#line 453 "../src/Widgets/Window.vala"
	switch (state) {
#line 453 "../src/Widgets/Window.vala"
		case GST_PLAYER_STATE_BUFFERING:
#line 1554 "Window.c"
		{
#line 455 "../src/Widgets/Window.vala"
			g_debug ("Window.vala:455: player state changed to Buffering");
#line 456 "../src/Widgets/Window.vala"
			gdk_threads_add_idle (____lambda22__gsource_func, self);
#line 460 "../src/Widgets/Window.vala"
			break;
#line 1562 "Window.c"
		}
#line 453 "../src/Widgets/Window.vala"
		case GST_PLAYER_STATE_PAUSED:
#line 1566 "Window.c"
		{
#line 462 "../src/Widgets/Window.vala"
			g_debug ("Window.vala:462: player state changed to Paused");
#line 463 "../src/Widgets/Window.vala"
			gdk_threads_add_idle (____lambda23__gsource_func, self);
#line 471 "../src/Widgets/Window.vala"
			break;
#line 1574 "Window.c"
		}
#line 453 "../src/Widgets/Window.vala"
		case GST_PLAYER_STATE_PLAYING:
#line 1578 "Window.c"
		{
#line 473 "../src/Widgets/Window.vala"
			g_debug ("Window.vala:473: player state changed to Playing");
#line 474 "../src/Widgets/Window.vala"
			gdk_threads_add_idle (____lambda24__gsource_func, self);
#line 478 "../src/Widgets/Window.vala"
			break;
#line 1586 "Window.c"
		}
#line 453 "../src/Widgets/Window.vala"
		case GST_PLAYER_STATE_STOPPED:
#line 1590 "Window.c"
		{
#line 480 "../src/Widgets/Window.vala"
			g_debug ("Window.vala:480: player state changed to Stopped");
#line 481 "../src/Widgets/Window.vala"
			gdk_threads_add_idle (____lambda25__gsource_func, self);
#line 489 "../src/Widgets/Window.vala"
			break;
#line 1598 "Window.c"
		}
		default:
#line 453 "../src/Widgets/Window.vala"
		break;
#line 1603 "Window.c"
	}
#line 492 "../src/Widgets/Window.vala"
	return;
#line 1607 "Window.c"
}

static gboolean
_gst_player_state_equal (const GstPlayerState * s1,
                         const GstPlayerState * s2)
{
#line 506 "../src/Widgets/Window.vala"
	if (s1 == s2) {
#line 506 "../src/Widgets/Window.vala"
		return TRUE;
#line 1618 "Window.c"
	}
#line 506 "../src/Widgets/Window.vala"
	if (s1 == NULL) {
#line 506 "../src/Widgets/Window.vala"
		return FALSE;
#line 1624 "Window.c"
	}
#line 506 "../src/Widgets/Window.vala"
	if (s2 == NULL) {
#line 506 "../src/Widgets/Window.vala"
		return FALSE;
#line 1630 "Window.c"
	}
#line 506 "../src/Widgets/Window.vala"
	return (*s1) == (*s2);
#line 1634 "Window.c"
}

gboolean
tuner_window_before_destroy (TunerWindow* self)
{
	gint width = 0;
	gint height = 0;
	gint x = 0;
	gint y = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	GSettings* _tmp4_;
	GSettings* _tmp5_;
	GSettings* _tmp6_;
	GSettings* _tmp7_;
	TunerPlayerController* _tmp8_;
	GstPlayerState* _tmp9_;
	GstPlayerState* _tmp10_;
	GstPlayerState _tmp11_;
	gboolean result;
#line 495 "../src/Widgets/Window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 498 "../src/Widgets/Window.vala"
	gtk_window_get_size ((GtkWindow*) self, &_tmp0_, &_tmp1_);
#line 498 "../src/Widgets/Window.vala"
	width = _tmp0_;
#line 498 "../src/Widgets/Window.vala"
	height = _tmp1_;
#line 499 "../src/Widgets/Window.vala"
	gtk_window_get_position ((GtkWindow*) self, &_tmp2_, &_tmp3_);
#line 499 "../src/Widgets/Window.vala"
	x = _tmp2_;
#line 499 "../src/Widgets/Window.vala"
	y = _tmp3_;
#line 501 "../src/Widgets/Window.vala"
	_tmp4_ = self->priv->_settings;
#line 501 "../src/Widgets/Window.vala"
	g_settings_set_int (_tmp4_, "pos-x", x);
#line 502 "../src/Widgets/Window.vala"
	_tmp5_ = self->priv->_settings;
#line 502 "../src/Widgets/Window.vala"
	g_settings_set_int (_tmp5_, "pos-y", y);
#line 503 "../src/Widgets/Window.vala"
	_tmp6_ = self->priv->_settings;
#line 503 "../src/Widgets/Window.vala"
	g_settings_set_int (_tmp6_, "window-height", height);
#line 504 "../src/Widgets/Window.vala"
	_tmp7_ = self->priv->_settings;
#line 504 "../src/Widgets/Window.vala"
	g_settings_set_int (_tmp7_, "window-width", width);
#line 506 "../src/Widgets/Window.vala"
	_tmp8_ = self->priv->_player;
#line 506 "../src/Widgets/Window.vala"
	_tmp9_ = tuner_player_controller_get_current_state (_tmp8_);
#line 506 "../src/Widgets/Window.vala"
	_tmp10_ = _tmp9_;
#line 506 "../src/Widgets/Window.vala"
	_tmp11_ = GST_PLAYER_STATE_PLAYING;
#line 506 "../src/Widgets/Window.vala"
	if (_gst_player_state_equal (_tmp10_, &_tmp11_) == TRUE) {
#line 1697 "Window.c"
		GNotification* notification = NULL;
		GNotification* _tmp12_;
		GNotification* _tmp13_;
		GNotification* _tmp14_;
		TunerApplication* _tmp15_;
		TunerApplication* _tmp16_;
		GNotification* _tmp17_;
#line 507 "../src/Widgets/Window.vala"
		gtk_widget_hide_on_delete ((GtkWidget*) self);
#line 508 "../src/Widgets/Window.vala"
		_tmp12_ = g_notification_new ("Playing in background");
#line 508 "../src/Widgets/Window.vala"
		notification = _tmp12_;
#line 509 "../src/Widgets/Window.vala"
		_tmp13_ = notification;
#line 509 "../src/Widgets/Window.vala"
		g_notification_set_body (_tmp13_, "Click here to resume window. To quit Tuner, pause playback and close t" \
"he window.");
#line 510 "../src/Widgets/Window.vala"
		_tmp14_ = notification;
#line 510 "../src/Widgets/Window.vala"
		g_notification_set_default_action (_tmp14_, "app.resume-window");
#line 511 "../src/Widgets/Window.vala"
		_tmp15_ = tuner_application_get_instance ();
#line 511 "../src/Widgets/Window.vala"
		_tmp16_ = _tmp15_;
#line 511 "../src/Widgets/Window.vala"
		_tmp17_ = notification;
#line 511 "../src/Widgets/Window.vala"
		g_application_send_notification ((GApplication*) _tmp16_, "continue-playing", _tmp17_);
#line 512 "../src/Widgets/Window.vala"
		result = TRUE;
#line 512 "../src/Widgets/Window.vala"
		_g_object_unref0 (notification);
#line 512 "../src/Widgets/Window.vala"
		return result;
#line 1733 "Window.c"
	}
#line 515 "../src/Widgets/Window.vala"
	result = FALSE;
#line 515 "../src/Widgets/Window.vala"
	return result;
#line 1739 "Window.c"
}

GSettings*
tuner_window_get_settings (TunerWindow* self)
{
	GSettings* result;
	GSettings* _tmp0_;
#line 10 "../src/Widgets/Window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 10 "../src/Widgets/Window.vala"
	_tmp0_ = self->priv->_settings;
#line 10 "../src/Widgets/Window.vala"
	result = _tmp0_;
#line 10 "../src/Widgets/Window.vala"
	return result;
#line 1755 "Window.c"
}

static void
tuner_window_set_settings (TunerWindow* self,
                           GSettings* value)
{
	GSettings* old_value;
#line 10 "../src/Widgets/Window.vala"
	g_return_if_fail (self != NULL);
#line 10 "../src/Widgets/Window.vala"
	old_value = tuner_window_get_settings (self);
#line 10 "../src/Widgets/Window.vala"
	if (old_value != value) {
#line 1769 "Window.c"
		GSettings* _tmp0_;
#line 10 "../src/Widgets/Window.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 10 "../src/Widgets/Window.vala"
		_g_object_unref0 (self->priv->_settings);
#line 10 "../src/Widgets/Window.vala"
		self->priv->_settings = _tmp0_;
#line 10 "../src/Widgets/Window.vala"
		g_object_notify_by_pspec ((GObject *) self, tuner_window_properties[TUNER_WINDOW_SETTINGS_PROPERTY]);
#line 1779 "Window.c"
	}
}

GtkStack*
tuner_window_get_stack (TunerWindow* self)
{
	GtkStack* result;
	GtkStack* _tmp0_;
#line 11 "../src/Widgets/Window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 11 "../src/Widgets/Window.vala"
	_tmp0_ = self->priv->_stack;
#line 11 "../src/Widgets/Window.vala"
	result = _tmp0_;
#line 11 "../src/Widgets/Window.vala"
	return result;
#line 1796 "Window.c"
}

void
tuner_window_set_stack (TunerWindow* self,
                        GtkStack* value)
{
	GtkStack* old_value;
#line 11 "../src/Widgets/Window.vala"
	g_return_if_fail (self != NULL);
#line 11 "../src/Widgets/Window.vala"
	old_value = tuner_window_get_stack (self);
#line 11 "../src/Widgets/Window.vala"
	if (old_value != value) {
#line 1810 "Window.c"
		GtkStack* _tmp0_;
#line 11 "../src/Widgets/Window.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 11 "../src/Widgets/Window.vala"
		_g_object_unref0 (self->priv->_stack);
#line 11 "../src/Widgets/Window.vala"
		self->priv->_stack = _tmp0_;
#line 11 "../src/Widgets/Window.vala"
		g_object_notify_by_pspec ((GObject *) self, tuner_window_properties[TUNER_WINDOW_STACK_PROPERTY]);
#line 1820 "Window.c"
	}
}

TunerPlayerController*
tuner_window_get_player (TunerWindow* self)
{
	TunerPlayerController* result;
	TunerPlayerController* _tmp0_;
#line 12 "../src/Widgets/Window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 12 "../src/Widgets/Window.vala"
	_tmp0_ = self->priv->_player;
#line 12 "../src/Widgets/Window.vala"
	result = _tmp0_;
#line 12 "../src/Widgets/Window.vala"
	return result;
#line 1837 "Window.c"
}

static void
tuner_window_set_player (TunerWindow* self,
                         TunerPlayerController* value)
{
	TunerPlayerController* old_value;
#line 12 "../src/Widgets/Window.vala"
	g_return_if_fail (self != NULL);
#line 12 "../src/Widgets/Window.vala"
	old_value = tuner_window_get_player (self);
#line 12 "../src/Widgets/Window.vala"
	if (old_value != value) {
#line 1851 "Window.c"
		TunerPlayerController* _tmp0_;
#line 12 "../src/Widgets/Window.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 12 "../src/Widgets/Window.vala"
		_g_object_unref0 (self->priv->_player);
#line 12 "../src/Widgets/Window.vala"
		self->priv->_player = _tmp0_;
#line 12 "../src/Widgets/Window.vala"
		g_object_notify_by_pspec ((GObject *) self, tuner_window_properties[TUNER_WINDOW_PLAYER_PROPERTY]);
#line 1861 "Window.c"
	}
}

static Block11Data*
block11_data_ref (Block11Data* _data11_)
{
#line 59 "../src/Widgets/Window.vala"
	g_atomic_int_inc (&_data11_->_ref_count_);
#line 59 "../src/Widgets/Window.vala"
	return _data11_;
#line 1872 "Window.c"
}

static void
block11_data_unref (void * _userdata_)
{
	Block11Data* _data11_;
	_data11_ = (Block11Data*) _userdata_;
#line 59 "../src/Widgets/Window.vala"
	if (g_atomic_int_dec_and_test (&_data11_->_ref_count_)) {
#line 1882 "Window.c"
		TunerWindow* self;
#line 59 "../src/Widgets/Window.vala"
		self = _data11_->self;
#line 59 "../src/Widgets/Window.vala"
		_g_object_unref0 (_data11_->c5);
#line 59 "../src/Widgets/Window.vala"
		_g_object_unref0 (_data11_->c4);
#line 59 "../src/Widgets/Window.vala"
		_g_object_unref0 (_data11_->c_slist);
#line 59 "../src/Widgets/Window.vala"
		_g_object_unref0 (_data11_->c_country);
#line 59 "../src/Widgets/Window.vala"
		_g_object_unref0 (_data11_->item4);
#line 59 "../src/Widgets/Window.vala"
		_g_object_unref0 (_data11_->s3);
#line 59 "../src/Widgets/Window.vala"
		_g_object_unref0 (_data11_->c3);
#line 59 "../src/Widgets/Window.vala"
		_g_object_unref0 (_data11_->s2);
#line 59 "../src/Widgets/Window.vala"
		_g_object_unref0 (_data11_->c2);
#line 59 "../src/Widgets/Window.vala"
		_g_object_unref0 (_data11_->s1);
#line 59 "../src/Widgets/Window.vala"
		_g_object_unref0 (_data11_->c1);
#line 59 "../src/Widgets/Window.vala"
		_g_object_unref0 (_data11_->selections_category);
#line 59 "../src/Widgets/Window.vala"
		_g_object_unref0 (_data11_->stack);
#line 59 "../src/Widgets/Window.vala"
		_g_object_unref0 (self);
#line 59 "../src/Widgets/Window.vala"
		g_slice_free (Block11Data, _data11_);
#line 1916 "Window.c"
	}
}

static void
_tuner_window_handleplayer_state_changed_tuner_player_controller_state_changed (TunerPlayerController* _sender,
                                                                                GstPlayerState state,
                                                                                gpointer self)
{
#line 64 "../src/Widgets/Window.vala"
	tuner_window_handleplayer_state_changed ((TunerWindow*) self, state);
#line 1927 "Window.c"
}

static void
_tuner_header_bar_update_from_station_tuner_player_controller_station_changed (TunerPlayerController* _sender,
                                                                               TunerModelStation* station,
                                                                               gpointer self)
{
#line 65 "../src/Widgets/Window.vala"
	tuner_header_bar_update_from_station ((TunerHeaderBar*) self, station);
#line 1937 "Window.c"
}

static void
_tuner_window___lambda26_ (TunerWindow* self,
                           const gchar* title)
{
	TunerHeaderBar* _tmp0_;
#line 66 "../src/Widgets/Window.vala"
	g_return_if_fail (title != NULL);
#line 67 "../src/Widgets/Window.vala"
	_tmp0_ = self->priv->headerbar;
#line 67 "../src/Widgets/Window.vala"
	tuner_header_bar_set_subtitle (_tmp0_, title);
#line 1951 "Window.c"
}

static void
__tuner_window___lambda26__tuner_player_controller_title_changed (TunerPlayerController* _sender,
                                                                  const gchar* title,
                                                                  gpointer self)
{
#line 66 "../src/Widgets/Window.vala"
	_tuner_window___lambda26_ ((TunerWindow*) self, title);
#line 1961 "Window.c"
}

static void
_tuner_window___lambda27_ (TunerWindow* self,
                           gdouble volume)
{
	TunerHeaderBar* _tmp0_;
	GtkVolumeButton* _tmp1_;
#line 70 "../src/Widgets/Window.vala"
	_tmp0_ = self->priv->headerbar;
#line 70 "../src/Widgets/Window.vala"
	_tmp1_ = _tmp0_->volume_button;
#line 70 "../src/Widgets/Window.vala"
	gtk_scale_button_set_value ((GtkScaleButton*) _tmp1_, volume);
#line 1976 "Window.c"
}

static void
__tuner_window___lambda27__tuner_player_controller_volume_changed (TunerPlayerController* _sender,
                                                                   gdouble volume,
                                                                   gpointer self)
{
#line 69 "../src/Widgets/Window.vala"
	_tuner_window___lambda27_ ((TunerWindow*) self, volume);
#line 1986 "Window.c"
}

static void
_tuner_window___lambda28_ (TunerWindow* self,
                           gdouble value)
{
	TunerPlayerController* _tmp0_;
#line 73 "../src/Widgets/Window.vala"
	_tmp0_ = self->priv->_player;
#line 73 "../src/Widgets/Window.vala"
	tuner_player_controller_set_volume (_tmp0_, value);
#line 1998 "Window.c"
}

static void
__tuner_window___lambda28__gtk_scale_button_value_changed (GtkScaleButton* _sender,
                                                           gdouble value,
                                                           gpointer self)
{
#line 72 "../src/Widgets/Window.vala"
	_tuner_window___lambda28_ ((TunerWindow*) self, value);
#line 2008 "Window.c"
}

static void
_tuner_window___lambda29_ (TunerWindow* self,
                           const gchar* key)
{
#line 77 "../src/Widgets/Window.vala"
	g_return_if_fail (key != NULL);
#line 78 "../src/Widgets/Window.vala"
	if (g_strcmp0 (key, "theme-mode") == 0) {
#line 79 "../src/Widgets/Window.vala"
		g_warning ("Window.vala:79: theme-mode changed");
#line 80 "../src/Widgets/Window.vala"
		tuner_window_adjust_theme ();
#line 2023 "Window.c"
	}
}

static void
__tuner_window___lambda29__g_settings_changed (GSettings* _sender,
                                               const gchar* key,
                                               gpointer self)
{
#line 77 "../src/Widgets/Window.vala"
	_tuner_window___lambda29_ ((TunerWindow*) self, key);
#line 2034 "Window.c"
}

static void
_tuner_window___lambda30_ (TunerWindow* self,
                           GParamSpec* key)
{
#line 86 "../src/Widgets/Window.vala"
	g_return_if_fail (key != NULL);
#line 87 "../src/Widgets/Window.vala"
	g_warning ("Window.vala:87: theme-mode changed");
#line 88 "../src/Widgets/Window.vala"
	tuner_window_adjust_theme ();
#line 2047 "Window.c"
}

static void
__tuner_window___lambda30__g_object_notify (GObject* _sender,
                                            GParamSpec* pspec,
                                            gpointer self)
{
#line 86 "../src/Widgets/Window.vala"
	_tuner_window___lambda30_ ((TunerWindow*) self, pspec);
#line 2057 "Window.c"
}

static GVariant*
_variant_new8 (gboolean value)
{
#line 95 "../src/Widgets/Window.vala"
	return g_variant_ref_sink (g_variant_new_boolean (value));
#line 2065 "Window.c"
}

static GVariant*
_variant_new9 (gboolean value)
{
#line 96 "../src/Widgets/Window.vala"
	return g_variant_ref_sink (g_variant_new_boolean (value));
#line 2073 "Window.c"
}

static gboolean
_tuner_window___lambda31_ (TunerWindow* self,
                           GdkEventAny* e)
{
	gboolean result;
#line 102 "../src/Widgets/Window.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 103 "../src/Widgets/Window.vala"
	result = tuner_window_before_destroy (self);
#line 103 "../src/Widgets/Window.vala"
	return result;
#line 2087 "Window.c"
}

static gboolean
__tuner_window___lambda31__gtk_widget_delete_event (GtkWidget* _sender,
                                                    GdkEventAny* event,
                                                    gpointer self)
{
	gboolean result;
	result = _tuner_window___lambda31_ ((TunerWindow*) self, event);
#line 102 "../src/Widgets/Window.vala"
	return result;
#line 2099 "Window.c"
}

static void
_tuner_window_handle_station_click_tuner_station_list_selection_changed (TunerStationList* _sender,
                                                                         TunerModelStation* station,
                                                                         gpointer self)
{
#line 143 "../src/Widgets/Window.vala"
	tuner_window_handle_station_click ((TunerWindow*) self, station);
#line 2109 "Window.c"
}

static void
_tuner_window_handle_favourites_changed_tuner_station_list_favourites_changed (TunerStationList* _sender,
                                                                               gpointer self)
{
#line 144 "../src/Widgets/Window.vala"
	tuner_window_handle_favourites_changed ((TunerWindow*) self);
#line 2118 "Window.c"
}

static void
_tuner_window___lambda36_ (Block11Data* _data11_)
{
	TunerWindow* self;
	GError* _inner_error0_ = NULL;
#line 140 "../src/Widgets/Window.vala"
	self = _data11_->self;
#line 2128 "Window.c"
	{
		GeeArrayList* _tmp0_ = NULL;
		TunerStationSource* _tmp1_;
		GeeArrayList* _tmp2_;
		TunerStationList* slist = NULL;
		TunerStationList* _tmp3_;
		TunerStationList* _tmp4_;
		TunerStationList* _tmp5_;
		TunerContentBox* _tmp6_;
		TunerStationList* _tmp7_;
#line 142 "../src/Widgets/Window.vala"
		_tmp1_ = _data11_->s1;
#line 142 "../src/Widgets/Window.vala"
		_tmp2_ = tuner_station_source_next (_tmp1_, &_inner_error0_);
#line 142 "../src/Widgets/Window.vala"
		_tmp0_ = _tmp2_;
#line 142 "../src/Widgets/Window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 142 "../src/Widgets/Window.vala"
			if (_inner_error0_->domain == SOURCE_ERROR) {
#line 2149 "Window.c"
				goto __catch0_source_error;
			}
#line 142 "../src/Widgets/Window.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 142 "../src/Widgets/Window.vala"
			g_clear_error (&_inner_error0_);
#line 142 "../src/Widgets/Window.vala"
			return;
#line 2158 "Window.c"
		}
#line 142 "../src/Widgets/Window.vala"
		_tmp3_ = tuner_station_list_new_with_stations (_tmp0_);
#line 142 "../src/Widgets/Window.vala"
		g_object_ref_sink (_tmp3_);
#line 142 "../src/Widgets/Window.vala"
		slist = _tmp3_;
#line 143 "../src/Widgets/Window.vala"
		_tmp4_ = slist;
#line 143 "../src/Widgets/Window.vala"
		g_signal_connect_object (_tmp4_, "selection-changed", (GCallback) _tuner_window_handle_station_click_tuner_station_list_selection_changed, self, 0);
#line 144 "../src/Widgets/Window.vala"
		_tmp5_ = slist;
#line 144 "../src/Widgets/Window.vala"
		g_signal_connect_object (_tmp5_, "favourites-changed", (GCallback) _tuner_window_handle_favourites_changed_tuner_station_list_favourites_changed, self, 0);
#line 145 "../src/Widgets/Window.vala"
		_tmp6_ = _data11_->c1;
#line 145 "../src/Widgets/Window.vala"
		_tmp7_ = slist;
#line 145 "../src/Widgets/Window.vala"
		tuner_content_box_set_content (_tmp6_, (TunerAbstractContentList*) _tmp7_);
#line 141 "../src/Widgets/Window.vala"
		_g_object_unref0 (slist);
#line 141 "../src/Widgets/Window.vala"
		_g_object_unref0 (_tmp0_);
#line 2184 "Window.c"
	}
	goto __finally0;
	__catch0_source_error:
	{
		TunerContentBox* _tmp8_;
#line 141 "../src/Widgets/Window.vala"
		g_clear_error (&_inner_error0_);
#line 147 "../src/Widgets/Window.vala"
		_tmp8_ = _data11_->c1;
#line 147 "../src/Widgets/Window.vala"
		tuner_content_box_show_alert (_tmp8_);
#line 2196 "Window.c"
	}
	__finally0:
#line 141 "../src/Widgets/Window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 141 "../src/Widgets/Window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 141 "../src/Widgets/Window.vala"
		g_clear_error (&_inner_error0_);
#line 141 "../src/Widgets/Window.vala"
		return;
#line 2207 "Window.c"
	}
}

static void
__tuner_window___lambda36__gtk_widget_realize (GtkWidget* _sender,
                                               gpointer self)
{
#line 140 "../src/Widgets/Window.vala"
	_tuner_window___lambda36_ (self);
#line 2217 "Window.c"
}

static void
_tuner_window___lambda43_ (Block11Data* _data11_)
{
	TunerWindow* self;
	GError* _inner_error0_ = NULL;
#line 150 "../src/Widgets/Window.vala"
	self = _data11_->self;
#line 2227 "Window.c"
	{
		GeeArrayList* _tmp0_ = NULL;
		TunerStationSource* _tmp1_;
		GeeArrayList* _tmp2_;
		TunerStationList* slist = NULL;
		TunerStationList* _tmp3_;
		TunerStationList* _tmp4_;
		TunerStationList* _tmp5_;
		TunerContentBox* _tmp6_;
		TunerStationList* _tmp7_;
#line 152 "../src/Widgets/Window.vala"
		_tmp1_ = _data11_->s1;
#line 152 "../src/Widgets/Window.vala"
		_tmp2_ = tuner_station_source_next (_tmp1_, &_inner_error0_);
#line 152 "../src/Widgets/Window.vala"
		_tmp0_ = _tmp2_;
#line 152 "../src/Widgets/Window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 152 "../src/Widgets/Window.vala"
			if (_inner_error0_->domain == SOURCE_ERROR) {
#line 2248 "Window.c"
				goto __catch0_source_error;
			}
#line 152 "../src/Widgets/Window.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 152 "../src/Widgets/Window.vala"
			g_clear_error (&_inner_error0_);
#line 152 "../src/Widgets/Window.vala"
			return;
#line 2257 "Window.c"
		}
#line 152 "../src/Widgets/Window.vala"
		_tmp3_ = tuner_station_list_new_with_stations (_tmp0_);
#line 152 "../src/Widgets/Window.vala"
		g_object_ref_sink (_tmp3_);
#line 152 "../src/Widgets/Window.vala"
		slist = _tmp3_;
#line 153 "../src/Widgets/Window.vala"
		_tmp4_ = slist;
#line 153 "../src/Widgets/Window.vala"
		g_signal_connect_object (_tmp4_, "selection-changed", (GCallback) _tuner_window_handle_station_click_tuner_station_list_selection_changed, self, 0);
#line 154 "../src/Widgets/Window.vala"
		_tmp5_ = slist;
#line 154 "../src/Widgets/Window.vala"
		g_signal_connect_object (_tmp5_, "favourites-changed", (GCallback) _tuner_window_handle_favourites_changed_tuner_station_list_favourites_changed, self, 0);
#line 155 "../src/Widgets/Window.vala"
		_tmp6_ = _data11_->c1;
#line 155 "../src/Widgets/Window.vala"
		_tmp7_ = slist;
#line 155 "../src/Widgets/Window.vala"
		tuner_content_box_set_content (_tmp6_, (TunerAbstractContentList*) _tmp7_);
#line 151 "../src/Widgets/Window.vala"
		_g_object_unref0 (slist);
#line 151 "../src/Widgets/Window.vala"
		_g_object_unref0 (_tmp0_);
#line 2283 "Window.c"
	}
	goto __finally0;
	__catch0_source_error:
	{
		TunerContentBox* _tmp8_;
#line 151 "../src/Widgets/Window.vala"
		g_clear_error (&_inner_error0_);
#line 157 "../src/Widgets/Window.vala"
		_tmp8_ = _data11_->c1;
#line 157 "../src/Widgets/Window.vala"
		tuner_content_box_show_alert (_tmp8_);
#line 2295 "Window.c"
	}
	__finally0:
#line 151 "../src/Widgets/Window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 151 "../src/Widgets/Window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 151 "../src/Widgets/Window.vala"
		g_clear_error (&_inner_error0_);
#line 151 "../src/Widgets/Window.vala"
		return;
#line 2306 "Window.c"
	}
}

static void
__tuner_window___lambda43__tuner_content_box_action_activated (TunerContentBox* _sender,
                                                               gpointer self)
{
#line 150 "../src/Widgets/Window.vala"
	_tuner_window___lambda43_ (self);
#line 2316 "Window.c"
}

static void
_tuner_window___lambda44_ (Block11Data* _data11_)
{
	TunerWindow* self;
	GError* _inner_error0_ = NULL;
#line 170 "../src/Widgets/Window.vala"
	self = _data11_->self;
#line 2326 "Window.c"
	{
		GeeArrayList* _tmp0_ = NULL;
		TunerStationSource* _tmp1_;
		GeeArrayList* _tmp2_;
		TunerStationList* slist = NULL;
		TunerStationList* _tmp3_;
		TunerStationList* _tmp4_;
		TunerStationList* _tmp5_;
		TunerContentBox* _tmp6_;
		TunerStationList* _tmp7_;
#line 172 "../src/Widgets/Window.vala"
		_tmp1_ = _data11_->s2;
#line 172 "../src/Widgets/Window.vala"
		_tmp2_ = tuner_station_source_next (_tmp1_, &_inner_error0_);
#line 172 "../src/Widgets/Window.vala"
		_tmp0_ = _tmp2_;
#line 172 "../src/Widgets/Window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 172 "../src/Widgets/Window.vala"
			if (_inner_error0_->domain == SOURCE_ERROR) {
#line 2347 "Window.c"
				goto __catch0_source_error;
			}
#line 172 "../src/Widgets/Window.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 172 "../src/Widgets/Window.vala"
			g_clear_error (&_inner_error0_);
#line 172 "../src/Widgets/Window.vala"
			return;
#line 2356 "Window.c"
		}
#line 172 "../src/Widgets/Window.vala"
		_tmp3_ = tuner_station_list_new_with_stations (_tmp0_);
#line 172 "../src/Widgets/Window.vala"
		g_object_ref_sink (_tmp3_);
#line 172 "../src/Widgets/Window.vala"
		slist = _tmp3_;
#line 173 "../src/Widgets/Window.vala"
		_tmp4_ = slist;
#line 173 "../src/Widgets/Window.vala"
		g_signal_connect_object (_tmp4_, "selection-changed", (GCallback) _tuner_window_handle_station_click_tuner_station_list_selection_changed, self, 0);
#line 174 "../src/Widgets/Window.vala"
		_tmp5_ = slist;
#line 174 "../src/Widgets/Window.vala"
		g_signal_connect_object (_tmp5_, "favourites-changed", (GCallback) _tuner_window_handle_favourites_changed_tuner_station_list_favourites_changed, self, 0);
#line 175 "../src/Widgets/Window.vala"
		_tmp6_ = _data11_->c2;
#line 175 "../src/Widgets/Window.vala"
		_tmp7_ = slist;
#line 175 "../src/Widgets/Window.vala"
		tuner_content_box_set_content (_tmp6_, (TunerAbstractContentList*) _tmp7_);
#line 171 "../src/Widgets/Window.vala"
		_g_object_unref0 (slist);
#line 171 "../src/Widgets/Window.vala"
		_g_object_unref0 (_tmp0_);
#line 2382 "Window.c"
	}
	goto __finally0;
	__catch0_source_error:
	{
		TunerContentBox* _tmp8_;
#line 171 "../src/Widgets/Window.vala"
		g_clear_error (&_inner_error0_);
#line 177 "../src/Widgets/Window.vala"
		_tmp8_ = _data11_->c2;
#line 177 "../src/Widgets/Window.vala"
		tuner_content_box_show_alert (_tmp8_);
#line 2394 "Window.c"
	}
	__finally0:
#line 171 "../src/Widgets/Window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 171 "../src/Widgets/Window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 171 "../src/Widgets/Window.vala"
		g_clear_error (&_inner_error0_);
#line 171 "../src/Widgets/Window.vala"
		return;
#line 2405 "Window.c"
	}
}

static void
__tuner_window___lambda44__gtk_widget_realize (GtkWidget* _sender,
                                               gpointer self)
{
#line 170 "../src/Widgets/Window.vala"
	_tuner_window___lambda44_ (self);
#line 2415 "Window.c"
}

static void
_tuner_window___lambda45_ (Block11Data* _data11_)
{
	TunerWindow* self;
	GError* _inner_error0_ = NULL;
#line 191 "../src/Widgets/Window.vala"
	self = _data11_->self;
#line 2425 "Window.c"
	{
		GeeArrayList* _tmp0_ = NULL;
		TunerStationSource* _tmp1_;
		GeeArrayList* _tmp2_;
		TunerStationList* slist = NULL;
		TunerStationList* _tmp3_;
		TunerStationList* _tmp4_;
		TunerStationList* _tmp5_;
		TunerContentBox* _tmp6_;
		TunerStationList* _tmp7_;
#line 193 "../src/Widgets/Window.vala"
		_tmp1_ = _data11_->s3;
#line 193 "../src/Widgets/Window.vala"
		_tmp2_ = tuner_station_source_next (_tmp1_, &_inner_error0_);
#line 193 "../src/Widgets/Window.vala"
		_tmp0_ = _tmp2_;
#line 193 "../src/Widgets/Window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 193 "../src/Widgets/Window.vala"
			if (_inner_error0_->domain == SOURCE_ERROR) {
#line 2446 "Window.c"
				goto __catch0_source_error;
			}
#line 193 "../src/Widgets/Window.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 193 "../src/Widgets/Window.vala"
			g_clear_error (&_inner_error0_);
#line 193 "../src/Widgets/Window.vala"
			return;
#line 2455 "Window.c"
		}
#line 193 "../src/Widgets/Window.vala"
		_tmp3_ = tuner_station_list_new_with_stations (_tmp0_);
#line 193 "../src/Widgets/Window.vala"
		g_object_ref_sink (_tmp3_);
#line 193 "../src/Widgets/Window.vala"
		slist = _tmp3_;
#line 194 "../src/Widgets/Window.vala"
		_tmp4_ = slist;
#line 194 "../src/Widgets/Window.vala"
		g_signal_connect_object (_tmp4_, "selection-changed", (GCallback) _tuner_window_handle_station_click_tuner_station_list_selection_changed, self, 0);
#line 195 "../src/Widgets/Window.vala"
		_tmp5_ = slist;
#line 195 "../src/Widgets/Window.vala"
		g_signal_connect_object (_tmp5_, "favourites-changed", (GCallback) _tuner_window_handle_favourites_changed_tuner_station_list_favourites_changed, self, 0);
#line 196 "../src/Widgets/Window.vala"
		_tmp6_ = _data11_->c3;
#line 196 "../src/Widgets/Window.vala"
		_tmp7_ = slist;
#line 196 "../src/Widgets/Window.vala"
		tuner_content_box_set_content (_tmp6_, (TunerAbstractContentList*) _tmp7_);
#line 192 "../src/Widgets/Window.vala"
		_g_object_unref0 (slist);
#line 192 "../src/Widgets/Window.vala"
		_g_object_unref0 (_tmp0_);
#line 2481 "Window.c"
	}
	goto __finally0;
	__catch0_source_error:
	{
		TunerContentBox* _tmp8_;
#line 192 "../src/Widgets/Window.vala"
		g_clear_error (&_inner_error0_);
#line 198 "../src/Widgets/Window.vala"
		_tmp8_ = _data11_->c3;
#line 198 "../src/Widgets/Window.vala"
		tuner_content_box_show_alert (_tmp8_);
#line 2493 "Window.c"
	}
	__finally0:
#line 192 "../src/Widgets/Window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 192 "../src/Widgets/Window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 192 "../src/Widgets/Window.vala"
		g_clear_error (&_inner_error0_);
#line 192 "../src/Widgets/Window.vala"
		return;
#line 2504 "Window.c"
	}
}

static void
__tuner_window___lambda45__gtk_widget_realize (GtkWidget* _sender,
                                               gpointer self)
{
#line 191 "../src/Widgets/Window.vala"
	_tuner_window___lambda45_ (self);
#line 2514 "Window.c"
}

static Block12Data*
block12_data_ref (Block12Data* _data12_)
{
#line 213 "../src/Widgets/Window.vala"
	g_atomic_int_inc (&_data12_->_ref_count_);
#line 213 "../src/Widgets/Window.vala"
	return _data12_;
#line 2524 "Window.c"
}

static void
block12_data_unref (void * _userdata_)
{
	Block12Data* _data12_;
	_data12_ = (Block12Data*) _userdata_;
#line 213 "../src/Widgets/Window.vala"
	if (g_atomic_int_dec_and_test (&_data12_->_ref_count_)) {
#line 2534 "Window.c"
		TunerWindow* self;
#line 213 "../src/Widgets/Window.vala"
		self = _data12_->_data11_->self;
#line 213 "../src/Widgets/Window.vala"
		_g_object_unref0 (_data12_->s_country);
#line 213 "../src/Widgets/Window.vala"
		block11_data_unref (_data12_->_data11_);
#line 213 "../src/Widgets/Window.vala"
		_data12_->_data11_ = NULL;
#line 213 "../src/Widgets/Window.vala"
		g_slice_free (Block12Data, _data12_);
#line 2546 "Window.c"
	}
}

static void
__lambda47_ (Block12Data* _data12_)
{
	Block11Data* _data11_;
	TunerWindow* self;
	GError* _inner_error0_ = NULL;
#line 228 "../src/Widgets/Window.vala"
	_data11_ = _data12_->_data11_;
#line 228 "../src/Widgets/Window.vala"
	self = _data11_->self;
#line 2560 "Window.c"
	{
		GeeArrayList* stations = NULL;
		TunerStationSource* _tmp0_;
		GeeArrayList* _tmp1_;
		TunerStationList* _tmp2_;
		GeeArrayList* _tmp3_;
		GeeArrayList* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		TunerContentBox* _tmp11_;
		TunerStationList* _tmp12_;
#line 230 "../src/Widgets/Window.vala"
		_tmp0_ = _data12_->s_country;
#line 230 "../src/Widgets/Window.vala"
		_tmp1_ = tuner_station_source_next (_tmp0_, &_inner_error0_);
#line 230 "../src/Widgets/Window.vala"
		stations = _tmp1_;
#line 230 "../src/Widgets/Window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 230 "../src/Widgets/Window.vala"
			if (_inner_error0_->domain == SOURCE_ERROR) {
#line 2586 "Window.c"
				goto __catch0_source_error;
			}
#line 230 "../src/Widgets/Window.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 230 "../src/Widgets/Window.vala"
			g_clear_error (&_inner_error0_);
#line 230 "../src/Widgets/Window.vala"
			return;
#line 2595 "Window.c"
		}
#line 231 "../src/Widgets/Window.vala"
		_tmp2_ = _data11_->c_slist;
#line 231 "../src/Widgets/Window.vala"
		_tmp3_ = stations;
#line 231 "../src/Widgets/Window.vala"
		tuner_station_list_set_stations (_tmp2_, _tmp3_);
#line 232 "../src/Widgets/Window.vala"
		_tmp4_ = stations;
#line 232 "../src/Widgets/Window.vala"
		_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 232 "../src/Widgets/Window.vala"
		_tmp6_ = _tmp5_;
#line 232 "../src/Widgets/Window.vala"
		_tmp7_ = g_strdup_printf ("%i", _tmp6_);
#line 232 "../src/Widgets/Window.vala"
		_tmp8_ = _tmp7_;
#line 232 "../src/Widgets/Window.vala"
		_tmp9_ = g_strconcat ("Length of country stations: ", _tmp8_, NULL);
#line 232 "../src/Widgets/Window.vala"
		_tmp10_ = _tmp9_;
#line 232 "../src/Widgets/Window.vala"
		g_warning ("Window.vala:232: %s", _tmp10_);
#line 232 "../src/Widgets/Window.vala"
		_g_free0 (_tmp10_);
#line 232 "../src/Widgets/Window.vala"
		_g_free0 (_tmp8_);
#line 233 "../src/Widgets/Window.vala"
		_tmp11_ = _data11_->c_country;
#line 233 "../src/Widgets/Window.vala"
		_tmp12_ = _data11_->c_slist;
#line 233 "../src/Widgets/Window.vala"
		tuner_content_box_set_content (_tmp11_, (TunerAbstractContentList*) _tmp12_);
#line 229 "../src/Widgets/Window.vala"
		_g_object_unref0 (stations);
#line 2631 "Window.c"
	}
	goto __finally0;
	__catch0_source_error:
	{
		TunerContentBox* _tmp13_;
#line 229 "../src/Widgets/Window.vala"
		g_clear_error (&_inner_error0_);
#line 235 "../src/Widgets/Window.vala"
		_tmp13_ = _data11_->c_country;
#line 235 "../src/Widgets/Window.vala"
		tuner_content_box_show_alert (_tmp13_);
#line 2643 "Window.c"
	}
	__finally0:
#line 229 "../src/Widgets/Window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 229 "../src/Widgets/Window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 229 "../src/Widgets/Window.vala"
		g_clear_error (&_inner_error0_);
#line 229 "../src/Widgets/Window.vala"
		return;
#line 2654 "Window.c"
	}
}

static void
___lambda47__gtk_widget_realize (GtkWidget* _sender,
                                 gpointer self)
{
#line 228 "../src/Widgets/Window.vala"
	__lambda47_ (self);
#line 2664 "Window.c"
}

static void
_tuner_window___lambda46_ (Block11Data* _data11_,
                           GObject* obj,
                           GAsyncResult* res)
{
	TunerWindow* self;
	Block12Data* _data12_;
	gchar* country = NULL;
	gchar* country_name = NULL;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	GraniteWidgetsSourceListItem* _tmp5_;
	const gchar* _tmp6_;
	TunerContentBox* _tmp7_;
	TunerHeaderLabel* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	TunerDirectoryController* _tmp14_;
	const gchar* _tmp15_;
	TunerStationSource* _tmp16_;
	GraniteWidgetsSourceListExpandableItem* _tmp17_;
	GraniteWidgetsSourceListItem* _tmp18_;
	TunerContentBox* _tmp19_;
	GError* _inner_error0_ = NULL;
#line 213 "../src/Widgets/Window.vala"
	self = _data11_->self;
#line 213 "../src/Widgets/Window.vala"
	g_return_if_fail (res != NULL);
#line 213 "../src/Widgets/Window.vala"
	_data12_ = g_slice_new0 (Block12Data);
#line 213 "../src/Widgets/Window.vala"
	_data12_->_ref_count_ = 1;
#line 213 "../src/Widgets/Window.vala"
	_data12_->_data11_ = block11_data_ref (_data11_);
#line 2704 "Window.c"
	{
		gchar* _tmp0_ = NULL;
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 216 "../src/Widgets/Window.vala"
		_tmp1_ = tuner_location_discovery_country_code_finish (res, &_inner_error0_);
#line 216 "../src/Widgets/Window.vala"
		_tmp0_ = _tmp1_;
#line 216 "../src/Widgets/Window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2715 "Window.c"
			goto __catch0_g_error;
		}
#line 216 "../src/Widgets/Window.vala"
		_tmp2_ = _tmp0_;
#line 216 "../src/Widgets/Window.vala"
		_tmp0_ = NULL;
#line 216 "../src/Widgets/Window.vala"
		_g_free0 (country);
#line 216 "../src/Widgets/Window.vala"
		country = _tmp2_;
#line 215 "../src/Widgets/Window.vala"
		_g_free0 (_tmp0_);
#line 2728 "Window.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 215 "../src/Widgets/Window.vala"
		g_clear_error (&_inner_error0_);
#line 220 "../src/Widgets/Window.vala"
		_g_free0 (country);
#line 220 "../src/Widgets/Window.vala"
		block12_data_unref (_data12_);
#line 220 "../src/Widgets/Window.vala"
		_data12_ = NULL;
#line 220 "../src/Widgets/Window.vala"
		return;
#line 2743 "Window.c"
	}
	__finally0:
#line 215 "../src/Widgets/Window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 215 "../src/Widgets/Window.vala"
		_g_free0 (country);
#line 215 "../src/Widgets/Window.vala"
		block12_data_unref (_data12_);
#line 215 "../src/Widgets/Window.vala"
		_data12_ = NULL;
#line 215 "../src/Widgets/Window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 215 "../src/Widgets/Window.vala"
		g_clear_error (&_inner_error0_);
#line 215 "../src/Widgets/Window.vala"
		return;
#line 2760 "Window.c"
	}
#line 223 "../src/Widgets/Window.vala"
	_tmp3_ = country;
#line 223 "../src/Widgets/Window.vala"
	_tmp4_ = tuner_model_countries_get_by_code (_tmp3_, "");
#line 223 "../src/Widgets/Window.vala"
	country_name = _tmp4_;
#line 224 "../src/Widgets/Window.vala"
	_tmp5_ = _data11_->item4;
#line 224 "../src/Widgets/Window.vala"
	_tmp6_ = country_name;
#line 224 "../src/Widgets/Window.vala"
	granite_widgets_source_list_item_set_name (_tmp5_, _tmp6_);
#line 225 "../src/Widgets/Window.vala"
	_tmp7_ = _data11_->c_country;
#line 225 "../src/Widgets/Window.vala"
	_tmp8_ = _tmp7_->header_label;
#line 225 "../src/Widgets/Window.vala"
	_tmp9_ = g_strconcat (_ ("Top 100 in"), " ", NULL);
#line 225 "../src/Widgets/Window.vala"
	_tmp10_ = _tmp9_;
#line 225 "../src/Widgets/Window.vala"
	_tmp11_ = country_name;
#line 225 "../src/Widgets/Window.vala"
	_tmp12_ = g_strconcat (_tmp10_, _tmp11_, NULL);
#line 225 "../src/Widgets/Window.vala"
	_tmp13_ = _tmp12_;
#line 225 "../src/Widgets/Window.vala"
	gtk_label_set_label ((GtkLabel*) _tmp8_, _tmp13_);
#line 225 "../src/Widgets/Window.vala"
	_g_free0 (_tmp13_);
#line 225 "../src/Widgets/Window.vala"
	_g_free0 (_tmp10_);
#line 226 "../src/Widgets/Window.vala"
	_tmp14_ = self->priv->_directory;
#line 226 "../src/Widgets/Window.vala"
	_tmp15_ = country;
#line 226 "../src/Widgets/Window.vala"
	_tmp16_ = tuner_directory_controller_load_by_country (_tmp14_, (guint) 100, _tmp15_);
#line 226 "../src/Widgets/Window.vala"
	_data12_->s_country = _tmp16_;
#line 227 "../src/Widgets/Window.vala"
	_tmp17_ = _data11_->selections_category;
#line 227 "../src/Widgets/Window.vala"
	_tmp18_ = _data11_->item4;
#line 227 "../src/Widgets/Window.vala"
	granite_widgets_source_list_expandable_item_add (_tmp17_, _tmp18_);
#line 228 "../src/Widgets/Window.vala"
	_tmp19_ = _data11_->c_country;
#line 228 "../src/Widgets/Window.vala"
	g_signal_connect_data ((GtkWidget*) _tmp19_, "realize", (GCallback) ___lambda47__gtk_widget_realize, block12_data_ref (_data12_), (GClosureNotify) block12_data_unref, 0);
#line 213 "../src/Widgets/Window.vala"
	_g_free0 (country_name);
#line 213 "../src/Widgets/Window.vala"
	_g_free0 (country);
#line 213 "../src/Widgets/Window.vala"
	block12_data_unref (_data12_);
#line 213 "../src/Widgets/Window.vala"
	_data12_ = NULL;
#line 2820 "Window.c"
}

static void
__tuner_window___lambda46__gasync_ready_callback (GObject* source_object,
                                                  GAsyncResult* res,
                                                  gpointer self)
{
#line 213 "../src/Widgets/Window.vala"
	_tuner_window___lambda46_ (self, source_object, res);
#line 213 "../src/Widgets/Window.vala"
	block11_data_unref (self);
#line 2832 "Window.c"
}

static gpointer
_tuner_model_genre_ref0 (gpointer self)
{
#line 273 "../src/Widgets/Window.vala"
	return self ? tuner_model_genre_ref (self) : NULL;
#line 2840 "Window.c"
}

static Block13Data*
block13_data_ref (Block13Data* _data13_)
{
#line 273 "../src/Widgets/Window.vala"
	g_atomic_int_inc (&_data13_->_ref_count_);
#line 273 "../src/Widgets/Window.vala"
	return _data13_;
#line 2850 "Window.c"
}

static void
block13_data_unref (void * _userdata_)
{
	Block13Data* _data13_;
	_data13_ = (Block13Data*) _userdata_;
#line 273 "../src/Widgets/Window.vala"
	if (g_atomic_int_dec_and_test (&_data13_->_ref_count_)) {
#line 2860 "Window.c"
		TunerWindow* self;
#line 273 "../src/Widgets/Window.vala"
		self = _data13_->_data11_->self;
#line 273 "../src/Widgets/Window.vala"
		_g_object_unref0 (_data13_->ds);
#line 273 "../src/Widgets/Window.vala"
		_g_object_unref0 (_data13_->cb);
#line 273 "../src/Widgets/Window.vala"
		block11_data_unref (_data13_->_data11_);
#line 273 "../src/Widgets/Window.vala"
		_data13_->_data11_ = NULL;
#line 273 "../src/Widgets/Window.vala"
		g_slice_free (Block13Data, _data13_);
#line 2874 "Window.c"
	}
}

static gchar**
_vala_array_dup8 (gchar** self,
                  gssize length)
{
#line 279 "../src/Widgets/Window.vala"
	if (length >= 0) {
#line 2884 "Window.c"
		gchar** result;
		gssize i;
#line 279 "../src/Widgets/Window.vala"
		result = g_new0 (gchar*, length + 1);
#line 279 "../src/Widgets/Window.vala"
		for (i = 0; i < length; i++) {
#line 2891 "Window.c"
			gchar* _tmp0_;
#line 279 "../src/Widgets/Window.vala"
			_tmp0_ = g_strdup (self[i]);
#line 279 "../src/Widgets/Window.vala"
			result[i] = _tmp0_;
#line 2897 "Window.c"
		}
#line 279 "../src/Widgets/Window.vala"
		return result;
#line 2901 "Window.c"
	}
#line 279 "../src/Widgets/Window.vala"
	return NULL;
#line 2905 "Window.c"
}

static void
_tuner_window_____lambda48_ (Block13Data* _data13_)
{
	Block11Data* _data11_;
	TunerWindow* self;
	GError* _inner_error0_ = NULL;
#line 281 "../src/Widgets/Window.vala"
	_data11_ = _data13_->_data11_;
#line 281 "../src/Widgets/Window.vala"
	self = _data11_->self;
#line 2918 "Window.c"
	{
		GeeArrayList* _tmp0_ = NULL;
		TunerStationSource* _tmp1_;
		GeeArrayList* _tmp2_;
		TunerStationList* slist1 = NULL;
		TunerStationList* _tmp3_;
		TunerStationList* _tmp4_;
		TunerStationList* _tmp5_;
		TunerContentBox* _tmp6_;
		TunerStationList* _tmp7_;
#line 283 "../src/Widgets/Window.vala"
		_tmp1_ = _data13_->ds;
#line 283 "../src/Widgets/Window.vala"
		_tmp2_ = tuner_station_source_next (_tmp1_, &_inner_error0_);
#line 283 "../src/Widgets/Window.vala"
		_tmp0_ = _tmp2_;
#line 283 "../src/Widgets/Window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 283 "../src/Widgets/Window.vala"
			if (_inner_error0_->domain == SOURCE_ERROR) {
#line 2939 "Window.c"
				goto __catch0_source_error;
			}
#line 283 "../src/Widgets/Window.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 283 "../src/Widgets/Window.vala"
			g_clear_error (&_inner_error0_);
#line 283 "../src/Widgets/Window.vala"
			return;
#line 2948 "Window.c"
		}
#line 283 "../src/Widgets/Window.vala"
		_tmp3_ = tuner_station_list_new_with_stations (_tmp0_);
#line 283 "../src/Widgets/Window.vala"
		g_object_ref_sink (_tmp3_);
#line 283 "../src/Widgets/Window.vala"
		slist1 = _tmp3_;
#line 284 "../src/Widgets/Window.vala"
		_tmp4_ = slist1;
#line 284 "../src/Widgets/Window.vala"
		g_signal_connect_object (_tmp4_, "selection-changed", (GCallback) _tuner_window_handle_station_click_tuner_station_list_selection_changed, self, 0);
#line 285 "../src/Widgets/Window.vala"
		_tmp5_ = slist1;
#line 285 "../src/Widgets/Window.vala"
		g_signal_connect_object (_tmp5_, "favourites-changed", (GCallback) _tuner_window_handle_favourites_changed_tuner_station_list_favourites_changed, self, 0);
#line 286 "../src/Widgets/Window.vala"
		_tmp6_ = _data13_->cb;
#line 286 "../src/Widgets/Window.vala"
		_tmp7_ = slist1;
#line 286 "../src/Widgets/Window.vala"
		tuner_content_box_set_content (_tmp6_, (TunerAbstractContentList*) _tmp7_);
#line 282 "../src/Widgets/Window.vala"
		_g_object_unref0 (slist1);
#line 282 "../src/Widgets/Window.vala"
		_g_object_unref0 (_tmp0_);
#line 2974 "Window.c"
	}
	goto __finally0;
	__catch0_source_error:
	{
		TunerContentBox* _tmp8_;
#line 282 "../src/Widgets/Window.vala"
		g_clear_error (&_inner_error0_);
#line 288 "../src/Widgets/Window.vala"
		_tmp8_ = _data13_->cb;
#line 288 "../src/Widgets/Window.vala"
		tuner_content_box_show_alert (_tmp8_);
#line 2986 "Window.c"
	}
	__finally0:
#line 282 "../src/Widgets/Window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 282 "../src/Widgets/Window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 282 "../src/Widgets/Window.vala"
		g_clear_error (&_inner_error0_);
#line 282 "../src/Widgets/Window.vala"
		return;
#line 2997 "Window.c"
	}
}

static void
__tuner_window_____lambda48__gtk_widget_realize (GtkWidget* _sender,
                                                 gpointer self)
{
#line 281 "../src/Widgets/Window.vala"
	_tuner_window_____lambda48_ (self);
#line 3007 "Window.c"
}

static void
_tuner_window___lambda49_ (TunerWindow* self,
                           gboolean starred)
{
	TunerPlayerController* _tmp0_;
	TunerModelStation* _tmp1_;
	TunerModelStation* _tmp2_;
#line 294 "../src/Widgets/Window.vala"
	_tmp0_ = self->priv->_player;
#line 294 "../src/Widgets/Window.vala"
	_tmp1_ = tuner_player_controller_get_station (_tmp0_);
#line 294 "../src/Widgets/Window.vala"
	_tmp2_ = _tmp1_;
#line 294 "../src/Widgets/Window.vala"
	tuner_model_station_toggle_starred (_tmp2_);
#line 3025 "Window.c"
}

static void
__tuner_window___lambda49__tuner_header_bar_star_clicked (TunerHeaderBar* _sender,
                                                          gboolean starred,
                                                          gpointer self)
{
#line 293 "../src/Widgets/Window.vala"
	_tuner_window___lambda49_ ((TunerWindow*) self, starred);
#line 3035 "Window.c"
}

static void
_tuner_window___lambda50_ (Block11Data* _data11_)
{
	TunerWindow* self;
	TunerStationList* _slist = NULL;
	TunerDirectoryController* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeArrayList* _tmp2_;
	TunerStationList* _tmp3_;
	TunerStationList* _tmp4_;
	TunerStationList* _tmp5_;
	TunerStationList* _tmp6_;
	TunerContentBox* _tmp7_;
	TunerStationList* _tmp8_;
#line 297 "../src/Widgets/Window.vala"
	self = _data11_->self;
#line 298 "../src/Widgets/Window.vala"
	_tmp0_ = self->priv->_directory;
#line 298 "../src/Widgets/Window.vala"
	_tmp1_ = tuner_directory_controller_get_stored (_tmp0_);
#line 298 "../src/Widgets/Window.vala"
	_tmp2_ = _tmp1_;
#line 298 "../src/Widgets/Window.vala"
	_tmp3_ = tuner_station_list_new_with_stations (_tmp2_);
#line 298 "../src/Widgets/Window.vala"
	g_object_ref_sink (_tmp3_);
#line 298 "../src/Widgets/Window.vala"
	_tmp4_ = _tmp3_;
#line 298 "../src/Widgets/Window.vala"
	_g_object_unref0 (_tmp2_);
#line 298 "../src/Widgets/Window.vala"
	_slist = _tmp4_;
#line 299 "../src/Widgets/Window.vala"
	_tmp5_ = _slist;
#line 299 "../src/Widgets/Window.vala"
	g_signal_connect_object (_tmp5_, "selection-changed", (GCallback) _tuner_window_handle_station_click_tuner_station_list_selection_changed, self, 0);
#line 300 "../src/Widgets/Window.vala"
	_tmp6_ = _slist;
#line 300 "../src/Widgets/Window.vala"
	g_signal_connect_object (_tmp6_, "favourites-changed", (GCallback) _tuner_window_handle_favourites_changed_tuner_station_list_favourites_changed, self, 0);
#line 301 "../src/Widgets/Window.vala"
	_tmp7_ = _data11_->c4;
#line 301 "../src/Widgets/Window.vala"
	_tmp8_ = _slist;
#line 301 "../src/Widgets/Window.vala"
	tuner_content_box_set_content (_tmp7_, (TunerAbstractContentList*) _tmp8_);
#line 297 "../src/Widgets/Window.vala"
	_g_object_unref0 (_slist);
#line 3086 "Window.c"
}

static void
__tuner_window___lambda50__tuner_window_refresh_favourites (TunerWindow* _sender,
                                                            gpointer self)
{
#line 297 "../src/Widgets/Window.vala"
	_tuner_window___lambda50_ (self);
#line 3095 "Window.c"
}

static void
_tuner_window___lambda51_ (Block11Data* _data11_,
                           GraniteWidgetsSourceListItem* item)
{
	TunerWindow* self;
	gchar* selected_item = NULL;
	gconstpointer _tmp0_;
	gchar* _tmp1_;
	GtkStack* _tmp2_;
	const gchar* _tmp3_;
#line 310 "../src/Widgets/Window.vala"
	self = _data11_->self;
#line 311 "../src/Widgets/Window.vala"
	_tmp0_ = g_object_get_data ((GObject*) item, "stack_child");
#line 311 "../src/Widgets/Window.vala"
	_tmp1_ = g_strdup ((const gchar*) _tmp0_);
#line 311 "../src/Widgets/Window.vala"
	selected_item = _tmp1_;
#line 312 "../src/Widgets/Window.vala"
	_tmp2_ = _data11_->stack;
#line 312 "../src/Widgets/Window.vala"
	_tmp3_ = selected_item;
#line 312 "../src/Widgets/Window.vala"
	gtk_stack_set_visible_child_name (_tmp2_, _tmp3_);
#line 310 "../src/Widgets/Window.vala"
	_g_free0 (selected_item);
#line 3124 "Window.c"
}

static void
__tuner_window___lambda51__granite_widgets_source_list_item_selected (GraniteWidgetsSourceList* _sender,
                                                                      GraniteWidgetsSourceListItem* item,
                                                                      gpointer self)
{
#line 310 "../src/Widgets/Window.vala"
	_tuner_window___lambda51_ (self, item);
#line 3134 "Window.c"
}

static void
_tuner_window___lambda52_ (Block11Data* _data11_,
                           const gchar* text)
{
	TunerWindow* self;
	gint _tmp0_;
	gint _tmp1_;
	GError* _inner_error0_ = NULL;
#line 315 "../src/Widgets/Window.vala"
	self = _data11_->self;
#line 315 "../src/Widgets/Window.vala"
	g_return_if_fail (text != NULL);
#line 316 "../src/Widgets/Window.vala"
	_tmp0_ = strlen (text);
#line 316 "../src/Widgets/Window.vala"
	_tmp1_ = _tmp0_;
#line 316 "../src/Widgets/Window.vala"
	if (_tmp1_ > 0) {
#line 3155 "Window.c"
		gchar* mytext = NULL;
		gchar* _tmp2_;
		TunerStationSource* s5 = NULL;
		TunerDirectoryController* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		TunerStationSource* _tmp6_;
#line 317 "../src/Widgets/Window.vala"
		_tmp2_ = g_strdup (text);
#line 317 "../src/Widgets/Window.vala"
		mytext = _tmp2_;
#line 318 "../src/Widgets/Window.vala"
		_tmp3_ = self->priv->_directory;
#line 318 "../src/Widgets/Window.vala"
		_tmp4_ = mytext;
#line 318 "../src/Widgets/Window.vala"
		_tmp5_ = g_strdup (_tmp4_);
#line 318 "../src/Widgets/Window.vala"
		_tmp6_ = tuner_directory_controller_load_search_stations (_tmp3_, _tmp5_, (guint) 100);
#line 318 "../src/Widgets/Window.vala"
		s5 = _tmp6_;
#line 3177 "Window.c"
		{
			GeeArrayList* stations = NULL;
			TunerStationSource* _tmp7_;
			GeeArrayList* _tmp8_;
			gboolean _tmp9_ = FALSE;
			GeeArrayList* _tmp10_;
#line 320 "../src/Widgets/Window.vala"
			_tmp7_ = s5;
#line 320 "../src/Widgets/Window.vala"
			_tmp8_ = tuner_station_source_next (_tmp7_, &_inner_error0_);
#line 320 "../src/Widgets/Window.vala"
			stations = _tmp8_;
#line 320 "../src/Widgets/Window.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 320 "../src/Widgets/Window.vala"
				if (_inner_error0_->domain == SOURCE_ERROR) {
#line 3194 "Window.c"
					goto __catch0_source_error;
				}
#line 320 "../src/Widgets/Window.vala"
				_g_object_unref0 (s5);
#line 320 "../src/Widgets/Window.vala"
				_g_free0 (mytext);
#line 320 "../src/Widgets/Window.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 320 "../src/Widgets/Window.vala"
				g_clear_error (&_inner_error0_);
#line 320 "../src/Widgets/Window.vala"
				return;
#line 3207 "Window.c"
			}
#line 321 "../src/Widgets/Window.vala"
			_tmp10_ = stations;
#line 321 "../src/Widgets/Window.vala"
			if (_tmp10_ == NULL) {
#line 321 "../src/Widgets/Window.vala"
				_tmp9_ = TRUE;
#line 3215 "Window.c"
			} else {
				GeeArrayList* _tmp11_;
				gint _tmp12_;
				gint _tmp13_;
#line 321 "../src/Widgets/Window.vala"
				_tmp11_ = stations;
#line 321 "../src/Widgets/Window.vala"
				_tmp12_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp11_);
#line 321 "../src/Widgets/Window.vala"
				_tmp13_ = _tmp12_;
#line 321 "../src/Widgets/Window.vala"
				_tmp9_ = _tmp13_ == 0;
#line 3228 "Window.c"
			}
#line 321 "../src/Widgets/Window.vala"
			if (_tmp9_) {
#line 3232 "Window.c"
				TunerContentBox* _tmp14_;
#line 322 "../src/Widgets/Window.vala"
				_tmp14_ = _data11_->c5;
#line 322 "../src/Widgets/Window.vala"
				tuner_content_box_show_nothing_found (_tmp14_);
#line 3238 "Window.c"
			} else {
				TunerStationList* _slist = NULL;
				GeeArrayList* _tmp15_;
				TunerStationList* _tmp16_;
				TunerStationList* _tmp17_;
				TunerStationList* _tmp18_;
				TunerContentBox* _tmp19_;
				TunerStationList* _tmp20_;
#line 324 "../src/Widgets/Window.vala"
				_tmp15_ = stations;
#line 324 "../src/Widgets/Window.vala"
				_tmp16_ = tuner_station_list_new_with_stations (_tmp15_);
#line 324 "../src/Widgets/Window.vala"
				g_object_ref_sink (_tmp16_);
#line 324 "../src/Widgets/Window.vala"
				_slist = _tmp16_;
#line 325 "../src/Widgets/Window.vala"
				_tmp17_ = _slist;
#line 325 "../src/Widgets/Window.vala"
				g_signal_connect_object (_tmp17_, "selection-changed", (GCallback) _tuner_window_handle_station_click_tuner_station_list_selection_changed, self, 0);
#line 326 "../src/Widgets/Window.vala"
				_tmp18_ = _slist;
#line 326 "../src/Widgets/Window.vala"
				g_signal_connect_object (_tmp18_, "favourites-changed", (GCallback) _tuner_window_handle_favourites_changed_tuner_station_list_favourites_changed, self, 0);
#line 327 "../src/Widgets/Window.vala"
				_tmp19_ = _data11_->c5;
#line 327 "../src/Widgets/Window.vala"
				_tmp20_ = _slist;
#line 327 "../src/Widgets/Window.vala"
				tuner_content_box_set_content (_tmp19_, (TunerAbstractContentList*) _tmp20_);
#line 321 "../src/Widgets/Window.vala"
				_g_object_unref0 (_slist);
#line 3271 "Window.c"
			}
#line 319 "../src/Widgets/Window.vala"
			_g_object_unref0 (stations);
#line 3275 "Window.c"
		}
		goto __finally0;
		__catch0_source_error:
		{
			TunerContentBox* _tmp21_;
#line 319 "../src/Widgets/Window.vala"
			g_clear_error (&_inner_error0_);
#line 330 "../src/Widgets/Window.vala"
			_tmp21_ = _data11_->c5;
#line 330 "../src/Widgets/Window.vala"
			tuner_content_box_show_alert (_tmp21_);
#line 3287 "Window.c"
		}
		__finally0:
#line 319 "../src/Widgets/Window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 319 "../src/Widgets/Window.vala"
			_g_object_unref0 (s5);
#line 319 "../src/Widgets/Window.vala"
			_g_free0 (mytext);
#line 319 "../src/Widgets/Window.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 319 "../src/Widgets/Window.vala"
			g_clear_error (&_inner_error0_);
#line 319 "../src/Widgets/Window.vala"
			return;
#line 3302 "Window.c"
		}
#line 316 "../src/Widgets/Window.vala"
		_g_object_unref0 (s5);
#line 316 "../src/Widgets/Window.vala"
		_g_free0 (mytext);
#line 3308 "Window.c"
	}
}

static void
__tuner_window___lambda52__tuner_header_bar_searched_for (TunerHeaderBar* _sender,
                                                          const gchar* text,
                                                          gpointer self)
{
#line 315 "../src/Widgets/Window.vala"
	_tuner_window___lambda52_ (self, text);
#line 3319 "Window.c"
}

static void
_tuner_window___lambda53_ (Block11Data* _data11_)
{
	TunerWindow* self;
	GtkStack* _tmp0_;
#line 335 "../src/Widgets/Window.vala"
	self = _data11_->self;
#line 336 "../src/Widgets/Window.vala"
	_tmp0_ = _data11_->stack;
#line 336 "../src/Widgets/Window.vala"
	gtk_stack_set_visible_child_name (_tmp0_, "searched");
#line 3333 "Window.c"
}

static void
__tuner_window___lambda53__tuner_header_bar_search_focused (TunerHeaderBar* _sender,
                                                            gpointer self)
{
#line 335 "../src/Widgets/Window.vala"
	_tuner_window___lambda53_ (self);
#line 3342 "Window.c"
}

static GObject *
tuner_window_constructor (GType type,
                          guint n_construct_properties,
                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	TunerWindow * self;
	Block11Data* _data11_;
	TunerHeaderBar* _tmp0_;
	TunerHeaderBar* _tmp1_;
	TunerPlayerController* _tmp2_;
	TunerPlayerController* _tmp3_;
	TunerHeaderBar* _tmp4_;
	TunerPlayerController* _tmp5_;
	TunerPlayerController* _tmp6_;
	TunerHeaderBar* _tmp7_;
	GtkVolumeButton* _tmp8_;
	GSettings* _tmp9_;
	GraniteSettings* granite_settings = NULL;
	GraniteSettings* _tmp10_;
	GraniteSettings* _tmp11_;
	GraniteSettings* _tmp12_;
	GSettings* _tmp13_;
	GVariant* _tmp14_;
	GSettings* _tmp15_;
	GVariant* _tmp16_;
	GSettings* _tmp17_;
	GSettings* _tmp18_;
	GdkGeometry _tmp19_ = {0};
	GSettings* _tmp20_;
	GSettings* _tmp21_;
	GtkStack* _tmp22_;
	GtkStack* _tmp23_;
	gchar* data_file = NULL;
	TunerApplication* _tmp24_;
	TunerApplication* _tmp25_;
	const gchar* _tmp26_;
	const gchar* _tmp27_;
	gchar* _tmp28_;
	TunerModelStationStore* store = NULL;
	const gchar* _tmp29_;
	TunerModelStationStore* _tmp30_;
	TunerModelStationStore* _tmp31_;
	TunerDirectoryController* _tmp32_;
	GtkPaned* primary_box = NULL;
	GtkPaned* _tmp33_;
	GraniteWidgetsSourceListExpandableItem* _tmp34_;
	GraniteWidgetsSourceListExpandableItem* _tmp35_;
	GraniteWidgetsSourceListExpandableItem* _tmp36_;
	GraniteWidgetsSourceListExpandableItem* searched_category = NULL;
	GraniteWidgetsSourceListExpandableItem* _tmp37_;
	GraniteWidgetsSourceListExpandableItem* _tmp38_;
	GraniteWidgetsSourceListExpandableItem* _tmp39_;
	GraniteWidgetsSourceListExpandableItem* genres_category = NULL;
	GraniteWidgetsSourceListExpandableItem* _tmp40_;
	GraniteWidgetsSourceListExpandableItem* _tmp41_;
	GraniteWidgetsSourceListExpandableItem* _tmp42_;
	GraniteWidgetsSourceListExpandableItem* _tmp43_;
	GraniteWidgetsSourceListExpandableItem* _tmp44_;
	GraniteWidgetsSourceList* _tmp45_;
	GraniteWidgetsSourceListItem* item1 = NULL;
	GraniteWidgetsSourceListItem* _tmp46_;
	GraniteWidgetsSourceListItem* _tmp47_;
	GThemedIcon* _tmp48_;
	GThemedIcon* _tmp49_;
	GraniteWidgetsSourceListExpandableItem* _tmp50_;
	GraniteWidgetsSourceListItem* _tmp51_;
	GraniteWidgetsSourceListItem* _tmp52_;
	GtkStack* _tmp53_;
	GraniteWidgetsSourceList* _tmp54_;
	TunerContentBox* _tmp55_;
	TunerDirectoryController* _tmp56_;
	TunerStationSource* _tmp57_;
	TunerContentBox* _tmp58_;
	TunerContentBox* _tmp59_;
	GraniteWidgetsSourceListItem* item2 = NULL;
	GraniteWidgetsSourceListItem* _tmp60_;
	GraniteWidgetsSourceListItem* _tmp61_;
	GThemedIcon* _tmp62_;
	GThemedIcon* _tmp63_;
	GraniteWidgetsSourceListExpandableItem* _tmp64_;
	GraniteWidgetsSourceListItem* _tmp65_;
	GraniteWidgetsSourceListItem* _tmp66_;
	GtkStack* _tmp67_;
	GraniteWidgetsSourceList* _tmp68_;
	TunerContentBox* _tmp69_;
	TunerDirectoryController* _tmp70_;
	TunerStationSource* _tmp71_;
	TunerContentBox* _tmp72_;
	GraniteWidgetsSourceListItem* item3 = NULL;
	GraniteWidgetsSourceListItem* _tmp73_;
	GraniteWidgetsSourceListItem* _tmp74_;
	GThemedIcon* _tmp75_;
	GThemedIcon* _tmp76_;
	GraniteWidgetsSourceListExpandableItem* _tmp77_;
	GraniteWidgetsSourceListItem* _tmp78_;
	GraniteWidgetsSourceListItem* _tmp79_;
	GtkStack* _tmp80_;
	GraniteWidgetsSourceList* _tmp81_;
	TunerContentBox* _tmp82_;
	TunerDirectoryController* _tmp83_;
	TunerStationSource* _tmp84_;
	TunerContentBox* _tmp85_;
	GraniteWidgetsSourceListItem* _tmp86_;
	GraniteWidgetsSourceListItem* _tmp87_;
	GThemedIcon* _tmp88_;
	GThemedIcon* _tmp89_;
	GraniteWidgetsSourceListItem* _tmp90_;
	GtkStack* _tmp91_;
	GraniteWidgetsSourceList* _tmp92_;
	TunerContentBox* _tmp93_;
	TunerStationList* _tmp94_;
	TunerStationList* _tmp95_;
	TunerStationList* _tmp96_;
	GraniteWidgetsSourceListItem* item5 = NULL;
	GraniteWidgetsSourceListItem* _tmp97_;
	GraniteWidgetsSourceListItem* _tmp98_;
	GThemedIcon* _tmp99_;
	GThemedIcon* _tmp100_;
	GraniteWidgetsSourceListExpandableItem* _tmp101_;
	GraniteWidgetsSourceListItem* _tmp102_;
	GraniteWidgetsSourceListItem* _tmp103_;
	GtkStack* _tmp104_;
	GraniteWidgetsSourceList* _tmp105_;
	TunerContentBox* _tmp106_;
	TunerStationList* slist = NULL;
	TunerDirectoryController* _tmp107_;
	GeeArrayList* _tmp108_;
	GeeArrayList* _tmp109_;
	TunerStationList* _tmp110_;
	TunerStationList* _tmp111_;
	TunerStationList* _tmp112_;
	TunerStationList* _tmp113_;
	TunerContentBox* _tmp114_;
	TunerStationList* _tmp115_;
	GraniteWidgetsSourceListItem* item6 = NULL;
	GraniteWidgetsSourceListItem* _tmp116_;
	GraniteWidgetsSourceListItem* _tmp117_;
	GThemedIcon* _tmp118_;
	GThemedIcon* _tmp119_;
	GraniteWidgetsSourceListExpandableItem* _tmp120_;
	GraniteWidgetsSourceListItem* _tmp121_;
	GraniteWidgetsSourceListItem* _tmp122_;
	GtkStack* _tmp123_;
	GraniteWidgetsSourceList* _tmp124_;
	TunerContentBox* _tmp125_;
	gint _tmp126_ = 0;
	TunerModelGenre** _tmp127_;
	TunerHeaderBar* _tmp154_;
	GraniteWidgetsSourceList* _tmp155_;
	GraniteWidgetsSourceListExpandableItem* _tmp156_;
	GraniteWidgetsSourceListExpandableItem* _tmp157_;
	GraniteWidgetsSourceListExpandableItem* _tmp158_;
	GraniteWidgetsSourceList* _tmp159_;
	GraniteWidgetsSourceListExpandableItem* _tmp160_;
	GraniteWidgetsSourceListExpandableItem* _tmp161_;
	GraniteWidgetsSourceListExpandableItem* _tmp162_;
	GraniteWidgetsSourceList* _tmp163_;
	GraniteWidgetsSourceListExpandableItem* _tmp164_;
	GraniteWidgetsSourceListExpandableItem* _tmp165_;
	GraniteWidgetsSourceListExpandableItem* _tmp166_;
	GraniteWidgetsSourceList* _tmp167_;
	GraniteWidgetsSourceList* _tmp168_;
	GraniteWidgetsSourceList* _tmp169_;
	GraniteWidgetsSourceListExpandableItem* _tmp170_;
	GraniteWidgetsSourceListItem* _tmp171_;
	GraniteWidgetsSourceListItem* _tmp172_;
	GraniteWidgetsSourceList* _tmp173_;
	TunerHeaderBar* _tmp174_;
	TunerHeaderBar* _tmp175_;
	GtkPaned* _tmp176_;
	GraniteWidgetsSourceList* _tmp177_;
	GtkPaned* _tmp178_;
	GtkStack* _tmp179_;
	GtkPaned* _tmp180_;
	GSettings* _tmp181_;
	GError* _inner_error0_ = NULL;
#line 59 "../src/Widgets/Window.vala"
	parent_class = G_OBJECT_CLASS (tuner_window_parent_class);
#line 59 "../src/Widgets/Window.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 59 "../src/Widgets/Window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUNER_TYPE_WINDOW, TunerWindow);
#line 59 "../src/Widgets/Window.vala"
	_data11_ = g_slice_new0 (Block11Data);
#line 59 "../src/Widgets/Window.vala"
	_data11_->_ref_count_ = 1;
#line 59 "../src/Widgets/Window.vala"
	_data11_->self = g_object_ref (self);
#line 60 "../src/Widgets/Window.vala"
	_tmp0_ = tuner_header_bar_new ();
#line 60 "../src/Widgets/Window.vala"
	g_object_ref_sink (_tmp0_);
#line 60 "../src/Widgets/Window.vala"
	_g_object_unref0 (self->priv->headerbar);
#line 60 "../src/Widgets/Window.vala"
	self->priv->headerbar = _tmp0_;
#line 61 "../src/Widgets/Window.vala"
	_tmp1_ = self->priv->headerbar;
#line 61 "../src/Widgets/Window.vala"
	gtk_window_set_titlebar ((GtkWindow*) self, (GtkWidget*) _tmp1_);
#line 62 "../src/Widgets/Window.vala"
	gtk_window_set_title ((GtkWindow*) self, TUNER_WINDOW_WindowName);
#line 64 "../src/Widgets/Window.vala"
	_tmp2_ = self->priv->_player;
#line 64 "../src/Widgets/Window.vala"
	g_signal_connect_object (_tmp2_, "state-changed", (GCallback) _tuner_window_handleplayer_state_changed_tuner_player_controller_state_changed, self, 0);
#line 65 "../src/Widgets/Window.vala"
	_tmp3_ = self->priv->_player;
#line 65 "../src/Widgets/Window.vala"
	_tmp4_ = self->priv->headerbar;
#line 65 "../src/Widgets/Window.vala"
	g_signal_connect_object (_tmp3_, "station-changed", (GCallback) _tuner_header_bar_update_from_station_tuner_player_controller_station_changed, _tmp4_, 0);
#line 66 "../src/Widgets/Window.vala"
	_tmp5_ = self->priv->_player;
#line 66 "../src/Widgets/Window.vala"
	g_signal_connect_object (_tmp5_, "title-changed", (GCallback) __tuner_window___lambda26__tuner_player_controller_title_changed, self, 0);
#line 69 "../src/Widgets/Window.vala"
	_tmp6_ = self->priv->_player;
#line 69 "../src/Widgets/Window.vala"
	g_signal_connect_object (_tmp6_, "volume-changed", (GCallback) __tuner_window___lambda27__tuner_player_controller_volume_changed, self, 0);
#line 72 "../src/Widgets/Window.vala"
	_tmp7_ = self->priv->headerbar;
#line 72 "../src/Widgets/Window.vala"
	_tmp8_ = _tmp7_->volume_button;
#line 72 "../src/Widgets/Window.vala"
	g_signal_connect_object ((GtkScaleButton*) _tmp8_, "value-changed", (GCallback) __tuner_window___lambda28__gtk_scale_button_value_changed, self, 0);
#line 76 "../src/Widgets/Window.vala"
	tuner_window_adjust_theme ();
#line 77 "../src/Widgets/Window.vala"
	_tmp9_ = self->priv->_settings;
#line 77 "../src/Widgets/Window.vala"
	g_signal_connect_object (_tmp9_, "changed", (GCallback) __tuner_window___lambda29__g_settings_changed, self, 0);
#line 85 "../src/Widgets/Window.vala"
	_tmp10_ = granite_settings_get_default ();
#line 85 "../src/Widgets/Window.vala"
	_tmp11_ = _g_object_ref0 (_tmp10_);
#line 85 "../src/Widgets/Window.vala"
	granite_settings = _tmp11_;
#line 86 "../src/Widgets/Window.vala"
	_tmp12_ = granite_settings;
#line 86 "../src/Widgets/Window.vala"
	g_signal_connect_object ((GObject*) _tmp12_, "notify", (GCallback) __tuner_window___lambda30__g_object_notify, self, 0);
#line 91 "../src/Widgets/Window.vala"
	g_action_map_add_action_entries ((GActionMap*) self, TUNER_WINDOW_ACTION_ENTRIES, (gint) G_N_ELEMENTS (TUNER_WINDOW_ACTION_ENTRIES), self);
#line 93 "../src/Widgets/Window.vala"
	g_object_set ((GtkWindow*) self, "window-position", GTK_WIN_POS_CENTER, NULL);
#line 94 "../src/Widgets/Window.vala"
	gtk_window_set_default_size ((GtkWindow*) self, 800, 540);
#line 95 "../src/Widgets/Window.vala"
	_tmp13_ = self->priv->_settings;
#line 95 "../src/Widgets/Window.vala"
	_tmp14_ = _variant_new8 (g_settings_get_boolean (_tmp13_, "do-not-track"));
#line 95 "../src/Widgets/Window.vala"
	g_action_group_change_action_state ((GActionGroup*) self, TUNER_WINDOW_ACTION_DISABLE_TRACKING, _tmp14_);
#line 95 "../src/Widgets/Window.vala"
	_g_variant_unref0 (_tmp14_);
#line 96 "../src/Widgets/Window.vala"
	_tmp15_ = self->priv->_settings;
#line 96 "../src/Widgets/Window.vala"
	_tmp16_ = _variant_new9 (g_settings_get_boolean (_tmp15_, "auto-play"));
#line 96 "../src/Widgets/Window.vala"
	g_action_group_change_action_state ((GActionGroup*) self, TUNER_WINDOW_ACTION_ENABLE_AUTOPLAY, _tmp16_);
#line 96 "../src/Widgets/Window.vala"
	_g_variant_unref0 (_tmp16_);
#line 97 "../src/Widgets/Window.vala"
	_tmp17_ = self->priv->_settings;
#line 97 "../src/Widgets/Window.vala"
	_tmp18_ = self->priv->_settings;
#line 97 "../src/Widgets/Window.vala"
	gtk_window_move ((GtkWindow*) self, g_settings_get_int (_tmp17_, "pos-x"), g_settings_get_int (_tmp18_, "pos-y"));
#line 99 "../src/Widgets/Window.vala"
	memset (&_tmp19_, 0, sizeof (GdkGeometry));
#line 99 "../src/Widgets/Window.vala"
	_tmp19_.min_height = 440;
#line 99 "../src/Widgets/Window.vala"
	_tmp19_.min_width = 600;
#line 99 "../src/Widgets/Window.vala"
	gtk_window_set_geometry_hints ((GtkWindow*) self, NULL, &_tmp19_, GDK_HINT_MIN_SIZE);
#line 100 "../src/Widgets/Window.vala"
	_tmp20_ = self->priv->_settings;
#line 100 "../src/Widgets/Window.vala"
	_tmp21_ = self->priv->_settings;
#line 100 "../src/Widgets/Window.vala"
	gtk_window_resize ((GtkWindow*) self, g_settings_get_int (_tmp20_, "window-width"), g_settings_get_int (_tmp21_, "window-height"));
#line 102 "../src/Widgets/Window.vala"
	g_signal_connect_object ((GtkWidget*) self, "delete-event", (GCallback) __tuner_window___lambda31__gtk_widget_delete_event, self, 0);
#line 106 "../src/Widgets/Window.vala"
	_tmp22_ = (GtkStack*) gtk_stack_new ();
#line 106 "../src/Widgets/Window.vala"
	g_object_ref_sink (_tmp22_);
#line 106 "../src/Widgets/Window.vala"
	_data11_->stack = _tmp22_;
#line 107 "../src/Widgets/Window.vala"
	_tmp23_ = _data11_->stack;
#line 107 "../src/Widgets/Window.vala"
	gtk_stack_set_transition_type (_tmp23_, GTK_STACK_TRANSITION_TYPE_CROSSFADE);
#line 109 "../src/Widgets/Window.vala"
	_tmp24_ = tuner_application_get_instance ();
#line 109 "../src/Widgets/Window.vala"
	_tmp25_ = _tmp24_;
#line 109 "../src/Widgets/Window.vala"
	_tmp26_ = tuner_application_get_data_dir (_tmp25_);
#line 109 "../src/Widgets/Window.vala"
	_tmp27_ = _tmp26_;
#line 109 "../src/Widgets/Window.vala"
	_tmp28_ = g_build_filename (_tmp27_, "favorites.json", NULL);
#line 109 "../src/Widgets/Window.vala"
	data_file = _tmp28_;
#line 110 "../src/Widgets/Window.vala"
	_tmp29_ = data_file;
#line 110 "../src/Widgets/Window.vala"
	_tmp30_ = tuner_model_station_store_new (_tmp29_);
#line 110 "../src/Widgets/Window.vala"
	store = _tmp30_;
#line 111 "../src/Widgets/Window.vala"
	_tmp31_ = store;
#line 111 "../src/Widgets/Window.vala"
	_tmp32_ = tuner_directory_controller_new (_tmp31_);
#line 111 "../src/Widgets/Window.vala"
	_g_object_unref0 (self->priv->_directory);
#line 111 "../src/Widgets/Window.vala"
	self->priv->_directory = _tmp32_;
#line 113 "../src/Widgets/Window.vala"
	_tmp33_ = (GtkPaned*) gtk_paned_new (GTK_ORIENTATION_HORIZONTAL);
#line 113 "../src/Widgets/Window.vala"
	g_object_ref_sink (_tmp33_);
#line 113 "../src/Widgets/Window.vala"
	primary_box = _tmp33_;
#line 116 "../src/Widgets/Window.vala"
	_tmp34_ = granite_widgets_source_list_expandable_item_new (_ ("Selections"));
#line 116 "../src/Widgets/Window.vala"
	_data11_->selections_category = _tmp34_;
#line 117 "../src/Widgets/Window.vala"
	_tmp35_ = _data11_->selections_category;
#line 117 "../src/Widgets/Window.vala"
	granite_widgets_source_list_expandable_item_set_collapsible (_tmp35_, FALSE);
#line 118 "../src/Widgets/Window.vala"
	_tmp36_ = _data11_->selections_category;
#line 118 "../src/Widgets/Window.vala"
	granite_widgets_source_list_expandable_item_set_expanded (_tmp36_, TRUE);
#line 120 "../src/Widgets/Window.vala"
	_tmp37_ = granite_widgets_source_list_expandable_item_new (_ ("Library"));
#line 120 "../src/Widgets/Window.vala"
	searched_category = _tmp37_;
#line 121 "../src/Widgets/Window.vala"
	_tmp38_ = searched_category;
#line 121 "../src/Widgets/Window.vala"
	granite_widgets_source_list_expandable_item_set_collapsible (_tmp38_, FALSE);
#line 122 "../src/Widgets/Window.vala"
	_tmp39_ = searched_category;
#line 122 "../src/Widgets/Window.vala"
	granite_widgets_source_list_expandable_item_set_expanded (_tmp39_, TRUE);
#line 124 "../src/Widgets/Window.vala"
	_tmp40_ = granite_widgets_source_list_expandable_item_new (_ ("Genres"));
#line 124 "../src/Widgets/Window.vala"
	genres_category = _tmp40_;
#line 125 "../src/Widgets/Window.vala"
	_tmp41_ = genres_category;
#line 125 "../src/Widgets/Window.vala"
	granite_widgets_source_list_expandable_item_set_collapsible (_tmp41_, TRUE);
#line 126 "../src/Widgets/Window.vala"
	_tmp42_ = genres_category;
#line 126 "../src/Widgets/Window.vala"
	granite_widgets_source_list_expandable_item_set_expanded (_tmp42_, TRUE);
#line 128 "../src/Widgets/Window.vala"
	_tmp43_ = granite_widgets_source_list_expandable_item_new ("");
#line 128 "../src/Widgets/Window.vala"
	_tmp44_ = _tmp43_;
#line 128 "../src/Widgets/Window.vala"
	_tmp45_ = granite_widgets_source_list_new (_tmp44_);
#line 128 "../src/Widgets/Window.vala"
	g_object_ref_sink (_tmp45_);
#line 128 "../src/Widgets/Window.vala"
	_g_object_unref0 (self->priv->source_list);
#line 128 "../src/Widgets/Window.vala"
	self->priv->source_list = _tmp45_;
#line 128 "../src/Widgets/Window.vala"
	_g_object_unref0 (_tmp44_);
#line 131 "../src/Widgets/Window.vala"
	_tmp46_ = granite_widgets_source_list_item_new (_ ("Discover"));
#line 131 "../src/Widgets/Window.vala"
	item1 = _tmp46_;
#line 132 "../src/Widgets/Window.vala"
	_tmp47_ = item1;
#line 132 "../src/Widgets/Window.vala"
	_tmp48_ = (GThemedIcon*) g_themed_icon_new ("face-smile");
#line 132 "../src/Widgets/Window.vala"
	_tmp49_ = _tmp48_;
#line 132 "../src/Widgets/Window.vala"
	granite_widgets_source_list_item_set_icon (_tmp47_, (GIcon*) _tmp49_);
#line 132 "../src/Widgets/Window.vala"
	_g_object_unref0 (_tmp49_);
#line 133 "../src/Widgets/Window.vala"
	_tmp50_ = _data11_->selections_category;
#line 133 "../src/Widgets/Window.vala"
	_tmp51_ = item1;
#line 133 "../src/Widgets/Window.vala"
	granite_widgets_source_list_expandable_item_add (_tmp50_, _tmp51_);
#line 135 "../src/Widgets/Window.vala"
	_tmp52_ = item1;
#line 135 "../src/Widgets/Window.vala"
	_tmp53_ = _data11_->stack;
#line 135 "../src/Widgets/Window.vala"
	_tmp54_ = self->priv->source_list;
#line 135 "../src/Widgets/Window.vala"
	_tmp55_ = tuner_window_create_content_box (self, "discover", _tmp52_, _ ("Discover Stations"), "media-playlist-shuffle-symbolic", _ ("Discover more stations"), _tmp53_, _tmp54_, FALSE);
#line 135 "../src/Widgets/Window.vala"
	_data11_->c1 = _tmp55_;
#line 139 "../src/Widgets/Window.vala"
	_tmp56_ = self->priv->_directory;
#line 139 "../src/Widgets/Window.vala"
	_tmp57_ = tuner_directory_controller_load_random_stations (_tmp56_, (guint) 20);
#line 139 "../src/Widgets/Window.vala"
	_data11_->s1 = _tmp57_;
#line 140 "../src/Widgets/Window.vala"
	_tmp58_ = _data11_->c1;
#line 140 "../src/Widgets/Window.vala"
	g_signal_connect_data ((GtkWidget*) _tmp58_, "realize", (GCallback) __tuner_window___lambda36__gtk_widget_realize, block11_data_ref (_data11_), (GClosureNotify) block11_data_unref, 0);
#line 150 "../src/Widgets/Window.vala"
	_tmp59_ = _data11_->c1;
#line 150 "../src/Widgets/Window.vala"
	g_signal_connect_data (_tmp59_, "action-activated", (GCallback) __tuner_window___lambda43__tuner_content_box_action_activated, block11_data_ref (_data11_), (GClosureNotify) block11_data_unref, 0);
#line 162 "../src/Widgets/Window.vala"
	_tmp60_ = granite_widgets_source_list_item_new (_ ("Trending"));
#line 162 "../src/Widgets/Window.vala"
	item2 = _tmp60_;
#line 163 "../src/Widgets/Window.vala"
	_tmp61_ = item2;
#line 163 "../src/Widgets/Window.vala"
	_tmp62_ = (GThemedIcon*) g_themed_icon_new ("playlist-queue");
#line 163 "../src/Widgets/Window.vala"
	_tmp63_ = _tmp62_;
#line 163 "../src/Widgets/Window.vala"
	granite_widgets_source_list_item_set_icon (_tmp61_, (GIcon*) _tmp63_);
#line 163 "../src/Widgets/Window.vala"
	_g_object_unref0 (_tmp63_);
#line 164 "../src/Widgets/Window.vala"
	_tmp64_ = _data11_->selections_category;
#line 164 "../src/Widgets/Window.vala"
	_tmp65_ = item2;
#line 164 "../src/Widgets/Window.vala"
	granite_widgets_source_list_expandable_item_add (_tmp64_, _tmp65_);
#line 166 "../src/Widgets/Window.vala"
	_tmp66_ = item2;
#line 166 "../src/Widgets/Window.vala"
	_tmp67_ = _data11_->stack;
#line 166 "../src/Widgets/Window.vala"
	_tmp68_ = self->priv->source_list;
#line 166 "../src/Widgets/Window.vala"
	_tmp69_ = tuner_window_create_content_box (self, "trending", _tmp66_, _ ("Trending in the last 24 hours"), NULL, NULL, _tmp67_, _tmp68_, FALSE);
#line 166 "../src/Widgets/Window.vala"
	_data11_->c2 = _tmp69_;
#line 169 "../src/Widgets/Window.vala"
	_tmp70_ = self->priv->_directory;
#line 169 "../src/Widgets/Window.vala"
	_tmp71_ = tuner_directory_controller_load_trending_stations (_tmp70_, (guint) 40);
#line 169 "../src/Widgets/Window.vala"
	_data11_->s2 = _tmp71_;
#line 170 "../src/Widgets/Window.vala"
	_tmp72_ = _data11_->c2;
#line 170 "../src/Widgets/Window.vala"
	g_signal_connect_data ((GtkWidget*) _tmp72_, "realize", (GCallback) __tuner_window___lambda44__gtk_widget_realize, block11_data_ref (_data11_), (GClosureNotify) block11_data_unref, 0);
#line 183 "../src/Widgets/Window.vala"
	_tmp73_ = granite_widgets_source_list_item_new (_ ("Popular"));
#line 183 "../src/Widgets/Window.vala"
	item3 = _tmp73_;
#line 184 "../src/Widgets/Window.vala"
	_tmp74_ = item3;
#line 184 "../src/Widgets/Window.vala"
	_tmp75_ = (GThemedIcon*) g_themed_icon_new ("playlist-similar");
#line 184 "../src/Widgets/Window.vala"
	_tmp76_ = _tmp75_;
#line 184 "../src/Widgets/Window.vala"
	granite_widgets_source_list_item_set_icon (_tmp74_, (GIcon*) _tmp76_);
#line 184 "../src/Widgets/Window.vala"
	_g_object_unref0 (_tmp76_);
#line 185 "../src/Widgets/Window.vala"
	_tmp77_ = _data11_->selections_category;
#line 185 "../src/Widgets/Window.vala"
	_tmp78_ = item3;
#line 185 "../src/Widgets/Window.vala"
	granite_widgets_source_list_expandable_item_add (_tmp77_, _tmp78_);
#line 187 "../src/Widgets/Window.vala"
	_tmp79_ = item3;
#line 187 "../src/Widgets/Window.vala"
	_tmp80_ = _data11_->stack;
#line 187 "../src/Widgets/Window.vala"
	_tmp81_ = self->priv->source_list;
#line 187 "../src/Widgets/Window.vala"
	_tmp82_ = tuner_window_create_content_box (self, "popular", _tmp79_, _ ("Most-listened over 24 hours"), NULL, NULL, _tmp80_, _tmp81_, FALSE);
#line 187 "../src/Widgets/Window.vala"
	_data11_->c3 = _tmp82_;
#line 190 "../src/Widgets/Window.vala"
	_tmp83_ = self->priv->_directory;
#line 190 "../src/Widgets/Window.vala"
	_tmp84_ = tuner_directory_controller_load_popular_stations (_tmp83_, (guint) 40);
#line 190 "../src/Widgets/Window.vala"
	_data11_->s3 = _tmp84_;
#line 191 "../src/Widgets/Window.vala"
	_tmp85_ = _data11_->c3;
#line 191 "../src/Widgets/Window.vala"
	g_signal_connect_data ((GtkWidget*) _tmp85_, "realize", (GCallback) __tuner_window___lambda45__gtk_widget_realize, block11_data_ref (_data11_), (GClosureNotify) block11_data_unref, 0);
#line 203 "../src/Widgets/Window.vala"
	_tmp86_ = granite_widgets_source_list_item_new (_ ("Your Country"));
#line 203 "../src/Widgets/Window.vala"
	_data11_->item4 = _tmp86_;
#line 204 "../src/Widgets/Window.vala"
	_tmp87_ = _data11_->item4;
#line 204 "../src/Widgets/Window.vala"
	_tmp88_ = (GThemedIcon*) g_themed_icon_new ("emblem-web");
#line 204 "../src/Widgets/Window.vala"
	_tmp89_ = _tmp88_;
#line 204 "../src/Widgets/Window.vala"
	granite_widgets_source_list_item_set_icon (_tmp87_, (GIcon*) _tmp89_);
#line 204 "../src/Widgets/Window.vala"
	_g_object_unref0 (_tmp89_);
#line 206 "../src/Widgets/Window.vala"
	_tmp90_ = _data11_->item4;
#line 206 "../src/Widgets/Window.vala"
	_tmp91_ = _data11_->stack;
#line 206 "../src/Widgets/Window.vala"
	_tmp92_ = self->priv->source_list;
#line 206 "../src/Widgets/Window.vala"
	_tmp93_ = tuner_window_create_content_box (self, "my-country", _tmp90_, _ ("Your Country"), NULL, NULL, _tmp91_, _tmp92_, TRUE);
#line 206 "../src/Widgets/Window.vala"
	_g_object_unref0 (_data11_->c_country);
#line 206 "../src/Widgets/Window.vala"
	_data11_->c_country = _tmp93_;
#line 209 "../src/Widgets/Window.vala"
	_tmp94_ = tuner_station_list_new ();
#line 209 "../src/Widgets/Window.vala"
	g_object_ref_sink (_tmp94_);
#line 209 "../src/Widgets/Window.vala"
	_data11_->c_slist = _tmp94_;
#line 210 "../src/Widgets/Window.vala"
	_tmp95_ = _data11_->c_slist;
#line 210 "../src/Widgets/Window.vala"
	g_signal_connect_object (_tmp95_, "selection-changed", (GCallback) _tuner_window_handle_station_click_tuner_station_list_selection_changed, self, 0);
#line 211 "../src/Widgets/Window.vala"
	_tmp96_ = _data11_->c_slist;
#line 211 "../src/Widgets/Window.vala"
	g_signal_connect_object (_tmp96_, "favourites-changed", (GCallback) _tuner_window_handle_favourites_changed_tuner_station_list_favourites_changed, self, 0);
#line 213 "../src/Widgets/Window.vala"
	tuner_location_discovery_country_code (__tuner_window___lambda46__gasync_ready_callback, block11_data_ref (_data11_));
#line 241 "../src/Widgets/Window.vala"
	_tmp97_ = granite_widgets_source_list_item_new (_ ("Starred by You"));
#line 241 "../src/Widgets/Window.vala"
	item5 = _tmp97_;
#line 242 "../src/Widgets/Window.vala"
	_tmp98_ = item5;
#line 242 "../src/Widgets/Window.vala"
	_tmp99_ = (GThemedIcon*) g_themed_icon_new ("starred");
#line 242 "../src/Widgets/Window.vala"
	_tmp100_ = _tmp99_;
#line 242 "../src/Widgets/Window.vala"
	granite_widgets_source_list_item_set_icon (_tmp98_, (GIcon*) _tmp100_);
#line 242 "../src/Widgets/Window.vala"
	_g_object_unref0 (_tmp100_);
#line 243 "../src/Widgets/Window.vala"
	_tmp101_ = searched_category;
#line 243 "../src/Widgets/Window.vala"
	_tmp102_ = item5;
#line 243 "../src/Widgets/Window.vala"
	granite_widgets_source_list_expandable_item_add (_tmp101_, _tmp102_);
#line 244 "../src/Widgets/Window.vala"
	_tmp103_ = item5;
#line 244 "../src/Widgets/Window.vala"
	_tmp104_ = _data11_->stack;
#line 244 "../src/Widgets/Window.vala"
	_tmp105_ = self->priv->source_list;
#line 244 "../src/Widgets/Window.vala"
	_tmp106_ = tuner_window_create_content_box (self, "starred", _tmp103_, _ ("Starred by You"), NULL, NULL, _tmp104_, _tmp105_, TRUE);
#line 244 "../src/Widgets/Window.vala"
	_data11_->c4 = _tmp106_;
#line 248 "../src/Widgets/Window.vala"
	_tmp107_ = self->priv->_directory;
#line 248 "../src/Widgets/Window.vala"
	_tmp108_ = tuner_directory_controller_get_stored (_tmp107_);
#line 248 "../src/Widgets/Window.vala"
	_tmp109_ = _tmp108_;
#line 248 "../src/Widgets/Window.vala"
	_tmp110_ = tuner_station_list_new_with_stations (_tmp109_);
#line 248 "../src/Widgets/Window.vala"
	g_object_ref_sink (_tmp110_);
#line 248 "../src/Widgets/Window.vala"
	_tmp111_ = _tmp110_;
#line 248 "../src/Widgets/Window.vala"
	_g_object_unref0 (_tmp109_);
#line 248 "../src/Widgets/Window.vala"
	slist = _tmp111_;
#line 249 "../src/Widgets/Window.vala"
	_tmp112_ = slist;
#line 249 "../src/Widgets/Window.vala"
	g_signal_connect_object (_tmp112_, "selection-changed", (GCallback) _tuner_window_handle_station_click_tuner_station_list_selection_changed, self, 0);
#line 250 "../src/Widgets/Window.vala"
	_tmp113_ = slist;
#line 250 "../src/Widgets/Window.vala"
	g_signal_connect_object (_tmp113_, "favourites-changed", (GCallback) _tuner_window_handle_favourites_changed_tuner_station_list_favourites_changed, self, 0);
#line 251 "../src/Widgets/Window.vala"
	_tmp114_ = _data11_->c4;
#line 251 "../src/Widgets/Window.vala"
	_tmp115_ = slist;
#line 251 "../src/Widgets/Window.vala"
	tuner_content_box_set_content (_tmp114_, (TunerAbstractContentList*) _tmp115_);
#line 254 "../src/Widgets/Window.vala"
	_tmp116_ = granite_widgets_source_list_item_new (_ ("Recent Search"));
#line 254 "../src/Widgets/Window.vala"
	item6 = _tmp116_;
#line 255 "../src/Widgets/Window.vala"
	_tmp117_ = item6;
#line 255 "../src/Widgets/Window.vala"
	_tmp118_ = (GThemedIcon*) g_themed_icon_new ("folder-saved-search");
#line 255 "../src/Widgets/Window.vala"
	_tmp119_ = _tmp118_;
#line 255 "../src/Widgets/Window.vala"
	granite_widgets_source_list_item_set_icon (_tmp117_, (GIcon*) _tmp119_);
#line 255 "../src/Widgets/Window.vala"
	_g_object_unref0 (_tmp119_);
#line 256 "../src/Widgets/Window.vala"
	_tmp120_ = searched_category;
#line 256 "../src/Widgets/Window.vala"
	_tmp121_ = item6;
#line 256 "../src/Widgets/Window.vala"
	granite_widgets_source_list_expandable_item_add (_tmp120_, _tmp121_);
#line 257 "../src/Widgets/Window.vala"
	_tmp122_ = item6;
#line 257 "../src/Widgets/Window.vala"
	_tmp123_ = _data11_->stack;
#line 257 "../src/Widgets/Window.vala"
	_tmp124_ = self->priv->source_list;
#line 257 "../src/Widgets/Window.vala"
	_tmp125_ = tuner_window_create_content_box (self, "searched", _tmp122_, _ ("Search"), NULL, NULL, _tmp123_, _tmp124_, TRUE);
#line 257 "../src/Widgets/Window.vala"
	_data11_->c5 = _tmp125_;
#line 273 "../src/Widgets/Window.vala"
	_tmp127_ = tuner_model_genres (&_tmp126_);
#line 3983 "Window.c"
	{
		TunerModelGenre** genre_collection = NULL;
		gint genre_collection_length1 = 0;
		gint _genre_collection_size_ = 0;
		gint genre_it = 0;
#line 273 "../src/Widgets/Window.vala"
		genre_collection = _tmp127_;
#line 273 "../src/Widgets/Window.vala"
		genre_collection_length1 = _tmp126_;
#line 273 "../src/Widgets/Window.vala"
		for (genre_it = 0; genre_it < genre_collection_length1; genre_it = genre_it + 1) {
#line 3995 "Window.c"
			TunerModelGenre* _tmp128_;
			TunerModelGenre* genre = NULL;
#line 273 "../src/Widgets/Window.vala"
			_tmp128_ = _tuner_model_genre_ref0 (genre_collection[genre_it]);
#line 273 "../src/Widgets/Window.vala"
			genre = _tmp128_;
#line 4002 "Window.c"
			{
				Block13Data* _data13_;
				GraniteWidgetsSourceListItem* item8 = NULL;
				TunerModelGenre* _tmp129_;
				const gchar* _tmp130_;
				GraniteWidgetsSourceListItem* _tmp131_;
				GraniteWidgetsSourceListItem* _tmp132_;
				GThemedIcon* _tmp133_;
				GThemedIcon* _tmp134_;
				GraniteWidgetsSourceListExpandableItem* _tmp135_;
				GraniteWidgetsSourceListItem* _tmp136_;
				TunerModelGenre* _tmp137_;
				const gchar* _tmp138_;
				GraniteWidgetsSourceListItem* _tmp139_;
				TunerModelGenre* _tmp140_;
				const gchar* _tmp141_;
				GtkStack* _tmp142_;
				GraniteWidgetsSourceList* _tmp143_;
				TunerContentBox* _tmp144_;
				GeeArrayList* tags = NULL;
				TunerModelGenre* _tmp145_;
				gchar** _tmp146_;
				gint _tmp146__length1;
				gchar** _tmp147_;
				gint _tmp147__length1;
				GeeArrayList* _tmp148_;
				TunerDirectoryController* _tmp149_;
				GeeArrayList* _tmp150_;
				GeeArrayList* _tmp151_;
				TunerStationSource* _tmp152_;
				TunerContentBox* _tmp153_;
#line 273 "../src/Widgets/Window.vala"
				_data13_ = g_slice_new0 (Block13Data);
#line 273 "../src/Widgets/Window.vala"
				_data13_->_ref_count_ = 1;
#line 273 "../src/Widgets/Window.vala"
				_data13_->_data11_ = block11_data_ref (_data11_);
#line 274 "../src/Widgets/Window.vala"
				_tmp129_ = genre;
#line 274 "../src/Widgets/Window.vala"
				_tmp130_ = _tmp129_->name;
#line 274 "../src/Widgets/Window.vala"
				_tmp131_ = granite_widgets_source_list_item_new (_ (_tmp130_));
#line 274 "../src/Widgets/Window.vala"
				item8 = _tmp131_;
#line 275 "../src/Widgets/Window.vala"
				_tmp132_ = item8;
#line 275 "../src/Widgets/Window.vala"
				_tmp133_ = (GThemedIcon*) g_themed_icon_new ("playlist-symbolic");
#line 275 "../src/Widgets/Window.vala"
				_tmp134_ = _tmp133_;
#line 275 "../src/Widgets/Window.vala"
				granite_widgets_source_list_item_set_icon (_tmp132_, (GIcon*) _tmp134_);
#line 275 "../src/Widgets/Window.vala"
				_g_object_unref0 (_tmp134_);
#line 276 "../src/Widgets/Window.vala"
				_tmp135_ = genres_category;
#line 276 "../src/Widgets/Window.vala"
				_tmp136_ = item8;
#line 276 "../src/Widgets/Window.vala"
				granite_widgets_source_list_expandable_item_add (_tmp135_, _tmp136_);
#line 277 "../src/Widgets/Window.vala"
				_tmp137_ = genre;
#line 277 "../src/Widgets/Window.vala"
				_tmp138_ = _tmp137_->name;
#line 277 "../src/Widgets/Window.vala"
				_tmp139_ = item8;
#line 277 "../src/Widgets/Window.vala"
				_tmp140_ = genre;
#line 277 "../src/Widgets/Window.vala"
				_tmp141_ = _tmp140_->name;
#line 277 "../src/Widgets/Window.vala"
				_tmp142_ = _data11_->stack;
#line 277 "../src/Widgets/Window.vala"
				_tmp143_ = self->priv->source_list;
#line 277 "../src/Widgets/Window.vala"
				_tmp144_ = tuner_window_create_content_box (self, _tmp138_, _tmp139_, _tmp141_, NULL, NULL, _tmp142_, _tmp143_, FALSE);
#line 277 "../src/Widgets/Window.vala"
				_data13_->cb = _tmp144_;
#line 279 "../src/Widgets/Window.vala"
				_tmp145_ = genre;
#line 279 "../src/Widgets/Window.vala"
				_tmp146_ = _tmp145_->tags;
#line 279 "../src/Widgets/Window.vala"
				_tmp146__length1 = _tmp145_->tags_length1;
#line 279 "../src/Widgets/Window.vala"
				_tmp147_ = (_tmp146_ != NULL) ? _vala_array_dup8 (_tmp146_, _tmp146__length1) : _tmp146_;
#line 279 "../src/Widgets/Window.vala"
				_tmp147__length1 = _tmp146__length1;
#line 279 "../src/Widgets/Window.vala"
				_tmp148_ = gee_array_list_new_wrap (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, _tmp147_, _tmp147__length1, NULL, NULL, NULL);
#line 279 "../src/Widgets/Window.vala"
				tags = _tmp148_;
#line 280 "../src/Widgets/Window.vala"
				_tmp149_ = self->priv->_directory;
#line 280 "../src/Widgets/Window.vala"
				_tmp150_ = tags;
#line 280 "../src/Widgets/Window.vala"
				_tmp151_ = _g_object_ref0 (_tmp150_);
#line 280 "../src/Widgets/Window.vala"
				_tmp152_ = tuner_directory_controller_load_by_tags (_tmp149_, _tmp151_);
#line 280 "../src/Widgets/Window.vala"
				_data13_->ds = _tmp152_;
#line 281 "../src/Widgets/Window.vala"
				_tmp153_ = _data13_->cb;
#line 281 "../src/Widgets/Window.vala"
				g_signal_connect_data ((GtkWidget*) _tmp153_, "realize", (GCallback) __tuner_window_____lambda48__gtk_widget_realize, block13_data_ref (_data13_), (GClosureNotify) block13_data_unref, 0);
#line 273 "../src/Widgets/Window.vala"
				_g_object_unref0 (tags);
#line 273 "../src/Widgets/Window.vala"
				_g_object_unref0 (item8);
#line 273 "../src/Widgets/Window.vala"
				_tuner_model_genre_unref0 (genre);
#line 273 "../src/Widgets/Window.vala"
				block13_data_unref (_data13_);
#line 273 "../src/Widgets/Window.vala"
				_data13_ = NULL;
#line 4120 "Window.c"
			}
		}
#line 273 "../src/Widgets/Window.vala"
		genre_collection = (_vala_array_free (genre_collection, genre_collection_length1, (GDestroyNotify) tuner_model_genre_unref), NULL);
#line 4125 "Window.c"
	}
#line 293 "../src/Widgets/Window.vala"
	_tmp154_ = self->priv->headerbar;
#line 293 "../src/Widgets/Window.vala"
	g_signal_connect_object (_tmp154_, "star-clicked", (GCallback) __tuner_window___lambda49__tuner_header_bar_star_clicked, self, 0);
#line 297 "../src/Widgets/Window.vala"
	g_signal_connect_data (self, "refresh-favourites", (GCallback) __tuner_window___lambda50__tuner_window_refresh_favourites, block11_data_ref (_data11_), (GClosureNotify) block11_data_unref, 0);
#line 304 "../src/Widgets/Window.vala"
	_tmp155_ = self->priv->source_list;
#line 304 "../src/Widgets/Window.vala"
	_tmp156_ = granite_widgets_source_list_get_root (_tmp155_);
#line 304 "../src/Widgets/Window.vala"
	_tmp157_ = _tmp156_;
#line 304 "../src/Widgets/Window.vala"
	_tmp158_ = _data11_->selections_category;
#line 304 "../src/Widgets/Window.vala"
	granite_widgets_source_list_expandable_item_add (_tmp157_, (GraniteWidgetsSourceListItem*) _tmp158_);
#line 305 "../src/Widgets/Window.vala"
	_tmp159_ = self->priv->source_list;
#line 305 "../src/Widgets/Window.vala"
	_tmp160_ = granite_widgets_source_list_get_root (_tmp159_);
#line 305 "../src/Widgets/Window.vala"
	_tmp161_ = _tmp160_;
#line 305 "../src/Widgets/Window.vala"
	_tmp162_ = searched_category;
#line 305 "../src/Widgets/Window.vala"
	granite_widgets_source_list_expandable_item_add (_tmp161_, (GraniteWidgetsSourceListItem*) _tmp162_);
#line 306 "../src/Widgets/Window.vala"
	_tmp163_ = self->priv->source_list;
#line 306 "../src/Widgets/Window.vala"
	_tmp164_ = granite_widgets_source_list_get_root (_tmp163_);
#line 306 "../src/Widgets/Window.vala"
	_tmp165_ = _tmp164_;
#line 306 "../src/Widgets/Window.vala"
	_tmp166_ = genres_category;
#line 306 "../src/Widgets/Window.vala"
	granite_widgets_source_list_expandable_item_add (_tmp165_, (GraniteWidgetsSourceListItem*) _tmp166_);
#line 308 "../src/Widgets/Window.vala"
	_tmp167_ = self->priv->source_list;
#line 308 "../src/Widgets/Window.vala"
	granite_widgets_source_list_set_ellipsize_mode (_tmp167_, PANGO_ELLIPSIZE_NONE);
#line 309 "../src/Widgets/Window.vala"
	_tmp168_ = self->priv->source_list;
#line 309 "../src/Widgets/Window.vala"
	_tmp169_ = self->priv->source_list;
#line 309 "../src/Widgets/Window.vala"
	_tmp170_ = _data11_->selections_category;
#line 309 "../src/Widgets/Window.vala"
	_tmp171_ = granite_widgets_source_list_get_first_child (_tmp169_, _tmp170_);
#line 309 "../src/Widgets/Window.vala"
	_tmp172_ = _tmp171_;
#line 309 "../src/Widgets/Window.vala"
	granite_widgets_source_list_set_selected (_tmp168_, _tmp172_);
#line 309 "../src/Widgets/Window.vala"
	_g_object_unref0 (_tmp172_);
#line 310 "../src/Widgets/Window.vala"
	_tmp173_ = self->priv->source_list;
#line 310 "../src/Widgets/Window.vala"
	g_signal_connect_data (_tmp173_, "item-selected", (GCallback) __tuner_window___lambda51__granite_widgets_source_list_item_selected, block11_data_ref (_data11_), (GClosureNotify) block11_data_unref, 0);
#line 315 "../src/Widgets/Window.vala"
	_tmp174_ = self->priv->headerbar;
#line 315 "../src/Widgets/Window.vala"
	g_signal_connect_data (_tmp174_, "searched-for", (GCallback) __tuner_window___lambda52__tuner_header_bar_searched_for, block11_data_ref (_data11_), (GClosureNotify) block11_data_unref, 0);
#line 335 "../src/Widgets/Window.vala"
	_tmp175_ = self->priv->headerbar;
#line 335 "../src/Widgets/Window.vala"
	g_signal_connect_data (_tmp175_, "search-focused", (GCallback) __tuner_window___lambda53__tuner_header_bar_search_focused, block11_data_ref (_data11_), (GClosureNotify) block11_data_unref, 0);
#line 339 "../src/Widgets/Window.vala"
	_tmp176_ = primary_box;
#line 339 "../src/Widgets/Window.vala"
	_tmp177_ = self->priv->source_list;
#line 339 "../src/Widgets/Window.vala"
	gtk_paned_pack1 (_tmp176_, (GtkWidget*) _tmp177_, FALSE, FALSE);
#line 340 "../src/Widgets/Window.vala"
	_tmp178_ = primary_box;
#line 340 "../src/Widgets/Window.vala"
	_tmp179_ = _data11_->stack;
#line 340 "../src/Widgets/Window.vala"
	gtk_paned_pack2 (_tmp178_, (GtkWidget*) _tmp179_, TRUE, FALSE);
#line 341 "../src/Widgets/Window.vala"
	_tmp180_ = primary_box;
#line 341 "../src/Widgets/Window.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp180_);
#line 342 "../src/Widgets/Window.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 345 "../src/Widgets/Window.vala"
	_tmp181_ = self->priv->_settings;
#line 345 "../src/Widgets/Window.vala"
	if (g_settings_get_boolean (_tmp181_, "auto-play")) {
#line 4215 "Window.c"
		gchar* last_played_station = NULL;
		GSettings* _tmp182_;
		gchar* _tmp183_;
		const gchar* _tmp184_;
		const gchar* _tmp185_;
		gchar* _tmp186_;
		gchar* _tmp187_;
		TunerStationSource* source = NULL;
		TunerDirectoryController* _tmp188_;
		const gchar* _tmp189_;
		TunerStationSource* _tmp190_;
#line 346 "../src/Widgets/Window.vala"
		g_warning ("Window.vala:346: %s", "Auto-play enabled");
#line 347 "../src/Widgets/Window.vala"
		_tmp182_ = self->priv->_settings;
#line 347 "../src/Widgets/Window.vala"
		_tmp183_ = g_settings_get_string (_tmp182_, "last-played-station");
#line 347 "../src/Widgets/Window.vala"
		last_played_station = _tmp183_;
#line 348 "../src/Widgets/Window.vala"
		_tmp184_ = last_played_station;
#line 348 "../src/Widgets/Window.vala"
		_tmp185_ = string_to_string (_tmp184_);
#line 348 "../src/Widgets/Window.vala"
		_tmp186_ = g_strconcat ("Last played station is: ", _tmp185_, NULL);
#line 348 "../src/Widgets/Window.vala"
		_tmp187_ = _tmp186_;
#line 348 "../src/Widgets/Window.vala"
		g_warning ("Window.vala:348: %s", _tmp187_);
#line 348 "../src/Widgets/Window.vala"
		_g_free0 (_tmp187_);
#line 350 "../src/Widgets/Window.vala"
		_tmp188_ = self->priv->_directory;
#line 350 "../src/Widgets/Window.vala"
		_tmp189_ = last_played_station;
#line 350 "../src/Widgets/Window.vala"
		_tmp190_ = tuner_directory_controller_load_station_uuid (_tmp188_, _tmp189_);
#line 350 "../src/Widgets/Window.vala"
		source = _tmp190_;
#line 4255 "Window.c"
		{
			GeeArrayList* _tmp191_ = NULL;
			TunerStationSource* _tmp192_;
			GeeArrayList* _tmp193_;
#line 353 "../src/Widgets/Window.vala"
			_tmp192_ = source;
#line 353 "../src/Widgets/Window.vala"
			_tmp193_ = tuner_station_source_next (_tmp192_, &_inner_error0_);
#line 353 "../src/Widgets/Window.vala"
			_tmp191_ = _tmp193_;
#line 353 "../src/Widgets/Window.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 353 "../src/Widgets/Window.vala"
				if (_inner_error0_->domain == SOURCE_ERROR) {
#line 4270 "Window.c"
					goto __catch0_source_error;
				}
#line 353 "../src/Widgets/Window.vala"
				_g_object_unref0 (source);
#line 353 "../src/Widgets/Window.vala"
				_g_free0 (last_played_station);
#line 353 "../src/Widgets/Window.vala"
				_g_object_unref0 (item6);
#line 353 "../src/Widgets/Window.vala"
				_g_object_unref0 (slist);
#line 353 "../src/Widgets/Window.vala"
				_g_object_unref0 (item5);
#line 353 "../src/Widgets/Window.vala"
				_g_object_unref0 (item3);
#line 353 "../src/Widgets/Window.vala"
				_g_object_unref0 (item2);
#line 353 "../src/Widgets/Window.vala"
				_g_object_unref0 (item1);
#line 353 "../src/Widgets/Window.vala"
				_g_object_unref0 (genres_category);
#line 353 "../src/Widgets/Window.vala"
				_g_object_unref0 (searched_category);
#line 353 "../src/Widgets/Window.vala"
				_g_object_unref0 (primary_box);
#line 353 "../src/Widgets/Window.vala"
				_g_object_unref0 (store);
#line 353 "../src/Widgets/Window.vala"
				_g_free0 (data_file);
#line 353 "../src/Widgets/Window.vala"
				_g_object_unref0 (granite_settings);
#line 353 "../src/Widgets/Window.vala"
				block11_data_unref (_data11_);
#line 353 "../src/Widgets/Window.vala"
				_data11_ = NULL;
#line 353 "../src/Widgets/Window.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 353 "../src/Widgets/Window.vala"
				g_clear_error (&_inner_error0_);
#line 4309 "Window.c"
			}
			{
				GeeArrayList* _station_list = NULL;
				gint _station_size = 0;
				GeeArrayList* _tmp194_;
				gint _tmp195_;
				gint _tmp196_;
				gint _station_index = 0;
#line 353 "../src/Widgets/Window.vala"
				_station_list = _tmp191_;
#line 353 "../src/Widgets/Window.vala"
				_tmp194_ = _station_list;
#line 353 "../src/Widgets/Window.vala"
				_tmp195_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp194_);
#line 353 "../src/Widgets/Window.vala"
				_tmp196_ = _tmp195_;
#line 353 "../src/Widgets/Window.vala"
				_station_size = _tmp196_;
#line 353 "../src/Widgets/Window.vala"
				_station_index = -1;
#line 353 "../src/Widgets/Window.vala"
				while (TRUE) {
#line 4332 "Window.c"
					gint _tmp197_;
					gint _tmp198_;
					TunerModelStation* station = NULL;
					GeeArrayList* _tmp199_;
					gpointer _tmp200_;
					TunerModelStation* _tmp201_;
#line 353 "../src/Widgets/Window.vala"
					_station_index = _station_index + 1;
#line 353 "../src/Widgets/Window.vala"
					_tmp197_ = _station_index;
#line 353 "../src/Widgets/Window.vala"
					_tmp198_ = _station_size;
#line 353 "../src/Widgets/Window.vala"
					if (!(_tmp197_ < _tmp198_)) {
#line 353 "../src/Widgets/Window.vala"
						break;
#line 4349 "Window.c"
					}
#line 353 "../src/Widgets/Window.vala"
					_tmp199_ = _station_list;
#line 353 "../src/Widgets/Window.vala"
					_tmp200_ = gee_abstract_list_get ((GeeAbstractList*) _tmp199_, _station_index);
#line 353 "../src/Widgets/Window.vala"
					station = (TunerModelStation*) _tmp200_;
#line 354 "../src/Widgets/Window.vala"
					_tmp201_ = station;
#line 354 "../src/Widgets/Window.vala"
					tuner_window_handle_station_click (self, _tmp201_);
#line 355 "../src/Widgets/Window.vala"
					_g_object_unref0 (station);
#line 355 "../src/Widgets/Window.vala"
					break;
#line 4365 "Window.c"
				}
			}
#line 352 "../src/Widgets/Window.vala"
			_g_object_unref0 (_tmp191_);
#line 4370 "Window.c"
		}
		goto __finally0;
		__catch0_source_error:
		{
#line 352 "../src/Widgets/Window.vala"
			g_clear_error (&_inner_error0_);
#line 358 "../src/Widgets/Window.vala"
			g_warning ("Window.vala:358: Error while trying to autoplay, aborting...");
#line 4379 "Window.c"
		}
		__finally0:
#line 352 "../src/Widgets/Window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 352 "../src/Widgets/Window.vala"
			_g_object_unref0 (source);
#line 352 "../src/Widgets/Window.vala"
			_g_free0 (last_played_station);
#line 352 "../src/Widgets/Window.vala"
			_g_object_unref0 (item6);
#line 352 "../src/Widgets/Window.vala"
			_g_object_unref0 (slist);
#line 352 "../src/Widgets/Window.vala"
			_g_object_unref0 (item5);
#line 352 "../src/Widgets/Window.vala"
			_g_object_unref0 (item3);
#line 352 "../src/Widgets/Window.vala"
			_g_object_unref0 (item2);
#line 352 "../src/Widgets/Window.vala"
			_g_object_unref0 (item1);
#line 352 "../src/Widgets/Window.vala"
			_g_object_unref0 (genres_category);
#line 352 "../src/Widgets/Window.vala"
			_g_object_unref0 (searched_category);
#line 352 "../src/Widgets/Window.vala"
			_g_object_unref0 (primary_box);
#line 352 "../src/Widgets/Window.vala"
			_g_object_unref0 (store);
#line 352 "../src/Widgets/Window.vala"
			_g_free0 (data_file);
#line 352 "../src/Widgets/Window.vala"
			_g_object_unref0 (granite_settings);
#line 352 "../src/Widgets/Window.vala"
			block11_data_unref (_data11_);
#line 352 "../src/Widgets/Window.vala"
			_data11_ = NULL;
#line 352 "../src/Widgets/Window.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 352 "../src/Widgets/Window.vala"
			g_clear_error (&_inner_error0_);
#line 4420 "Window.c"
		}
#line 345 "../src/Widgets/Window.vala"
		_g_object_unref0 (source);
#line 345 "../src/Widgets/Window.vala"
		_g_free0 (last_played_station);
#line 4426 "Window.c"
	}
#line 59 "../src/Widgets/Window.vala"
	_g_object_unref0 (item6);
#line 59 "../src/Widgets/Window.vala"
	_g_object_unref0 (slist);
#line 59 "../src/Widgets/Window.vala"
	_g_object_unref0 (item5);
#line 59 "../src/Widgets/Window.vala"
	_g_object_unref0 (item3);
#line 59 "../src/Widgets/Window.vala"
	_g_object_unref0 (item2);
#line 59 "../src/Widgets/Window.vala"
	_g_object_unref0 (item1);
#line 59 "../src/Widgets/Window.vala"
	_g_object_unref0 (genres_category);
#line 59 "../src/Widgets/Window.vala"
	_g_object_unref0 (searched_category);
#line 59 "../src/Widgets/Window.vala"
	_g_object_unref0 (primary_box);
#line 59 "../src/Widgets/Window.vala"
	_g_object_unref0 (store);
#line 59 "../src/Widgets/Window.vala"
	_g_free0 (data_file);
#line 59 "../src/Widgets/Window.vala"
	_g_object_unref0 (granite_settings);
#line 59 "../src/Widgets/Window.vala"
	block11_data_unref (_data11_);
#line 59 "../src/Widgets/Window.vala"
	_data11_ = NULL;
#line 59 "../src/Widgets/Window.vala"
	return obj;
#line 4458 "Window.c"
}

static void
tuner_window_class_init (TunerWindowClass * klass,
                         gpointer klass_data)
{
	GtkCssProvider* provider = NULL;
	GtkCssProvider* _tmp0_;
	GtkCssProvider* _tmp1_;
	GdkScreen* _tmp2_;
	GtkCssProvider* _tmp3_;
#line 8 "../src/Widgets/Window.vala"
	tuner_window_parent_class = g_type_class_peek_parent (klass);
#line 8 "../src/Widgets/Window.vala"
	g_type_class_adjust_private_offset (klass, &TunerWindow_private_offset);
#line 8 "../src/Widgets/Window.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_tuner_window_get_property;
#line 8 "../src/Widgets/Window.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_tuner_window_set_property;
#line 8 "../src/Widgets/Window.vala"
	G_OBJECT_CLASS (klass)->constructor = tuner_window_constructor;
#line 8 "../src/Widgets/Window.vala"
	G_OBJECT_CLASS (klass)->finalize = tuner_window_finalize;
#line 8 "../src/Widgets/Window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_WINDOW_SETTINGS_PROPERTY, tuner_window_properties[TUNER_WINDOW_SETTINGS_PROPERTY] = g_param_spec_object ("settings", "settings", "settings", g_settings_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 8 "../src/Widgets/Window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_WINDOW_STACK_PROPERTY, tuner_window_properties[TUNER_WINDOW_STACK_PROPERTY] = g_param_spec_object ("stack", "stack", "stack", gtk_stack_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 8 "../src/Widgets/Window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_WINDOW_PLAYER_PROPERTY, tuner_window_properties[TUNER_WINDOW_PLAYER_PROPERTY] = g_param_spec_object ("player", "player", "player", TUNER_TYPE_PLAYER_CONTROLLER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 8 "../src/Widgets/Window.vala"
	tuner_window_signals[TUNER_WINDOW_REFRESH_FAVOURITES_SIGNAL] = g_signal_new ("refresh-favourites", TUNER_TYPE_WINDOW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 38 "../src/Widgets/Window.vala"
	_tmp0_ = gtk_css_provider_new ();
#line 38 "../src/Widgets/Window.vala"
	provider = _tmp0_;
#line 39 "../src/Widgets/Window.vala"
	_tmp1_ = provider;
#line 39 "../src/Widgets/Window.vala"
	gtk_css_provider_load_from_resource (_tmp1_, "com/github/louis77/tuner/Application.css");
#line 40 "../src/Widgets/Window.vala"
	_tmp2_ = gdk_screen_get_default ();
#line 40 "../src/Widgets/Window.vala"
	_tmp3_ = provider;
#line 40 "../src/Widgets/Window.vala"
	gtk_style_context_add_provider_for_screen (_tmp2_, (GtkStyleProvider*) _tmp3_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 37 "../src/Widgets/Window.vala"
	_g_object_unref0 (provider);
#line 4506 "Window.c"
}

static void
tuner_window_instance_init (TunerWindow * self,
                            gpointer klass)
{
#line 8 "../src/Widgets/Window.vala"
	self->priv = tuner_window_get_instance_private (self);
#line 4515 "Window.c"
}

static void
tuner_window_finalize (GObject * obj)
{
	TunerWindow * self;
#line 8 "../src/Widgets/Window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUNER_TYPE_WINDOW, TunerWindow);
#line 10 "../src/Widgets/Window.vala"
	_g_object_unref0 (self->priv->_settings);
#line 11 "../src/Widgets/Window.vala"
	_g_object_unref0 (self->priv->_stack);
#line 12 "../src/Widgets/Window.vala"
	_g_object_unref0 (self->priv->_player);
#line 14 "../src/Widgets/Window.vala"
	_g_object_unref0 (self->priv->_directory);
#line 15 "../src/Widgets/Window.vala"
	_g_object_unref0 (self->priv->headerbar);
#line 16 "../src/Widgets/Window.vala"
	_g_object_unref0 (self->priv->source_list);
#line 8 "../src/Widgets/Window.vala"
	G_OBJECT_CLASS (tuner_window_parent_class)->finalize (obj);
#line 4538 "Window.c"
}

static GType
tuner_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TunerWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tuner_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TunerWindow), 0, (GInstanceInitFunc) tuner_window_instance_init, NULL };
	GType tuner_window_type_id;
	tuner_window_type_id = g_type_register_static (gtk_application_window_get_type (), "TunerWindow", &g_define_type_info, 0);
	TunerWindow_private_offset = g_type_add_instance_private (tuner_window_type_id, sizeof (TunerWindowPrivate));
	return tuner_window_type_id;
}

GType
tuner_window_get_type (void)
{
	static volatile gsize tuner_window_type_id__once = 0;
	if (g_once_init_enter (&tuner_window_type_id__once)) {
		GType tuner_window_type_id;
		tuner_window_type_id = tuner_window_get_type_once ();
		g_once_init_leave (&tuner_window_type_id__once, tuner_window_type_id);
	}
	return tuner_window_type_id__once;
}

static void
_vala_tuner_window_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	TunerWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TUNER_TYPE_WINDOW, TunerWindow);
#line 8 "../src/Widgets/Window.vala"
	switch (property_id) {
#line 8 "../src/Widgets/Window.vala"
		case TUNER_WINDOW_SETTINGS_PROPERTY:
#line 8 "../src/Widgets/Window.vala"
		g_value_set_object (value, tuner_window_get_settings (self));
#line 8 "../src/Widgets/Window.vala"
		break;
#line 8 "../src/Widgets/Window.vala"
		case TUNER_WINDOW_STACK_PROPERTY:
#line 8 "../src/Widgets/Window.vala"
		g_value_set_object (value, tuner_window_get_stack (self));
#line 8 "../src/Widgets/Window.vala"
		break;
#line 8 "../src/Widgets/Window.vala"
		case TUNER_WINDOW_PLAYER_PROPERTY:
#line 8 "../src/Widgets/Window.vala"
		g_value_set_object (value, tuner_window_get_player (self));
#line 8 "../src/Widgets/Window.vala"
		break;
#line 4591 "Window.c"
		default:
#line 8 "../src/Widgets/Window.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 8 "../src/Widgets/Window.vala"
		break;
#line 4597 "Window.c"
	}
}

static void
_vala_tuner_window_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	TunerWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TUNER_TYPE_WINDOW, TunerWindow);
#line 8 "../src/Widgets/Window.vala"
	switch (property_id) {
#line 8 "../src/Widgets/Window.vala"
		case TUNER_WINDOW_SETTINGS_PROPERTY:
#line 8 "../src/Widgets/Window.vala"
		tuner_window_set_settings (self, g_value_get_object (value));
#line 8 "../src/Widgets/Window.vala"
		break;
#line 8 "../src/Widgets/Window.vala"
		case TUNER_WINDOW_STACK_PROPERTY:
#line 8 "../src/Widgets/Window.vala"
		tuner_window_set_stack (self, g_value_get_object (value));
#line 8 "../src/Widgets/Window.vala"
		break;
#line 8 "../src/Widgets/Window.vala"
		case TUNER_WINDOW_PLAYER_PROPERTY:
#line 8 "../src/Widgets/Window.vala"
		tuner_window_set_player (self, g_value_get_object (value));
#line 8 "../src/Widgets/Window.vala"
		break;
#line 4629 "Window.c"
		default:
#line 8 "../src/Widgets/Window.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 8 "../src/Widgets/Window.vala"
		break;
#line 4635 "Window.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

